unit UDlgOpPrmClusEM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UDlgBaseOperatorParameter, ComCtrls, StdCtrls, ExtCtrls,
  lmdstdcA;

type
  TDlgOpPrmClusEM = class(TDlgBaseOperatorParameter)
    spinNbClusters: TLMDSpinEdit;
    Label1: TLabel;
    spinMaxIteration: TLMDSpinEdit;
    Label2: TLabel;
    chkStandardize: TCheckBox;
    edRidgeCoef: TEdit;
    Label3: TLabel;
    TabSheet1: TTabSheet;
    chkShowAnova: TCheckBox;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   ApplyModifications(); override;
    procedure   SetParameters(); override;
  end;

var
  DlgOpPrmClusEM: TDlgOpPrmClusEM;

implementation

uses UCompClusteringEM;

{$R *.dfm}

{ TDlgOpPrmClusEM }

procedure TDlgOpPrmClusEM.ApplyModifications;
var prm: TOpPrmClusEM;
begin
 prm:= self.OpPrm as TOpPrmClusEM;
 TRY
 prm.NbClusters:= self.spinNbClusters.Value;
 prm.MaxIter:= self.spinMaxIteration.Value;
 prm.RidgeCorrection:= StrToFloat(self.edRidgeCoef.Text);
 prm.Standardization:= integer(self.chkStandardize.Checked);
 prm.ShowAnovaDetails:= self.chkShowAnova.Checked;
 EXCEPT
 END;
end;

procedure TDlgOpPrmClusEM.SetParameters;
var prm: TOpPrmClusEM;
begin
 prm:= self.OpPrm as TOpPrmClusEM;
 self.spinNbClusters.Value:= prm.NbClusters;
 self.spinMaxIteration.Value:= prm.MaxIter;
 self.edRidgeCoef.Text:= FloatToStr(prm.RidgeCorrection);
 self.chkStandardize.Checked:= boolean(prm.Standardization);
 self.chkShowAnova.Checked:= prm.ShowAnovaDetails;
end;

end.
