(****************************************************************************)
(* UCompSDKRelatedAnovaRndBlock.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(****************************************************************************)

{
@abstract(Anova pour K chantillons apparis - Blocs alatoires complets)
@author(Ricco)
@created(11/07/2008)

http://eric.univ-lyon2.fr/~ricco/cours/cours/Comp_Pop_Tests_Parametriques.pdf
pages 48  53

}

unit UCompSDKRelatedAnovaRndBlock;

interface

USES
    UCompDefinition,
    UOperatorDefinition,
    UCompSDKRelatedDefinition,
    UCalcStatDesKRelatedSamples,
    UDatasetDefinition;

TYPE
    //gnrateur
    TMLGenSDKRelatedAnova = class(TMLGenComp)
                               protected
                               procedure   GenCompInitializations(); override;
                               public
                               function    GetClassMLComponent: TClassMLComponent; override;
                               end;

    //composant
    TMLCompSDKRelatedAnova = class(TMLCompSDKRelated)
                                protected
                                function    getClassOperator: TClassOperator; override;
                                end;

    //oprateur
    TOpSDKRelatedAnova = class(TOpSDKRelated)
                            protected
                            function    getCalcInstance(lstAtts: TLstAttributes): TCalcSDKRelated; override;
                            function    getClassParameter: TClassOperatorParameter; override;
                            end;

    //paramtrage
    TOpPrmSDKRelatedAnova = class(TOpPrmSDKRelated)
                               end;

implementation

USES
    Classes;

{ TMLGenSDKRelatedAnova }

procedure TMLGenSDKRelatedAnova.GenCompInitializations;
begin
 FMLComp:= mlcDescriptiveStat;
end;

function TMLGenSDKRelatedAnova.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDKRelatedAnova;
end;

{ TMLCompSDKRelatedAnova }

function TMLCompSDKRelatedAnova.getClassOperator: TClassOperator;
begin
 result:= TOpSDKRelatedAnova;
end;

{ TOpSDKRelatedAnova }

function TOpSDKRelatedAnova.getCalcInstance(
  lstAtts: TLstAttributes): TCalcSDKRelated;
begin
 result:= TCalcSDKRelatedAnova.create(lstAtts);
end;

function TOpSDKRelatedAnova.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDKRelatedAnova;
end;

initialization
 RegisterClass(TMLGenSDKRelatedAnova);
end.
