(***********************************************************************)
(* UCompSDKRelatedFriedman.pas - Copyright (c) 2005 Ricco RAKOTOMALALA *)
(***********************************************************************)

{
@abstract(Q de Cochran pour les blocs alatoires complets)
@author(Ricco)
@created(21/08/2008)

Siegel, pages 170  174
}

unit UCompSDKRelatedQCochran;

interface

USES
    UCompDefinition,
    UOperatorDefinition,
    UCompSDKRelatedDefinition,
    UCalcStatDesKRelatedSamples,
    UDatasetDefinition;

TYPE
    //gnrateur
    TMLGenSDKRelatedQCochran = class(TMLGenComp)
                               protected
                               procedure   GenCompInitializations(); override;
                               public
                               function    GetClassMLComponent: TClassMLComponent; override;
                               end;

    //composant
    TMLCompSDKRelatedQCochran = class(TMLCompSDKRelated)
                                protected
                                function    getClassOperator: TClassOperator; override;
                                end;

    //oprateur
    TOpSDKRelatedQCochran = class(TOpSDKRelated)
                            protected
                            function    getCalcInstance(lstAtts: TLstAttributes): TCalcSDKRelated; override;
                            function    getClassParameter: TClassOperatorParameter; override;
                            end;

    //paramtrage
    TOpPrmSDKRelatedQCochran = class(TOpPrmSDKRelated)
                               end;     


implementation

USES
    Classes;

{ TMLGenSDKRelatedQCochran }

procedure TMLGenSDKRelatedQCochran.GenCompInitializations;
begin
 FMLComp:= mlcNonParametricStatistics;
end;

function TMLGenSDKRelatedQCochran.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDKRelatedQCochran; 
end;

{ TMLCompSDKRelatedQCochran }

function TMLCompSDKRelatedQCochran.getClassOperator: TClassOperator;
begin
 result:= TOpSDKRelatedQCochran; 
end;

{ TOpSDKRelatedQCochran }

function TOpSDKRelatedQCochran.getCalcInstance(lstAtts: TLstAttributes): TCalcSDKRelated;
begin
 result:= TCalcSDKRelatedQCochran.create(lstAtts);  
end;

function TOpSDKRelatedQCochran.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDKRelatedQCochran; 
end;

initialization
 RegisterClass(TMLGenSDKRelatedQCochran);
end.
