(*************************************************************************)
(* UCompSDPartialCorrelation.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(*************************************************************************)

{
@abstract(Corrlation semi-partielle)
@author(Ricco)
@created(12/06/2008)

Calcul des corrlation partielles.
Voir rf --> http://eric.univ-lyon2.fr/~ricco/cours/cours/Analyse_de_Correlation.pdf 

}
unit UCompSDPartialCorrelation;

interface

USES
    UCompSDSemiPartialCorrelation,
    Forms,Classes,
    IniFiles, Contnrs,
    UCompDefinition,
    UCompSDDefinition,
    UOperatorDefinition,
    UDatasetExamples,UDatasetImplementation,UDatasetDefinition;

TYPE
    //gnrateur
    TMLGenCompSDPartialCorrelation = class(TMLGenComp)
    protected
    procedure   GenCompInitializations(); override;
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    //
    TMLCompSDPartialCorrelation = class(TMLCompSDSemiPartialCorrelation)
    protected
    function    getClassOperator: TClassOperator; override;
    function    GetLogResultDescription(): string; override;
    end;

    //
    TOpSDPartialCorrelation = class(TOpSDSemiPartialCorrelation)
    protected
    function    getClassParameter: TClassOperatorParameter; override;
    function    getCorrelationTitleHtml(): string; override;
    procedure   computeTargetResiduals(examples: TExamples); override;
    end;

    //
    TOpPrmSDPartialCorrelation = class(TOpPrmSDSemiPartialCorrelation)
    end;

implementation

USES
    Sysutils;

{ TMLGenCompSDPartialCorrelation }

procedure TMLGenCompSDPartialCorrelation.GenCompInitializations;
begin
  FMLComp:= mlcDescriptiveStat;
end;

function TMLGenCompSDPartialCorrelation.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDPartialCorrelation;
end;

{ TMLCompSDPartialCorrelation }

function TMLCompSDPartialCorrelation.getClassOperator: TClassOperator;
begin
 result:= TOpSDPartialCorrelation;
end;

function TMLCompSDPartialCorrelation.GetLogResultDescription: string;
begin
 result:= format('[PARTIAL Correlation] %d correlations computed',[(Operator as TOpSDPartialCorrelation).LstStat.Count]);
end;

{ TOpSDPartialCorrelation }

procedure TOpSDPartialCorrelation.computeTargetResiduals(
  examples: TExamples);
var j: integer;
begin
 FResTarget.Clear();
 FResTarget.OwnsObjects:= true;
 for j:= 0 to pred(FLstTarget.Count) do
  FResTarget.Add(self.computeResidual(examples,FLstTarget.Items[j] as TAttribute));
end;

function TOpSDPartialCorrelation.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDPartialCorrelation;
end;

function TOpSDPartialCorrelation.getCorrelationTitleHtml: string;
begin
 result:= '<H4>Partial correlation</H4>';
end;

initialization
 RegisterClass(TMLGenCompSDPartialCorrelation);
end.
