(***************************************************************)
(* UCompSDBoxMTest.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(***************************************************************)

{
@abstract(Test de comparaison de matrices de variance covariance)
@author(Ricco)
@created(16/07/2008)

On peut le voir aussi comme une version mutlivarie du test de Bartlett

}

unit UCompSDBoxMTest;

interface

USES
    Forms,
    UCompDefinition,
    UCompManageDataset,
    UCalcStatDes,
    UCalcStatDesManova,
    UCompSDDefinition,
    UOperatorDefinition,
    UCompSDManovaDefinition;

TYPE
    //gnrateur de composant
    TMLGenCompBoxM = class(TMLGenComp)
    protected
    procedure   GenCompInitializations(); override;
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    //composant
    TMLCompSDBoxM = class(TMLCompSDManova)
    protected
    function    getClassOperator: TClassOperator; override;
    end;

    //oprateur
    TOpSDBoxM = class(TOpSDManova)
    protected
    //rcuprer la classe de calcul individuelle -- surcharge obligatoire
    function getClassStat(): TClassCalcSDCondMultivariate; override;
    //rcuprer la classe de liste de rsultats -- surcharge obligatoire
    function getClassLstStat(): TClassLstCalcSDCondManova; override;
    //paramtrage
    function    getClassParameter: TClassOperatorParameter; override;
    end;

    //paramtrage
    TOpPrmSDBoxM = class(TOpPrmSDManova)
    end;

implementation

USES
    Classes;

{ TMLGenCompBoxM }

procedure TMLGenCompBoxM.GenCompInitializations;
begin
 FMLComp:= mlcDescriptiveStat;
end;

function TMLGenCompBoxM.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDBoxM;
end;

{ TMLCompSDBoxM }

function TMLCompSDBoxM.getClassOperator: TClassOperator;
begin
 result:= TOpSDBoxM;
end;

{ TOpSDBoxM }

function TOpSDBoxM.getClassLstStat: TClassLstCalcSDCondManova;
begin
 result:= TLstCalcSDCondBoxM;
end;

function TOpSDBoxM.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDBoxM;
end;

function TOpSDBoxM.getClassStat: TClassCalcSDCondMultivariate;
begin
 result:= TCalcSDCondBoxM;
end;

initialization
 RegisterClass(TMLGenCompBoxM);
end.
