(******************************************************************)
(* UCompSDT2Hotelling.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(******************************************************************)

{
@abstract(T2 de Hotelling - Homoscdasticit)
@author(Ricco)
@created(16/07/2008)

Comparaison de 2 moyennes, Multivari, Homoscdasticit

}

unit UCompSDT2Hotelling;

interface

USES
    Forms,
    UCompDefinition,
    UCompManageDataset,
    UCalcStatDes,
    UCalcStatDesManova,
    UCompSDDefinition,
    UOperatorDefinition,
    UCompSDManovaDefinition;

TYPE
    //gnrateur de composant
    TMLGenCompT2 = class(TMLGenComp)
                       protected
                       procedure   GenCompInitializations(); override;
                       public
                       function    GetClassMLComponent: TClassMLComponent; override;
                       end;

    //composant
    TMLCompSDT2 = class(TMLCompSDDefManova)
                      protected
                      function    getClassOperator: TClassOperator; override;
                      end;

    //oprateur
    TOpSDT2 = class(TOpSDDefManova)
                  protected
                  //rcuprer la classe de calcul individuelle -- surcharge obligatoire
                  function getClassStat(): TClassCalcSDCondMultivariate; override;
                  //rcuprer la classe de liste de rsultats -- surcharge obligatoire
                  function getClassLstStat(): TClassLstCalcSDCondManova; override;
                  //paramtrage
                  function    getClassParameter: TClassOperatorParameter; override;
                  //vrifier que tous les INPUT sont binaires
                  function    CheckAttributes(): boolean; override;
                  end;

    //paramtrage
    TOpPrmSDT2 = class(TOpPrmSDDefManova)
                     end;

implementation

USES
    Classes, UDatasetImplementation;

{ TMLGenCompT2 }

procedure TMLGenCompT2.GenCompInitializations;
begin
 FMLComp:= mlcDescriptiveStat;
end;

function TMLGenCompT2.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDT2;
end;

{ TMLCompSDT2 }

function TMLCompSDT2.getClassOperator: TClassOperator;
begin
 result:= TOpSDT2;
end;

{ TOpSDT2 }

function TOpSDT2.CheckAttributes: boolean;
var ok: boolean;
    j: integer;
begin
 ok:= inherited CheckAttributes();
 //et tous binaires les INPUT
 for j:= 0 to pred(self.WorkData.LstAtts[asInput].Count) do
  ok:= ok and (self.WorkData.LstAtts[asInput].Attribute[j].nbValues = 2);
 result:= ok;
end;

function TOpSDT2.getClassLstStat: TClassLstCalcSDCondManova;
begin
 result:= TLstCalcSDCondT2;
end;

function TOpSDT2.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDT2;
end;

function TOpSDT2.getClassStat: TClassCalcSDCondMultivariate;
begin
 result:= TCalcSDCondT2;
end;

initialization
 RegisterClass(TMLGenCompT2);
end.
