(*********************************************************************************)
(* UCompSDT2HotellingHeteroscedastic.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(*********************************************************************************)

{
@abstract(T2 de Hotelling - Htroscdasticit)
@author(Ricco)
@created(16/07/2008)

Comparaison de 2 moyennes, Multivari, Htroscdasticit

}

unit UCompSDT2HotellingHeteroscedastic;

interface

USES
    UCompDefinition,
    UOperatorDefinition,
    UCompSDManovaDefinition,
    UCompSDT2Hotelling,
    UCalcStatDesManova;

TYPE
    //gnrateur de composant
    TMLGenCompT2Heteroscedastic = class(TMLGenComp)
    protected
    procedure   GenCompInitializations(); override;
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    //composant
    TMLCompSDT2Heteroscedastic = class(TMLCompSDT2)
    protected
    function    getClassOperator: TClassOperator; override;
    end;

    //oprateur
    TOpSDT2Heteroscedastic = class(TOpSDT2)
    protected
    //rcuprer la classe de calcul individuelle -- surcharge obligatoire
    function getClassStat(): TClassCalcSDCondMultivariate; override;
    //rcuprer la classe de liste de rsultats -- surcharge obligatoire
    function getClassLstStat(): TClassLstCalcSDCondManova; override;
    //paramtrage
    function getClassParameter: TClassOperatorParameter; override;
    end;

    //paramtrage
    TOpPrmSDT2Heteroscedastic = class(TOpPrmSDT2)
    end;


implementation

USES
    Classes;

{ TMLGenCompT2Heteroscedastic }

procedure TMLGenCompT2Heteroscedastic.GenCompInitializations;
begin
 FMLComp:= mlcDescriptiveStat;
end;

function TMLGenCompT2Heteroscedastic.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDT2Heteroscedastic;
end;

{ TMLCompSDT2Heteroscedastic }

function TMLCompSDT2Heteroscedastic.getClassOperator: TClassOperator;
begin
 result:= TOpSDT2Heteroscedastic;
end;

{ TOpSDT2Heteroscedastic }

function TOpSDT2Heteroscedastic.getClassLstStat: TClassLstCalcSDCondManova;
begin
 result:= TLstCalcSDCondT2Heteroscedastic;
end;

function TOpSDT2Heteroscedastic.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDT2Heteroscedastic;
end;

function TOpSDT2Heteroscedastic.getClassStat: TClassCalcSDCondMultivariate;
begin
 result:= TCalcSDCondT2Heteroscedastic;
end;

initialization
 RegisterClass(TMLGenCompT2Heteroscedastic);
end.
