(*****************************************************************)
(* UCompSDMedianTest.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(*****************************************************************)

{
@abstract(Comparaison de populations, mais avec une approche non paramtrique, test de la mdiane)
@author(Ricco)
@created(17/08/2008)

}
unit UCompSDMedianTest;

interface

USES
        Forms, Classes,
        UCompDefinition,
        UCompManageDataset,
        UCompSDDefinition,
        UCompSDCondDescDefinition,
        UOperatorDefinition,
        UDatasetDefinition,
        UDatasetImplementation,
        UDatasetExamples,
        UCalcStatDesConditionnalDesc,
        UCalcStatDesRankForNonParametricStat;

TYPE

        {gnrateur de composant one-way anova}
        TMLGenCompSDMedian = class(TMLGenCompNonParOneWay)
        public
        function    GetClassMLComponent: TClassMLComponent; override;
        end;

        {le composant one anova}
        TMLCompSDMedian = class(TMLCompSD)
        protected
        function    getClassOperator: TClassOperator; override;
        end;

        {oprateur de calcul }
        TOpSDMedian = class(TOpSDCondDescDefinition)
        protected
        function    getClassStat(): TClassCalcSDCondDesc; override;
        function    getClassLstStat(): TClassLstCalcStatDesCond; override;
        function    getClassParameter: TClassOperatorParameter; override;
        end;

        {paramtrage de l'oprateur de calcul}
        TOpPrmSDMedian = class(TOpPrmSDCondDescDefinition)
        end;

        {classe de calcul statistique}
        TCalcSDNonParamMedian = class(TCalcSDNonParamCondDescScores)
        protected
        function    getClassRankScoreComputation(): TClassRankComputed; override;
        end;

        {classe de calcul des scores}
        TScoresMedian = class(TRankComputed)
        protected
        procedure   computeScoresFromRank(lstSorted: TExamples); override;
        end;


implementation

{ TMLGenCompSDMedian }

function TMLGenCompSDMedian.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDMedian;
end;

{ TMLCompSDMedian }

function TMLCompSDMedian.getClassOperator: TClassOperator;
begin
 result:= TOpSDMedian;
end;

{ TOpSDMedian }

function TOpSDMedian.getClassLstStat: TClassLstCalcStatDesCond;
begin
 result:= TLstCalcStatDesCondScores; 
end;

function TOpSDMedian.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDMedian;
end;

function TOpSDMedian.getClassStat: TClassCalcSDCondDesc;
begin
 result:= TCalcSDNonParamMedian;
end;

{ TCalcSDNonParamMedian }

function TCalcSDNonParamMedian.getClassRankScoreComputation: TClassRankComputed;
begin
 result:= TScoresMedian;
end;

{ TScoresMedian }

procedure TScoresMedian.computeScoresFromRank(lstSorted: TExamples);
var seuil: double;
    i, example: integer;
begin
 //seuil
 seuil:= (1.0 + lstSorted.Size) / 2.0;
 for i:= 1 to lstSorted.Size do
  begin
   example:= lstSorted.Number[i];
   if( FRankValue[example] > seuil)
    then FRankValue[example]:= 1.0
    else FRankValue[example]:= 0.0;
  end;
end;

initialization
 RegisterClass(TMLGenCompSDMedian);
end.
