(******************************************************************)
(* UCompSDOneWayAnova.pas - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(******************************************************************)

{
@abstract(Analyse de variance  1 facteur)
@author(Ricco)
@created(12/01/2004)
Calcule des stats descriptives sur une var continue conditionnellement aux valeurs prises par une
variable discrte.
!!! Ici on peut enchaner plusieurs var. continues, il seront rfrences dans la
srie des target, les variables discrtes sont dans la liste Input.
On a bien une sorte de schma de rgression simple avec une exogne qualitative.
Pas de nouvelles variables gnres sur ce composant.
}
unit UCompSDOneWayAnova;

interface

USES
        Forms,
        UCompDefinition,
        UCompManageDataset,
        UCompSDDefinition,
        UOperatorDefinition,
        UDatasetDefinition,
        UDatasetImplementation,
        UCompSDCondDescDefinition,
        UCalcStatDesConditionnalDesc;        

TYPE
        {gnrateur de composant one-way anova}
        TMLGenCompSDOneAnova = class(TMLGenComp)
                               protected
                               procedure   GenCompInitializations(); override;
                               public
                               function    GetClassMLComponent: TClassMLComponent; override;        
                               end;

        {le composant one anova}
        TMLCompSDOneAnova = class(TMLCompSDCondDescDefinition)
                            protected
                            function    getClassOperator: TClassOperator; override;
                            end;

        {oprateur de calcul }
        TOpSDOneAnova = class(TOpSDCondDescDefinition)
                        protected
                        function    getClassStat(): TClassCalcSDCondDesc; override;
                        function    getClassLstStat(): TClassLstCalcStatDesCond; override;
                        function    getClassParameter: TClassOperatorParameter; override;
                        end;

        {paramtrage de l'oprateur de calcul}
        TOpPrmSDOneAnova = class(TOpPrmSDCondDescDefinition)
                           end;

implementation

USES
        Classes, SysUtils,
        UCalcStatDes, UConstConfiguration;

{ TMLGenCompSDOneAnova }

procedure TMLGenCompSDOneAnova.GenCompInitializations;
begin
 FMLComp:= mlcDescriptiveStat;
end;

function TMLGenCompSDOneAnova.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDOneAnova; 
end;

{ TMLCompSDOneAnova }

function TMLCompSDOneAnova.getClassOperator: TClassOperator;
begin
 result:= TOpSDOneAnova;
end;

{ TOpSDOneAnova }

function TOpSDOneAnova.getClassLstStat: TClassLstCalcStatDesCond;
begin
 result:= TLstStatDesCondANOVA; 
end;

function TOpSDOneAnova.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDOneAnova;  
end;

function TOpSDOneAnova.getClassStat: TClassCalcSDCondDesc;
begin
 result:= TCalcSDCondDescAnova; 
end;

initialization
 RegisterClass(TMLGenCompSDOneAnova);
end.
