(*****************************************************************)
(* UCompSDWelchAnova.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(*****************************************************************)

{
@abstract(Analyse de variance  1 facteur - Variances ingales)
@author(Ricco)
@created(13/07/2008)

Welch Variance Weighted Anova
Voir --> http://eric.univ-lyon2.fr/~ricco/cours/cours/Comp_Pop_Tests_Parametriques.pdf
pages 21 et 22  

}

unit UCompSDWelchAnova;

interface

USES
        Forms,
        UCompDefinition,
        UCompManageDataset,
        UCompSDDefinition,
        UOperatorDefinition,
        UDatasetDefinition,
        UDatasetImplementation,
        UCompSDCondDescDefinition,
        UCalcStatDesConditionnalDesc;        

TYPE
        {gnrateur de composant one-way anova}
        TMLGenCompSDWelchAnova = class(TMLGenComp)
                               protected
                               procedure   GenCompInitializations(); override;
                               public
                               function    GetClassMLComponent: TClassMLComponent; override;
                               end;

        {le composant one anova}
        TMLCompSDWelchAnova = class(TMLCompSDCondDescDefinition)
                            protected
                            function    getClassOperator: TClassOperator; override;
                            end;

        {oprateur de calcul }
        TOpSDWelchAnova = class(TOpSDCondDescDefinition)
                        protected
                        function    getClassStat(): TClassCalcSDCondDesc; override;
                        function    getClassLstStat(): TClassLstCalcStatDesCond; override;
                        function    getClassParameter: TClassOperatorParameter; override;
                        end;

        {paramtrage de l'oprateur de calcul}
        TOpPrmSDWelchAnova = class(TOpPrmSDCondDescDefinition)
                           end;


implementation

USES
        Classes, SysUtils,
        UCalcStatDes, UConstConfiguration;

{ TMLGenCompSDWelchAnova }

procedure TMLGenCompSDWelchAnova.GenCompInitializations;
begin
 FMLComp:= mlcDescriptiveStat;
end;

function TMLGenCompSDWelchAnova.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDWelchAnova;
end;

{ TMLCompSDWelchAnova }

function TMLCompSDWelchAnova.getClassOperator: TClassOperator;
begin
 result:= TOpSDWelchAnova;
end;

{ TOpSDWelchAnova }

function TOpSDWelchAnova.getClassLstStat: TClassLstCalcStatDesCond;
begin
 result:= TLstStatDesCondWelchANOVA;
end;

function TOpSDWelchAnova.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDWelchAnova;
end;

function TOpSDWelchAnova.getClassStat: TClassCalcSDCondDesc;
begin
 result:= TCalcSDCondDescWelchAnova;
end;

initialization
 RegisterClass(TMLGenCompSDWelchAnova);
end.
