(************************************************************************)
(* UCompSDOrdinalAssocGamma.pas - Copyright (c) 2007 Ricco RAKOTOMALALA *)
(************************************************************************)

{
@abstract(Composant association sur variables catgorielles)
@author(Ricco)
@created(28/09/2007)

Gamma de Goodman et Kruskal

}
unit UCompSDOrdinalAssocGamma;

interface

USES
    UCompDefinition,
    UOperatorDefinition,
    UCompSDOrdinalAssociation,
    UCalcStatDesOrdinalAssociation;

TYPE
    {Gnrateur de univariate stat cont desc}
    TMLGenCompSDOrdinalAssocGamma = class(TMLGenCompSDOrdinalAssoc)
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    {le composant}
    TMLCompSDOrdinalAssocGamma = class(TMLCompSDOrdinalAssoc)
    protected
    function    getClassOperator: TClassOperator; override;
    end;

    {l'oprateur associ}
    TOpSDOrdinalAssocGamma = class(TOpSDOrdinalAssoc)
    protected
    function    getClassComputation(): TClassCalcSDOrdinalAssoc; override;
    function    getMethodDescription(): string; override;
    end;

implementation

USES
    Classes;

{ TMLGenCompSDOrdinalAssocGamma }

function TMLGenCompSDOrdinalAssocGamma.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDOrdinalAssocGamma; 
end;

{ TMLCompSDOrdinalAssocGamma }

function TMLCompSDOrdinalAssocGamma.getClassOperator: TClassOperator;
begin
 result:= TOpSDOrdinalAssocGamma; 
end;

{ TOpSDOrdinalAssocGamma }


{ TOpSDOrdinalAssocGamma }

function TOpSDOrdinalAssocGamma.getClassComputation: TClassCalcSDOrdinalAssoc;
begin
 result:= TOrdinalAssocGamma;
end;

function TOpSDOrdinalAssocGamma.getMethodDescription: string;
begin
 result:= 'Goodman & Kruskal''s Gamma';
end;

initialization
 RegisterClass(TMLGenCompSDOrdinalAssocGamma);
end.
