(************************************************************************)
(* UCompSDOrdinalAssocTau_c.pas - Copyright (c) 2007 Ricco RAKOTOMALALA *)
(************************************************************************)

{
@abstract(Composant association sur variables catgorielles)
@author(Ricco)
@created(28/09/2007)

d de Sommers

}

unit UCompSDOrdinalAssocSommers;

interface

USES
    Forms,
    UCompDefinition,
    UOperatorDefinition,
    UCompSDOrdinalAssociation,
    UCalcStatDesOrdinalAssociation;

TYPE
    {Gnrateur de univariate stat cont desc}
    TMLGenCompSDOrdinalAssocSommers = class(TMLGenCompSDOrdinalAssoc)
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    {le composant}
    TMLCompSDOrdinalAssocSommers = class(TMLCompSDOrdinalAssoc)
    protected
    function    getClassOperator: TClassOperator; override;
    end;

    {l'oprateur associ}
    TOpSDOrdinalAssocSommers = class(TOpSDOrdinalAssoc)
    protected
    function    getClassComputation(): TClassCalcSDOrdinalAssoc; override;
    function    getMethodDescription(): string; override;
    function    getClassParameter: TClassOperatorParameter; override;
    procedure   RebuildStatDes(); override;
    function    CheckAttributes(): boolean; override;
    end;

    {paramtrage}
    TOpPrmSDOrdinalAssocSommers = class(TOpPrmSDOrdinalAssoc)
    protected
    function    CreateDlgParameters(): TForm; override;
    procedure   SetDefaultParameters(); override;    
    end;

implementation

USES
    Classes, UDlgOpPrmOrdinalAssociationSommers, UDlgBaseOperatorParameter,
    UDatasetDefinition,
    UDatasetImplementation, UCalcStructOrdinalAssociation,
    Contnrs;

{ TOpPrmSDOrdinalAssocSommers }

function TOpPrmSDOrdinalAssocSommers.CreateDlgParameters: TForm;
begin
 result:= TdlgOpPrmSDOrdinalAssociationSommers.CreateFromOpPrm(self);
end;

procedure TOpPrmSDOrdinalAssocSommers.SetDefaultParameters;
begin
 inherited;
 InputList:= 0;//toujours, c'est immuable...
end;

{ TMLGenCompSDOrdinalAssocSommers }

function TMLGenCompSDOrdinalAssocSommers.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDOrdinalAssocSommers;
end;

{ TMLCompSDOrdinalAssocSommers }

function TMLCompSDOrdinalAssocSommers.getClassOperator: TClassOperator;
begin
 result:= TOpSDOrdinalAssocSommers; 
end;

{ TOpSDOrdinalAssocSommers }

function TOpSDOrdinalAssocSommers.CheckAttributes: boolean;
begin
 result:= (self.WorkData.LstAtts[asTarget].Count > 0) and (self.WorkData.LstAtts[asTarget].isAllCategory(caContinue));
 result:= result and (self.WorkData.LstAtts[asInput].Count > 0) and (self.WorkData.LstAtts[asInput].isAllCategory(caContinue));
end;

function TOpSDOrdinalAssocSommers.getClassComputation: TClassCalcSDOrdinalAssoc;
begin
 result:= TOrdinalAssocSommers;
end;

function TOpSDOrdinalAssocSommers.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmSDOrdinalAssocSommers; 
end;

function TOpSDOrdinalAssocSommers.getMethodDescription: string;
begin
 result:= 'Sommers'' d';
end;

procedure TOpSDOrdinalAssocSommers.RebuildStatDes;
var vecI, vecJ: TVecDistinctValues;
    i,j: integer;
begin
 //supprimer les listes internes de valeurs uniques
 self.destroyLstVec();
 //reconstruire
 FLstVecInput:= TObjectList.Create(TRUE);
 for j:= 0 to pred(workdata.LstAtts[asInput].Count) do
  FLstVecInput.Add(TVecDistinctValues.create(workdata.LstAtts[asInput].Attribute[j]));
 //pour les targets
 FLstVecTarget:= TObjectList.Create(TRUE);
 for j:= 0 to pred(workdata.LstAtts[asTarget].Count) do
  FLstVecTarget.Add(TVecDistinctValues.create(workdata.LstAtts[asTarget].Attribute[j]));
 //ok, on peut construire les stats  produire maintenant
 for i:= 0 to pred(FLstVecTarget.Count) do
  begin
   vecI:= FLstVecTarget[i] as TVecDistinctValues;
   for j:= 0 to pred(FLstVecInput.Count) do
    begin
     vecJ:= FLstVecInput[j] as TVecDistinctValues;
     if (vecI <> vecJ) then FLstStat.AddStat(getClassComputation().create(vecI,vecJ));
    end;
  end;
end;

initialization
 RegisterClass(TMLGenCompSDOrdinalAssocSommers);
end.
