(************************************************************************)
(* UCompSDOrdinalAssocTau_b.pas - Copyright (c) 2007 Ricco RAKOTOMALALA *)
(************************************************************************)

{
@abstract(Composant association sur variables catgorielles)
@author(Ricco)
@created(28/09/2007)

Tau-b de Kendall

}

unit UCompSDOrdinalAssocTau_b;

interface

USES
    UCompDefinition,
    UOperatorDefinition,
    UCompSDOrdinalAssociation,
    UCalcStatDesOrdinalAssociation;

TYPE
    {Gnrateur de univariate stat cont desc}
    TMLGenCompSDOrdinalAssocTau_b = class(TMLGenCompSDOrdinalAssoc)
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    {le composant}
    TMLCompSDOrdinalAssocTau_b = class(TMLCompSDOrdinalAssoc)
    protected
    function    getClassOperator: TClassOperator; override;
    end;

    {l'oprateur associ}
    TOpSDOrdinalAssocTau_b = class(TOpSDOrdinalAssoc)
    protected
    function    getClassComputation(): TClassCalcSDOrdinalAssoc; override;
    function    getMethodDescription(): string; override;
    end;

implementation

USES
    Classes;

{ TMLGenCompSDOrdinalAssocTau_b }

function TMLGenCompSDOrdinalAssocTau_b.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDOrdinalAssocTau_b; 
end;

{ TMLCompSDOrdinalAssocTau_b }

function TMLCompSDOrdinalAssocTau_b.getClassOperator: TClassOperator;
begin
 result:= TOpSDOrdinalAssocTau_b;
end;

{ TOpSDOrdinalAssocTau_b }

function TOpSDOrdinalAssocTau_b.getClassComputation: TClassCalcSDOrdinalAssoc;
begin
 result:= TOrdinalAssocTau_b;
end;

function TOpSDOrdinalAssocTau_b.getMethodDescription: string;
begin
 result:= 'Kendall''s Tau-b';
end;

initialization
 RegisterClass(TMLGenCompSDOrdinalAssocTau_b);
end.
