(************************************************************************)
(* UCompSDOrdinalAssocTau_c.pas - Copyright (c) 2007 Ricco RAKOTOMALALA *)
(************************************************************************)

{
@abstract(Composant association sur variables catgorielles)
@author(Ricco)
@created(28/09/2007)

Tau-c de Kendall

}

unit UCompSDOrdinalAssocTau_c;

interface

USES
    UCompDefinition,
    UOperatorDefinition,
    UCompSDOrdinalAssociation,
    UCalcStatDesOrdinalAssociation;

TYPE
    {Gnrateur de univariate stat cont desc}
    TMLGenCompSDOrdinalAssocTau_c = class(TMLGenCompSDOrdinalAssoc)
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    {le composant}
    TMLCompSDOrdinalAssocTau_c = class(TMLCompSDOrdinalAssoc)
    protected
    function    getClassOperator: TClassOperator; override;
    end;

    {l'oprateur associ}
    TOpSDOrdinalAssocTau_c = class(TOpSDOrdinalAssoc)
    protected
    function    getClassComputation(): TClassCalcSDOrdinalAssoc; override;
    function    getMethodDescription(): string; override;
    end;


implementation

USES
    Classes;

{ TMLGenCompSDOrdinalAssocTau_c }

function TMLGenCompSDOrdinalAssocTau_c.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompSDOrdinalAssocTau_c;
end;

{ TMLCompSDOrdinalAssocTau_c }

function TMLCompSDOrdinalAssocTau_c.getClassOperator: TClassOperator;
begin
 result:= TOpSDOrdinalAssocTau_c;
end;

{ TOpSDOrdinalAssocTau_c }

function TOpSDOrdinalAssocTau_c.getClassComputation: TClassCalcSDOrdinalAssoc;
begin
 result:= TOrdinalAssocTau_c;
end;

function TOpSDOrdinalAssocTau_c.getMethodDescription: string;
begin
 result:= 'Kendall''s Tau-c';
end;

initialization
 RegisterClass(TMLGenCompSDOrdinalAssocTau_c);
end.
