(************************************************************)
(* UDlgOpPrmPCA.pas - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(************************************************************)

unit UDlgOpPrmPCA;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UDlgBaseOperatorParameter, StdCtrls, CheckLst, ComCtrls,
  ExtCtrls, lmdstdcA;

type
  TDlgOpPrmPCA = class(TDlgBaseOperatorParameter)
    rgAxis: TRadioGroup;
    spinAxis: TLMDSpinEdit;
    chkCos2: TCheckBox;
    chkStandardize: TCheckBox;
    chkBartlett: TCheckBox;
    chkShowCorr: TCheckBox;
    chkRepCorr: TCheckBox;
    chkSortVariables: TCheckBox;
    procedure rgAxisClick(Sender: TObject);
    procedure chkStandardizeClick(Sender: TObject);
  private
  public
  procedure   ApplyModifications(); override;
  procedure   SetParameters(); override;  
  end;

var
  DlgOpPrmPCA: TDlgOpPrmPCA;

implementation

uses UCompFactAnalysisPCA;

{$R *.dfm}

procedure TDlgOpPrmPCA.ApplyModifications;
var prm: TOpPrmFactPCA;
begin
 prm:= OpPrm as TOpPrmFactPCA;
 if (rgAxis.ItemIndex=0)
  then prm.NbAxisCreated:= -1
  else prm.NbAxisCreated:= spinAxis.Value;
 prm.Cos2Ctr:= self.chkCos2.Checked;
 prm.Standardize:= self.chkStandardize.Checked;
 prm.BartlettKmo:= self.chkBartlett.Checked;
 prm.ShowCorr:= self.chkShowCorr.Checked;
 prm.ShowRepCorr:= self.chkRepCorr.Checked;
 prm.SortVarOnLoadings:= self.chkSortVariables.Checked;
end;

procedure TDlgOpPrmPCA.rgAxisClick(Sender: TObject);
begin
 if (rgAxis.ItemIndex=0)
  then spinAxis.Enabled:= FALSE
  else spinAxis.Enabled:= TRUE;
end;

procedure TDlgOpPrmPCA.SetParameters;
var prm: TOpPrmFactPCA;
begin
 prm:= OpPrm as TOpPrmFactPCA;
 if (prm.NbAxisCreated<0)
  then rgAxis.ItemIndex:= 0
  else
   begin
    rgAxis.ItemIndex:= 1;
    spinAxis.Value:= prm.NbAxisCreated;
   end;
 self.chkCos2.Checked:= prm.Cos2Ctr;
 self.chkStandardize.Checked:= prm.Standardize;
 self.chkBartlett.Checked:= prm.BartlettKmo;
 self.chkShowCorr.Checked:= prm.ShowCorr;
 self.chkRepCorr.Checked:= prm.ShowRepCorr;
 self.chkSortVariables.Checked:= prm.SortVarOnLoadings;
end;

procedure TDlgOpPrmPCA.chkStandardizeClick(Sender: TObject);
begin
 if (self.chkStandardize.Checked = false)
  then
   begin
    self.chkBartlett.Checked:= false;
    self.chkBartlett.Enabled:= false;
    self.chkShowCorr.Checked:= false;
    self.chkShowCorr.Enabled:= false;
   end
  else
   begin
    self.chkBartlett.Enabled:= true;
    self.chkShowCorr.Enabled:= true;
   end;
end;

end.
