unit UFrmOpViewFactPCA;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart;

type
  TFrmOpViewFactPCA = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chartScreePlot: TChart;
    Series1: TLineSeries;
    chartPropVariance: TChart;
    LineSeries2: TLineSeries;
    Splitter1: TSplitter;
    N1: TMenuItem;
    Screeplot1: TMenuItem;
    Cumulativevariance1: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure Screeplot1Click(Sender: TObject);
    procedure Cumulativevariance1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
    function    getAdditionalInfoForReport(): string; override;
  end;

var
  FrmOpViewFactPCA: TFrmOpViewFactPCA;

implementation

uses UCompFactAnalysisPCA;

{$R *.dfm}

{ TFrmOpViewFactPCA }

function TFrmOpViewFactPCA.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Principal Component Analysis</H3>';
 s:= s + self.addChartToReport(chartScreePlot,400,1);
 s:= s + self.addChartToReport(chartPropVariance,400,2);
 result:= s;
end;

procedure TFrmOpViewFactPCA.PrepareView;
var s1,s2: TLineSeries;
    i: integer;
    op: TOpFactPCA;
    cumul: double;
begin
 //le rapport html
 inherited;
 //le graphique
 cumul:= 0;
 op:= self.Operator as TOpFactPCA;
 s1:= self.ChartScreePlot.Series[0] as TLineSeries;
 s1.Clear();
 s2:= self.ChartPropVariance.Series[0] as TLineSeries;
 s2.Clear();
 s2.AddXY(0,cumul);
 for i:= 1 to op.DimAnalysis do
  begin
   s1.AddXY(i,op.EigVal[i]);
   cumul:= cumul + op.EigVal[i];
   //s2.AddXY(i,cumul/(1.0*op.DimAnalysis));
   //new - 09/09/2012 - on utilisa la trace plutt - pour une ACP a revient au mme
   s2.AddXY(i,cumul/(1.0*op.Trace));
  end;
 //activer le rapport toujours
 self.pgctrlFond.ActivePageIndex:= 0;
end;

procedure TFrmOpViewFactPCA.FormResize(Sender: TObject);
begin
 self.chartPropVariance.Width:= self.ClientWidth div 2;
end;

procedure TFrmOpViewFactPCA.Screeplot1Click(Sender: TObject);
begin
 self.chartScreePlot.CopyToClipboardMetafile(false);
end;

procedure TFrmOpViewFactPCA.Cumulativevariance1Click(Sender: TObject);
begin
 self.chartPropVariance.CopyToClipboardMetafile(false);
end;

end.
