unit UFrmOpViewFactAnalysisAFC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart, StdCtrls, UCompFactAnalysisAFC;

type
  TFrmOpViewFactAnalysisAFC = class(TFrmBaseOperator)
    TabChart: TTabSheet;
    panelChart: TPanel;
    cmbX2: TComboBox;
    cmbX1: TComboBox;
    chart: TChart;
    SerieLigne: TPointSeries;
    SerieColonne: TPointSeries;
    actCopyChart: TAction;
    actZoomIn: TAction;
    actZoomOut: TAction;
    N1: TMenuItem;
    mnCopyChart: TMenuItem;
    mnZoomIn: TMenuItem;
    mnZoomOut: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    mnJitter: TMenuItem;
    procedure cmbX1Change(Sender: TObject);
    procedure pgctrlFondChange(Sender: TObject);
    procedure actCopyChartExecute(Sender: TObject);
    procedure actZoomInExecute(Sender: TObject);
    procedure actZoomOutExecute(Sender: TObject);
    procedure mnJitterClick(Sender: TObject);
  private
    { Dclarations prives }
    //new - 31/10/2012 - le min et max en abcisse et ordonne
    xMin, xMax, yMin, yMax: double;
    //rafrachir la vue
    procedure  refreshView(jitter: boolean = false);
    //insrer la valeur
    procedure  setValue(points: TPointSeries; x,y: double; desc: string; jitter: boolean = false);
    //reset les min et les max
    procedure  resetMinMax();
    //new - 09/09/2013 - galiser min-max en abcisse et ordonne
    procedure  egaliserMinMax();
  public
    //oprateur
    FOpAFC: TOpFactAFC;
    { Dclarations publiques }
    procedure   PrepareView(); override;
    function    getAdditionalInfoForReport(): string; override;
    procedure   getOperator(); virtual;
  end;

var
  FrmOpViewFactAnalysisAFC: TFrmOpViewFactAnalysisAFC;

implementation

uses
    UDatasetImplementation, Math;

const
    JITTER_FACTOR : double = 0.06;    

{$R *.dfm}

{ TFrmOpViewFactAnalysisAFC }

procedure TFrmOpViewFactAnalysisAFC.PrepareView;
var a: integer;
begin
 inherited;
 //rcuprer l'oprateur
 self.getOperator();
 //mj des combo
 for a:= 1 to FOpAFC.FNbAxis do
  begin
   self.cmbX1.Items.Add(format('Axis_%d',[a]));
   self.cmbX2.Items.Add(format('Axis_%d',[a]));
  end;
 //slectionner
 self.cmbX1.ItemIndex:= 0;
 self.cmbX2.ItemIndex:= 0;
 //jitter -> false
 self.refreshView(false);
end;

procedure TFrmOpViewFactAnalysisAFC.refreshView(jitter: boolean = false);
var x1,x2: integer;
    i,j: integer;
begin
 //reser le min et le max si pas de jitter demand
 if (jitter = false) then self.resetMinMax();
 //numro des facteurs  afficher
 x1:= self.cmbX1.ItemIndex + 1;
 x2:= self.cmbX2.ItemIndex + 1;
 //insrer les valeurs
 if (x1 > 0) and (x2 > 0)
  then
   begin
    //monter la srie en ligne
    self.SerieLigne.Clear();
    for i:= 1 to FOpAFC.FNbLig do
     //self.SerieLigne.AddXY(FOpAFC.FLigCoord^[i]^[x1],FOpAFC.FLigCoord^[i]^[x2],FOpAFC.Dataset.LstAtts[asTarget].Attribute[0].sValue[FOpAFC.Dataset.Examples.Number[i]]);
     self.setValue(SerieLigne,FOpAFC.FLigCoord^[i]^[x1],FOpAFC.FLigCoord^[i]^[x2],FOpAFC.Dataset.LstAtts[asTarget].Attribute[0].sValue[FOpAFC.Dataset.Examples.Number[i]],jitter);
    //monter la srie en colonne
    self.SerieColonne.Clear();
    for j:= 1 to FOpAFC.FNbCol do
     //self.SerieColonne.AddXY(FOpAFC.FColCoord^[j]^[x1],FOpAFC.FColCoord^[j]^[x2],FOpAFC.Dataset.LstAtts[asInput].Attribute[pred(j)].Name);
     self.setValue(SerieColonne,FOpAFC.FColCoord^[j]^[x1],FOpAFC.FColCoord^[j]^[x2],FOpAFC.Dataset.LstAtts[asInput].Attribute[pred(j)].Name,jitter);
    //new - 09/09/2013 - galiser les min-max en abcisse et ordonne
    self.egaliserMinMax();
    self.chart.BottomAxis.Automatic:= false;
    self.chart.BottomAxis.Minimum:= xMin;
    self.chart.BottomAxis.Maximum:= xMax;
    self.chart.LeftAxis.Automatic:= false;
    self.chart.LeftAxis.Minimum:= yMin;
    self.chart.LeftAxis.Maximum:= yMax;
   end;
end;

procedure TFrmOpViewFactAnalysisAFC.cmbX1Change(Sender: TObject);
begin
 self.refreshView();
end;

procedure TFrmOpViewFactAnalysisAFC.pgctrlFondChange(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePage = self.TabChart)
  then
   begin
    self.actCopy.Enabled:= false;
    self.actCopyChart.Enabled:= true;
    self.actZoomIn.Enabled:= true;
    self.actZoomOut.Enabled:= true;
   end
  else
   begin
    self.actCopy.Enabled:= true;
    self.actCopyChart.Enabled:= false;
    self.actZoomIn.Enabled:= false;
    self.actZoomOut.Enabled:= false;
   end;
end;

procedure TFrmOpViewFactAnalysisAFC.actCopyChartExecute(Sender: TObject);
begin
 self.chart.CopyToClipboardMetafile(false);
end;

procedure TFrmOpViewFactAnalysisAFC.actZoomInExecute(Sender: TObject);
begin
 self.SerieLigne.Marks.Font.Size:= self.SerieLigne.Marks.Font.Size + 1;
 self.SerieColonne.Marks.Font.Size:= self.SerieColonne.Marks.Font.Size + 1;
end;

procedure TFrmOpViewFactAnalysisAFC.actZoomOutExecute(Sender: TObject);
begin
 self.SerieLigne.Marks.Font.Size:= self.SerieLigne.Marks.Font.Size - 1;
 self.SerieColonne.Marks.Font.Size:= self.SerieColonne.Marks.Font.Size - 1;
end;

function TFrmOpViewFactAnalysisAFC.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Correspondance Analysis</H3>';
 s:= s + self.addChartToReport(chart);
 result:= s;
end;

procedure TFrmOpViewFactAnalysisAFC.setValue(points: TPointSeries; x,
  y: double; desc: string; jitter: boolean);
var newx, newy: double;
begin
 if (jitter = false)
  then
   begin
    newx:= x;
    newy:= y;
    xMin:= Min(x,xMin);
    yMin:= Min(y,yMin);
    xMax:= Max(x,xMax);
    yMax:= Max(y,yMax);
   end
  else
   begin
    newx:= x + (0.5 - random)*JITTER_FACTOR*(self.xMax - self.xMin);
    newy:= y + (0.5 - random)*JITTER_FACTOR*(self.yMax - self.yMin);
   end;
 points.AddXY(newx,newy,desc);
end;

procedure TFrmOpViewFactAnalysisAFC.resetMinMax;
begin
 xMin:= Math.MaxDouble;
 yMin:= Math.MaxDouble;
 xMax:= -1.0 * xMin;
 yMax:= -1.0 * yMin;
end;

procedure TFrmOpViewFactAnalysisAFC.mnJitterClick(Sender: TObject);
begin
 self.refreshView(true);
end;

procedure TFrmOpViewFactAnalysisAFC.getOperator;
begin
 FOpAFC:= Operator as TOpFactAFC;
end;

procedure TFrmOpViewFactAnalysisAFC.egaliserMinMax;
begin
 if (xMin < yMin) then yMin:= xMin else xMin:= yMin;
 if (xMax > yMax) then yMax:= xMax else xMax:= yMax;
end;

end.
