(*****************************************************************)
(* UCompFCContValues.pas - Copyright (c) 2011 Ricco RAKOTOMALALA *)
(*****************************************************************)

{
@abstract(Discrete to continuous)
@author(Ricco)
@created(26/05/2011)

Transforme une variable discrte en utilisant simplement le code interne

Cela permet entres autres de virer les modalits sans valeurs observes...

}

unit UCompFCContValues;

interface

USES
        Forms, Classes, IniFiles, Contnrs,
        UCompDefinition,
        UCompFCDefinition,
        UOperatorDefinition,
        UCalcStatDes, UDatasetDefinition, UDatasetImplementation,
        UCalcStructOrdinalAssociation;

TYPE
        {gnrateur de standardisation}
        TGenFCDtoC = class(TMLGenComp)
        protected
        procedure   GenCompInitializations(); override;
        public
        function    GetClassMLComponent: TClassMLComponent; override;
        end;

        {composant standardisation}
        TMLCompFCDtoC = class(TMLCompFC)
        protected
        function    getClassOperator: TClassOperator; override;
        function    GetLogResultDescription(): string; override;
        end;

        {oprateur de standaridsation}
        TOpFCDtoC = class(TOperatorFC)
        protected
        function    getClassParameter: TClassOperatorParameter; override;
        {au dpart, il n'y a que des inputs, et ils sont tous continus}
        function    CheckAttributes(): boolean; override;
        {calculer les stats sur les bons individus et variables, puis normaliser}
        function    CoreExecute(): boolean; override;
        public
        function    getHTMLResultsSummary(): string; override;
        end;

        {paramtre de l'oprateur}
        TPrmOpFCDtoC = class(TOperatorPrmFC)
        protected
        function    CreateDlgParameters(): TForm; override;
        procedure   SetDefaultParameters(); override;
        end;


implementation

USES
    Sysutils,
    UConstConfiguration, ULogFile;

{ TPrmOpFCDtoC }

function TPrmOpFCDtoC.CreateDlgParameters: TForm;
begin
 result:= nil;
end;

procedure TPrmOpFCDtoC.SetDefaultParameters;
begin
 //none
end;

{ TGenFCDtoC }

procedure TGenFCDtoC.GenCompInitializations;
begin
 FMLComp:= mlcFeatureConstruction;
end;

function TGenFCDtoC.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompFCDtoC;
end;

{ TMLCompFCDtoC }

function TMLCompFCDtoC.getClassOperator: TClassOperator;
begin
 result:= TOpFCDtoC;
end;

function TMLCompFCDtoC.GetLogResultDescription: string;
begin
 result:= format('%d continuous attributes generated',[LocalDataset.Count]);
end;

{ TOpFCDtoC }

function TOpFCDtoC.CheckAttributes: boolean;
begin
 result:= (self.WorkData.LstAtts[asInput].Count > 0) and (self.WorkData.LstAtts[asInput].isAllCategory(caDiscrete) = true);
end;

function TOpFCDtoC.CoreExecute: boolean;
var j,i: integer;
    att,newAtt: TAttribute;
begin
 result:= true;
 TRY
 GenAtts.Clear();
 //gnrer la nouvelle liste
 for j:= 0 to pred(self.WorkData.LstAtts[asInput].Count) do
  begin
   att:= self.WorkData.LstAtts[asInput].Attribute[j];
   newAtt:= TAttContinue.Create('d2c_'+att.Name+'_'+IntToStr((MLOwner as TMLComponent).Number),att.Size);
   for i:= 1 to newAtt.Size do newAtt.cValue[i]:= att.cValue[i];
   GenAtts.Add(newAtt);
  end;
 EXCEPT
 result:= false;
 END;
end;

function TOpFCDtoC.getClassParameter: TClassOperatorParameter;
begin
 result:= TPrmOpFCDtoC;
end;

function TOpFCDtoC.getHTMLResultsSummary: string;
var s: string;
    j: integer;
begin
 //lister les variables gnres et le nombre de modalits associes
 s:= '<H3>Discrete to continuous transformation</H3>';
 s:= s + HTML_HEADER_TABLE_RESULT;
 s:= s + HTML_TABLE_COLOR_HEADER_GRAY + '<TH>New attribute name</TH><TH>Values</TH></TR>';
 for j:= 0 to pred(GenAtts.Count) do
  s:= s + HTML_TABLE_COLOR_DATA_GRAY + format('<TD align="left">%s</TD></TR>',[GenAtts.Attribute[j].Name]);
 s:= s + '</table>';
 result:= s;
end;

initialization
 RegisterClass(TGenFCDtoC);
end.
