unit UDlgOpPrmPlsRegPlus;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UDlgBaseOperatorParameter, ComCtrls, StdCtrls, ExtCtrls,
  lmdstdcA, CheckLst;

type
  TdlgOpPrmPlsRegPlus = class(TDlgBaseOperatorParameter)
    Label1: TLabel;
    spinComponents: TLMDSpinEdit;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    outPred: TCheckBox;
    outXScores: TCheckBox;
    outYScores: TCheckBox;
    GroupBox2: TGroupBox;
    chkReport: TCheckListBox;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   ApplyModifications(); override;
    procedure   SetParameters(); override;      
  end;

var
  dlgOpPrmPlsRegPlus: TdlgOpPrmPlsRegPlus;

implementation

uses UCompPLSRegressionPlus;

{$R *.dfm}

{ TdlgOpPrmPlsRegPlus }

procedure TdlgOpPrmPlsRegPlus.ApplyModifications;
var prm: TOpPrmPLSRegPlus;
begin
 prm:= self.OpPrm as TOpPrmPLSRegPlus;
 prm.NbAxisCreated:= self.spinComponents.Value;
 //....
 prm.OutPredResid:= self.outPred.Checked;
 prm.OutXScores:= self.outXScores.Checked;
 prm.OutYScores:= self.outYScores.Checked;
 //....
 prm.RepR2:= self.chkReport.Checked[0];
 prm.RepXLoadings:= self.chkReport.Checked[1];
 prm.RepXWeigths:= self.chkReport.Checked[2];
 prm.RepYWeigths:= self.chkReport.Checked[3];
 prm.RepVIP:= self.chkReport.Checked[4];
 prm.RepUnstdCoef:= self.chkReport.Checked[5];
 prm.RepStdCoef:= self.chkReport.Checked[6];
end;

procedure TdlgOpPrmPlsRegPlus.SetParameters;
var prm: TOpPrmPLSRegPlus;
begin
 prm:= self.OpPrm as TOpPrmPLSRegPlus;
 self.spinComponents.Value:= prm.NbAxisCreated;
 //....
 self.outPred.Checked:= prm.OutPredResid;
 self.outXScores.Checked:= prm.OutXScores;
 self.outYScores.Checked:= prm.OutYScores;
 //....
 self.chkReport.Checked[0]:= prm.RepR2;
 self.chkReport.Checked[1]:= prm.RepXLoadings;
 self.chkReport.Checked[2]:= prm.RepXWeigths;
 self.chkReport.Checked[3]:= prm.RepYWeigths;
 self.chkReport.Checked[4]:= prm.RepVIP;
 self.chkReport.Checked[5]:= prm.RepUnstdCoef;
 self.chkReport.Checked[6]:= prm.RepStdCoef;
end;

end.
