(****************************************************************************)
(* UFrmOpViewPLSRegressionChart.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(****************************************************************************)

{
@abstract(Fentre de visualisation - Rgression PLS)
@author(Ricco)
@created(11/06/2008)

L'intrt est d'intgrer directement la carte w*c pour les diffrents couples de facteurs.

}
unit UFrmOpViewPLSRegressionChart;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, StdCtrls,
  TeeProcs, TeEngine, Chart, Series, UCalcPLSRegressionPlus;

type
  TfrmOpViewPlsRegressionChart = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    panelChart: TPanel;
    actIncSize: TAction;
    actDecSize: TAction;
    N1: TMenuItem;
    FontSize1: TMenuItem;
    FontSize2: TMenuItem;
    chartPls: TChart;
    cmbHoriz: TComboBox;
    cmbVert: TComboBox;
    wSerie: TPointSeries;
    cSerie: TPointSeries;
    procedure actIncSizeExecute(Sender: TObject);
    procedure actDecSizeExecute(Sender: TObject);
    procedure wSerieGetMarkText(Sender: TChartSeries;
      ValueIndex: Integer; var MarkText: String);
    procedure cmbVertChange(Sender: TObject);
    procedure chartPlsBeforeDrawAxes(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
    calcPls: TCalcPLSPlus;
    procedure   refreshChart();
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
    function    getAdditionalInfoForReport(): string; override;
  end;

var
  frmOpViewPlsRegressionChart: TfrmOpViewPlsRegressionChart;

implementation

uses
    Math,
    UCompPLSRegressionPlus;

{$R *.dfm}

{ TfrmOpViewPlsRegressionChart }

procedure TfrmOpViewPlsRegressionChart.PrepareView;
var i,nbAxis: integer;
begin
 inherited;
 //
 calcPls:= (self.operator as TOpPLSRegPlus).getCalc() as TCalcPLSPlus;
 //lister les axes
 nbAxis:= calcPls.NbAxis;
 for i:= 1 to nbAxis do
  begin
   self.cmbHoriz.Items.Add('Factor '+IntToStr(i));
   self.cmbVert.Items.Add('Factor '+IntToStr(i));
  end;
 //initialiser
 if (nbAxis > 0)
  then
   begin
    self.cmbHoriz.ItemIndex:= 0;
    if (nbAxis > 1) then self.cmbVert.ItemIndex:= 1 else self.cmbVert.ItemIndex:= 0;
   end;
 //prparer  la rception
 wSerie.FillSampleValues(calcPls.StatPLS.FCountX);
 cSerie.FillSampleValues(calcPls.StatPLS.FCountY);
 //mj du graphique
 self.refreshChart();
end;

procedure TfrmOpViewPlsRegressionChart.refreshChart;
var h1,h2,j: integer;
begin
 h1:= self.cmbHoriz.ItemIndex;
 h2:= self.cmbVert.ItemIndex;
 //afficher le graphique pour les INPUT
 for j:= 0 to pred(calcPls.StatPLS.FCountX) do
  begin
   self.wSerie.XValue[j]:= calcPls.WhEtoile[j,h1];
   self.wSerie.YValue[j]:= calcPls.WhEtoile[j,h2];
  end;
 //afficher le graphique pour les TARGET
 for j:= 0 to pred(calcPls.StatPLS.FCountY) do
  begin
   self.cSerie.XValues[j]:= calcPls.Ch[j,h1];
   self.cSerie.YValues[j]:= calcPls.Ch[j,h2];
  end;
end;

procedure TfrmOpViewPlsRegressionChart.actIncSizeExecute(Sender: TObject);
begin
 wSerie.Marks.Font.Size:= wSerie.Marks.Font.Size + 1;
 cSerie.Marks.Font.Size:= cSerie.Marks.Font.Size + 1;
end;

procedure TfrmOpViewPlsRegressionChart.actDecSizeExecute(Sender: TObject);
begin
 wSerie.Marks.Font.Size:= wSerie.Marks.Font.Size - 1;
 cSerie.Marks.Font.Size:= cSerie.Marks.Font.Size - 1;
end;

procedure TfrmOpViewPlsRegressionChart.wSerieGetMarkText(
  Sender: TChartSeries; ValueIndex: Integer; var MarkText: String);
begin
 if (Sender = wSerie)
  then MarkText:= calcPls.DataSourceInput.Attribute[ValueIndex].Name
  else MarkText:= calcPls.DataSourceTarget.Attribute[ValueIndex].Name;
end;

procedure TfrmOpViewPlsRegressionChart.cmbVertChange(Sender: TObject);
begin
 self.refreshChart();
end;

procedure TfrmOpViewPlsRegressionChart.chartPlsBeforeDrawAxes(
  Sender: TObject);
var r: TRect;
    pCenter: TPoint;
begin

 //dessiner en gras les axes (0,0)
 //coordonnes min max
 r.Left:= Math.Min(wSerie.CalcXPosValue(wSerie.XValues.MinValue),cSerie.CalcXPosValue(cSerie.XValues.MinValue));
 r.Top:= Math.Min(wSerie.CalcYPosValue(wSerie.YValues.MaxValue),cSerie.CalcYPosValue(cSerie.YValues.MaxValue));
 r.Right:= Math.Max(wSerie.CalcXPosValue(wSerie.XValues.MaxValue),cSerie.CalcXPosValue(cSerie.XValues.MaxValue));
 r.Bottom:= Math.Max(wSerie.CalcYPosValue(wSerie.YValues.MinValue),cSerie.CalcYPosValue(cSerie.YValues.MinValue));
 //point central
 pCenter.X:= wSerie.CalcXPosValue(0);
 pCenter.Y:= wSerie.CalcYPosValue(0);
 //
 chartPls.Canvas.Pen.Width:= 3;
 chartPls.Canvas.Pen.Color:= clGray;
 chartpls.Canvas.Pen.Style:= psDash;
 chartPls.Canvas.Line(r.Left,pCenter.Y,r.Right,pcenter.Y);
 chartPls.Canvas.Line(pCenter.X,r.Top,pCenter.X,r.Bottom);
end;

procedure TfrmOpViewPlsRegressionChart.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.TabIndex = 0)
  then inherited
  else self.chartPls.CopyToClipboardMetafile(false);
end;

function TfrmOpViewPlsRegressionChart.getAdditionalInfoForReport: string;
var s: string;
begin
 s:= '<H3>[w*c] chart</H3>';
 s:= s + self.addChartToReport(chartPls);
 result:= s;
end;

end.
