unit UFrmOpViewRegDfBetas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, Grids, UCompRegOutlierDfBetas;

type
  TfrmOpViewRegDfBetas = class(TFrmBaseOperator)
    tabDfBetas: TTabSheet;
    grid: TDrawGrid;
    procedure gridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    op: TOpRegDFBetas;
    isConstant: boolean;
    p: integer;
    procedure   PrepareView(); override;    
  end;

var
  frmOpViewRegDfBetas: TfrmOpViewRegDfBetas;

implementation

uses UCompRegMultiple, UStringAddBuffered, ClipBrd, UDatasetImplementation;

{$R *.dfm}

{ TfrmOpViewRegDfBetas }

procedure TfrmOpViewRegDfBetas.PrepareView;
begin
 inherited;
 op:= self.Operator as TOpRegDFBetas;
 isConstant:= (op.opCalc.PrmOp as TOpPrmRegMultiple).Constant;
 grid.RowCount:= op.WorkData.Examples.Size + 1;
 p:= length(op.TabCount);
 grid.ColCount:= p + 1;
 grid.ColWidths[0]:= 80;
 self.pgctrlFond.ActivePage:= self.tabHTML;
end;

procedure TfrmOpViewRegDfBetas.gridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var value: single;
    s: string;
begin
 case ACol of
  //numro d'individu
  0: begin
      if (ARow > 0) then grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2, IntToStr(op.WorkData.Examples.Number[ARow]));
     end;
  else
   begin
    if (ARow = 0)
     then
      begin
       //en-tte
       if (isConstant = true)
        then
         begin
          if (ACol = 1)
           then s:= 'Intercept'
           else s:= op.opCalc.LstExogenous.Attribute[ACol-2].Name;
         end
        else s:= op.opCalc.LstExogenous.Attribute[ACol-1].Name;
       grid.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2,s);
      end
     else
      begin
       //la valeur, ah l l, quelle ide d'avoir mis la constante en dernire colonne dans la matrice des X !!!
       if (isConstant = true)
        then
         begin
          if (ACol = 1)
           then value:= op.TabValues[ARow-1,p-1]
           else value:= op.TabValues[ARow-1,ACol-2];
          end
        else value:= op.TabValues[ARow-1,ACol-1];
       //tester
       if (abs(value) > op.CutValue)
        then
         begin
          grid.Canvas.Brush.Color:= $0066CCFF;
          grid.Canvas.Brush.Style:= bsSolid;
          grid.Canvas.Rectangle(Rect.Left+1,Rect.Top+1,Rect.Right-1,Rect.Bottom-1);
          grid.Canvas.Brush.Style:= bsClear;
         end;
       //afficher
        grid.Canvas.TextOut(Rect.Left + 4, Rect.Top + 2,format('%.7f',[value]));
      end;
   end;
 end;
end;

const
    COL_SEPARATOR : CHAR = #9;
    LINE_SEPARATOR : STRING = #13#10;

procedure TfrmOpViewRegDfBetas.actCopyExecute(Sender: TObject);
var buf: TBufString;
    i,j: integer;
    s: string;
begin
 if (self.pgctrlFond.ActivePage = tabHTML)
  then inherited
  else
   begin
    screen.Cursor:= crHourGlass;
    TRY
    //copier la grille dans le presse-papier
    buf:= TBufString.Create(1*1024*1024);
    buf.BeginUpdate();
    //en-tte
    s:= '-';
    if (isConstant = true) then s:= s + COL_SEPARATOR + 'Intercept';
    for j:= 0 to pred(op.opCalc.LstExogenous.Count) do
     s:= s + COL_SEPARATOR + op.opCalc.LstExogenous.Attribute[j].Name;
    s:= s + LINE_SEPARATOR;
    buf.AddStr(s);
    //les valeurs
    for i:= 1 to op.opCalc.WorkData.Examples.Size do
     begin
      s:= IntToStr(op.WorkData.Examples.Number[i]);
      if (isConstant = true) then s:= s + COL_SEPARATOR + format('%.8f',[op.TabValues[i-1,p-1]]);
      for j:= 0 to pred(op.opCalc.LstExogenous.Count) do
       s:= s + COL_SEPARATOR + format('%.8f',[op.TabValues[i-1,j]]);  
      s:= s + LINE_SEPARATOR;
      buf.AddStr(s);
     end;
    //finaliser
    buf.EndUpdate();
    //envoyer dans le presse papier
    clipboard.AsText:= buf.BufS;
    //and then...
    buf.Free();
    FINALLY
    screen.Cursor:= crDefault;
    END;
   end;
end;

end.
