unit UFrmOpViewRegMultiple;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, Grids,
  UCalcRegLinMultiple;

type
  TfrmOpViewRegression = class(TFrmBaseOperator)
    TabSheet1: TTabSheet;
    grid: TDrawGrid;
    procedure gridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
    calc: TCalcRegMultiple;
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
  end;

var
  frmOpViewRegression: TfrmOpViewRegression;

implementation

uses UCompRegMultiple, Math, UStringAddBuffered, ClipBrd;

{$R *.dfm}

{ TfrmOpViewRegression }

procedure TfrmOpViewRegression.PrepareView;
begin
  inherited;//remplir le rapport
  calc:= (self.Operator as TOpRegMultiple).CalcReg;//rcuprer l'oprateur
  //dimensionner la grille
  grid.RowCount:= calc.XPXM1.MatMM.Lig + 1;
  grid.ColCount:= calc.XPXM1.MatMM.Col + 1;
end;

procedure TfrmOpViewRegression.gridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var oldPenColor: TColor;
    id: integer;
begin
 //les bords
 If (ARow=0) OR (ACol=0)
  Then
   Begin
     //dessin du fond des colonnes fixes...
     with grid do
      begin
       Canvas.Brush.Color:= clBtnFace;
       Canvas.FillRect(Rect);
       OldPenColor:= Canvas.Pen.Color;
       Canvas.Pen.Color:= clBtnHighLight;
       Canvas.MoveTo(Rect.Left,Rect.Bottom);
       Canvas.LineTo(Rect.Left,Rect.Top);
       Canvas.LineTo(Rect.Right,Rect.Top);
       Canvas.Pen.Color:= clBtnShadow;
       Canvas.LineTo(Rect.Right,Rect.Bottom);
       Canvas.LineTo(Rect.Left,Rect.Bottom);
       Canvas.Pen.Color:= oldPenColor;
      end;
     //TraceLog.WriteToLogFile('TFrmOpViewData.GridDataDrawCell >> ['+IntToSTr(ARow)+','+IntToStr(ACol)+']');
   end;
 //le coin en haut  gauche
 if (ACol = 0) and (ARow = 0) then grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,'(X''X)^(-1)');
 //les en-ttes, en ligne ou en colonne
 if (ACol = 0) xor (ARow = 0)
  then
   begin
    id:= Math.Max(ACol,ARow);
    if (id < calc.XPXM1.MatMM.Lig) or (calc.UseIntercept = false) //ou Col puisque la matrice est symtrique
     then grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,calc.LstExogenous.Attribute[id-1].Name)
     else grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,'intercept');
   end;
 //les valeurs
 if (ACol > 0) and (ARow > 0)
  then
   begin
    grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,Format('%.8g',[calc.XPXM1[ACol,ARow]]));
   end;
end;

const
    TAB = #9;
    CRLF = #13#10;

procedure TfrmOpViewRegression.actCopyExecute(Sender: TObject);
var i,j,id: integer;
    buf: TBufString;
    s: string;
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else
   begin
    buf:= TBufString.Create(2048);
    buf.BeginUpdate();
    for i:= 0 to calc.XPXM1.MatMM.Lig do
     begin
      s:= '';
      for j:= 0 to calc.XPXM1.MatMM.Col do
       begin
        if (i = 0) and (j = 0) then s:= '(X''X)^(-1)' + TAB;
        if (i = 0) xor (j = 0)
         then
          begin
           id:= Math.Max(i,j);
           if (id < calc.XPXM1.MatMM.Lig) or (calc.UseIntercept = false)
            then s:= s + calc.LstExogenous.Attribute[id-1].Name + TAB
            else s:= s + 'intercept' + TAB;
          end;
        if (i > 0) and (j > 0)
         then s:= s + Format('%10.7e',[calc.XPXM1[i,j]]) + TAB;
       end;
      s:= copy(s,1,length(s)-1)+ CRLF;
      buf.AddStr(s);
     end;
    buf.EndUpdate();
    clipboard.AsText:= buf.BufS;
    buf.Free();
   end;
end;

end.
