(******************************************************************)
(* UCompRegSvmEpsilon.pas - Copyright (c) 2009 Ricco RAKOTOMALALA *)
(******************************************************************)

{
@abstract(Classe de composant - Mthodes de rgression Epsilon-SVR)
@author(Ricco)
@created(07/04/2009)

Utilisation de la bibliothque LIBSVM (http://www.csie.ntu.edu.tw/~cjlin/libsvm/)
importe sous forme de DLL.

}

unit UCompRegSvmEpsilon;

interface

USES
    Forms,
    UCompDefinition,
    UOperatorDefinition,
    UCompRegSvm;

TYPE
    //gnrateur
    TGenRegEpsilonSVR = class(TGenRegSvr)
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    //composant
    TMLEpsilonSvr = class(TMLRegSvr)
    protected
    function    getClassOperator: TClassOperator; override;
    function    getGenericAttName(): string; override;
    end;

    //oprateur
    TOpRegEpsilonSvr = class(TOpRegSvr)
    protected
    function    getClassParameter: TClassOperatorParameter; override;
    end;

    //paramtrage
    TopPrmRegEspilonSvr = class(TOpPrmRegressionSvm)
    protected
    function    getHtmlInternalParameter(): string; override;
    procedure   SetDefaultParameters(); override;
    function    CreateDlgParameters(): TForm; override;
    end;

implementation

USES
    Classes, SysUtils, UDlgOpPrmRegSvmEpsilon, UDlgBaseOperatorParameter;

{ TGenRegEpsilonSVR }

function TGenRegEpsilonSVR.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLEpsilonSvr;
end;

{ TMLEpsilonSvr }

function TMLEpsilonSvr.getClassOperator: TClassOperator;
begin
 result:= TOpRegEpsilonSvr;
end;

function TMLEpsilonSvr.getGenericAttName: string;
begin
 result:= 'e_svr';
end;

{ TOpRegEpsilonSvr }

function TOpRegEpsilonSvr.getClassParameter: TClassOperatorParameter;
begin
 result:= TopPrmRegEspilonSvr;
end;

{ TopPrmRegEspilonSvr }

function TopPrmRegEspilonSvr.CreateDlgParameters: TForm;
begin
 result:= TdlgOpPrmRegSvmEpsilon.CreateFromOpPrm(self);
end;

function TopPrmRegEspilonSvr.getHtmlInternalParameter: string;
begin
 result:= format('<TD>Epsilon</TD><TD align=right>%.4g</TD></TR>',[SvmTypeEpsilon]);
end;

procedure TopPrmRegEspilonSvr.SetDefaultParameters;
begin
 inherited;
 SvmType:= 3;//la grosse astuce est ici, et ce paramtre n'est pas modifiable par l'utilisateur !!!
 SvmTypeEpsilon:= 0.1;
end;

initialization
 RegisterClass(TGenRegEpsilonSVR);
end.
