(*************************************************************)
(* UCompRegSvmNu.pas - Copyright (c) 2009 Ricco RAKOTOMALALA *)
(*************************************************************)

{
@abstract(Classe de composant - Mthodes de rgression Nu-SVR)
@author(Ricco)
@created(07/04/2009)

Utilisation de la bibliothque LIBSVM (http://www.csie.ntu.edu.tw/~cjlin/libsvm/)
importe sous forme de DLL.

}

unit UCompRegSvmNu;

interface

USES
    UCompDefinition,
    UOperatorDefinition,
    UCompRegSvm,
    Forms;

TYPE
    //gnrateur
    TGenRegNuSvr = class(TGenRegSvr)
    public
    function    GetClassMLComponent: TClassMLComponent; override;
    end;

    //composant
    TMLNuSvr = class(TMLRegSvr)
    protected
    function    getClassOperator: TClassOperator; override;
    function    getGenericAttName(): string; override;
    end;

    //oprateur
    TOpRegNuSvr = class(TOpRegSvr)
    protected
    function    getClassParameter: TClassOperatorParameter; override;
    end;

    //paramtrage
    TopPrmRegNuSvr = class(TOpPrmRegressionSvm)
    protected
    function    getHtmlInternalParameter(): string; override;
    procedure   SetDefaultParameters(); override;
    function    CreateDlgParameters(): TForm; override;
    end;

implementation

USES
    Classes, SysUtils, UDlgOpPrmRegSvmNu, UDlgBaseOperatorParameter;

{ TGenRegNuSvr }

function TGenRegNuSvr.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLNuSvr;
end;

{ TMLEpsilonSvr }

function TMLNuSvr.getClassOperator: TClassOperator;
begin
 result:= TOpRegNuSvr;
end;

function TMLNuSvr.getGenericAttName: string;
begin
 result:= 'nu_svr';
end;

{ TOpRegNuSvr }

function TOpRegNuSvr.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmRegNuSvr;
end;

{ TopPrmRegEspilonSvr }

function TopPrmRegNuSvr.CreateDlgParameters: TForm;
begin
 result:= TdlgOpPrmRegSvmNu.CreateFromOpPrm(self);
end;

function TopPrmRegNuSvr.getHtmlInternalParameter: string;
begin
 result:= format('<TD>Nu</TD><TD align=right>%.4g</TD></TR>',[SvmTypeNu]);
end;

procedure TopPrmRegNuSvr.SetDefaultParameters;
begin
 inherited;
 SvmType:= 4;//la grosse astuce est ici, et ce paramtre n'est pas modifiable par l'utilisateur !!!
 SvmTypeNu:= 0.5;
end;

initialization
 RegisterClass(TGenRegNuSvr);
end.
