unit UDlgOpPrmRegTreeCART;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UDlgBaseOperatorParameter, ComCtrls, StdCtrls, ExtCtrls,
  LMDCustomControl, LMDCustomPanel, LMDCustomBevelPanel, LMDBaseEdit,
  LMDCustomEdit, LMDCustomMaskEdit, LMDMaskEdit, lmdstdcA;

type
  TdlgOpPrmRegTreeCART = class(TDlgBaseOperatorParameter)
    rgRnd: TRadioGroup;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    spinMinSizeToSPlit: TLMDSpinEdit;
    spinMaxClusters: TLMDSpinEdit;
    Label5: TLabel;
    Label6: TLabel;
    spinMaxDepth: TLMDSpinEdit;
    GroupBox2: TGroupBox;
    spinPruneSize: TLMDSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    edSERule: TLMDMaskEdit;
    chkShowSeq: TCheckBox;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  procedure   ApplyModifications(); override;
  procedure   SetParameters(); override;    
  end;

var
  dlgOpPrmRegTreeCART: TdlgOpPrmRegTreeCART;

implementation

uses UCompRegTreePredictive, UCalcRndGenerator;

{$R *.dfm}

{ TdlgOpPrmRegTreeCART }

procedure TdlgOpPrmRegTreeCART.ApplyModifications;
var prm: TPrmOpRegTreeCART;
begin
 prm:= self.OpPrm as TPrmOpRegTreeCART;
 //
 prm.SizeBeforeSplit:= self.spinMinSizeToSPlit.Value;
 prm.MaxNbClusters:= self.spinMaxClusters.Value;
 prm.MaxDepth:= self.spinMaxDepth.Value;
 prm.PruningSetSize:= self.spinPruneSize.Value;
 prm.ShowAllTreeSeq:= self.chkShowSeq.Checked;
 prm.ModeRndGenerator:= TStartSeed(self.rgRnd.ItemIndex);
 TRY
 prm.SERule:= StrToFloat(self.edSERule.Text);
 EXCEPT
 prm.SERule:= 1.0;
 END;
end;

procedure TdlgOpPrmRegTreeCART.SetParameters;
var prm: TPrmOpRegTreeCART;
begin
 prm:= self.OpPrm as TPrmOpRegTreeCART;
 //
 self.spinMinSizeToSPlit.Value:= prm.SizeBeforeSplit;
 self.spinMaxClusters.Value:= prm.MaxNbClusters;
 self.spinMaxDepth.Value:= prm.MaxDepth;
 self.spinPruneSize.Value:= prm.PruningSetSize;
 self.edSERule.Text:= FloatToStr(prm.SERule);
 self.chkShowSeq.Checked:= prm.ShowAllTreeSeq;
 self.rgRnd.ItemIndex:= ord(prm.ModeRndGenerator);
end;

end.
