unit UFrmOpViewRegTreeCART;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart, LMDCustomComponent, LMDCustomHint,
  LMDCustomShapeHint, LMDMessageHint;

type
  TfrmOpViewRegTreeCART = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chart: TChart;
    growing: TLineSeries;
    pruning: TLineSeries;
    msgHint: TLMDMessageHint;
    procedure actCopyExecute(Sender: TObject);
    procedure growingClick(Sender: TChartSeries; ValueIndex: Integer;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
    function getAdditionalInfoForReport: string; override;
  end;

var
  frmOpViewRegTreeCART: TfrmOpViewRegTreeCART;

implementation

uses UCalcRegTreeCART, UCompRegTreePredictive;

{$R *.dfm}

procedure TfrmOpViewRegTreeCART.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else chart.CopyToClipboardBitmap();
end;

procedure TfrmOpViewRegTreeCART.PrepareView;
var arbre: TMLTreeStructureClusCART;
    i: integer;
begin
 inherited;
 //assurer le coup avant de se lancer
 if (Operator is TOpRegTreeCART)
  then
   begin
    //rcuprer le tableau des taux d'erreur et du nombre de feuilles
    arbre:= ((Operator as TOpRegTreeCART).Calc as TCalcRegTreeCART).Tree as TMLTreeStructureClusCART;
    for i:= high(arbre.TabTreeSequence) downto low(arbre.TabTreeSequence) do
     begin
      growing.AddXY(arbre.TabTreeSequence[i].NbLeaves,arbre.TabTreeSequence[i].mseGrow);
      pruning.AddXY(arbre.TabTreeSequence[i].NbLeaves,arbre.TabTreeSequence[i].msePrune);
     end;
   end;
 //slectionner la sortie HTML
 self.pgctrlFond.ActivePageIndex:= 0;
end;

procedure TfrmOpViewRegTreeCART.growingClick(Sender: TChartSeries;
  ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var coord: TPoint;
    msg: string;
begin
 coord:= chart.ClientToScreen(point(X,Y));
 msg:= Format('# leaves : %.0f -- MSE : %.4f',[sender.XValues[ValueIndex],sender.YValues[ValueIndex]]);
 msgHint.ShowMessage(msg,coord.X,coord.Y);
end;

function TfrmOpViewRegTreeCART.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Mean squared error vs. Tree complexity</H3>';
 s:= s + self.addChartToReport(chart);
 result:= s;
end;

end.
