unit UFrmSpvScoringPrecRecall;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeeProcs,
  TeEngine, Chart, Series;

type
  TfrmOpViewSpvScoringPrecRecall = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chart: TChart;
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
    function getAdditionalInfoForReport: string; override;
  end;

var
  frmOpViewSpvScoringPrecRecall: TfrmOpViewSpvScoringPrecRecall;

implementation

uses
    UCompSpvScoringPrecRecallCurve,
    UCompSpvScoringLift,
    UDatasetDefinition,
    UDatasetImplementation;

CONST
    CHART_LINE_WIDTH = 3;    

{$R *.dfm}

procedure TfrmOpViewSpvScoringPrecRecall.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else chart.CopyToClipboardBitmap();
end;

function TfrmOpViewSpvScoringPrecRecall.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Precision-Recall curve</H3>';
 s:= s + self.addChartToReport(chart);
 result:= s;
end;

procedure TfrmOpViewSpvScoringPrecRecall.PrepareView;
var op: TOpSpvScoringPrecRecall;
    plot: TLineSeries;
    j,i: integer;
    att: TAttribute;
    x,y: double;

    procedure createNewPlot(titre: string);
    begin
     plot:= TLineSeries.Create(chart);
     plot.Title:= titre;
     plot.LinePen.Width:= CHART_LINE_WIDTH;
     plot.FillSampleValues(op.NbExamples);
     chart.AddSeries(plot);
    end;
    
begin
 inherited;
 //rcuprer l'oprateur
 op:= Operator as TOpSpvScoringPrecRecall;
 //page  afficher en priorit
 self.pgctrlFond.ActivePage:= tabCHART;
 //charger les sries de points
 for j:= 0 to pred(op.WorkData.LstAtts[asInput].Count) do
  begin
   att:= op.WorkData.LstAtts[asInput].Attribute[j];
   createNewPlot(att.Name);
   for i:= 1 to op.NbExamples do
    begin
     x:= op.TabTVP[i,j];
     y:= op.TabPrecision[i,j];
     plot.XValue[pred(i)]:= x;
     plot.YValue[pred(i)]:= y;
    end;
  end;
end;

end.
