unit UFrmSpvScoringRelDiagram;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart;

type
  TfrmSpvScoringRelDiagram = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chart: TChart;
    diag: TLineSeries;
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
    function getAdditionalInfoForReport: string; override;
  end;

var
  frmSpvScoringRelDiagram: TfrmSpvScoringRelDiagram;

implementation

uses
    UDatasetDefinition, UDatasetImplementation,
    UCompSpvScoringReliabilityDiagram;

{$R *.dfm}

CONST
    CHART_LINE_WIDTH = 2;

{ TfrmSpvScoringRelDiagram }

procedure TfrmSpvScoringRelDiagram.PrepareView;
var op: TOpSpvScoringRelDiagram;
    plot: TLineSeries;
    j,i: integer;
    att: TAttribute;
    x,y: double;

    procedure createNewPlot(titre: string);
    begin
     plot:= TLineSeries.Create(chart);
     plot.Title:= titre;
     plot.Pointer.Visible:= true;
     plot.LinePen.Style:= psDashDot;
     plot.LinePen.Width:= 1;
     chart.AddSeries(plot);
    end;

begin
 inherited;
 //mettre la diagonale
 //rcuprer l'oprateur
 op:= Operator as TOpSpvScoringRelDiagram;
 //page  afficher en priorit
 self.pgctrlFond.ActivePage:= tabCHART;
 //diagonale
 diag.AddXY(0,0);
 diag.AddXY(1,1);
 //charger les sries de points
 for j:= 0 to pred(op.WorkData.LstAtts[asInput].Count) do
  begin
   att:= op.WorkData.LstAtts[asInput].Attribute[j];
   createNewPlot(att.Name);
   for i:= 1 to op.NbGroups do
    begin
     x:= op.TabMoyScore[i-1][j];
     y:= op.TabPPos[i-1][j];
     plot.AddXY(x,y,'',clTeeColor);
    end;
  end;
end;

procedure TfrmSpvScoringRelDiagram.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else chart.CopyToClipboardBitmap();
end;

function TfrmSpvScoringRelDiagram.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Reliability diagram</H3>';
 s:= s + self.addChartToReport(chart);
 result:= s;
end;

end.
