unit UFrmSpvScoringRoc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeeProcs,
  TeEngine, Chart, Series;

type
  TfrmOpViewSpvScoringRoc = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chart: TChart;
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
    function getAdditionalInfoForReport: string; override;
  end;

var
  frmOpViewSpvScoringRoc: TfrmOpViewSpvScoringRoc;

implementation

uses UCompSpvScoringRoc, UCompSpvScoringLift, UDatasetDefinition, UDatasetImplementation;

CONST
    CHART_LINE_WIDTH = 2;

{$R *.dfm}

procedure TfrmOpViewSpvScoringRoc.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else chart.CopyToClipboardBitmap();
end;

function TfrmOpViewSpvScoringRoc.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Roc curve</H3>';
 s:= s + self.addChartToReport(chart);
 result:= s;
end;

procedure TfrmOpViewSpvScoringRoc.PrepareView;
var op: TOpSpvScoringROC;
    plot: TLineSeries;
    j,i: integer;
    att: TAttribute;
    x,y: double;

    procedure createNewPlot(titre: string);
    begin
     plot:= TLineSeries.Create(chart);
     plot.Title:= titre;
     plot.LinePen.Width:= CHART_LINE_WIDTH;
     chart.AddSeries(plot);
    end;
    
begin
 inherited;
 //rcuprer l'oprateur
 op:= Operator as TOpSpvScoringROC;
 //page  afficher en priorit
 self.pgctrlFond.ActivePage:= tabCHART;
 //construire la diagonale
 createNewPlot('Random : 0.500');
 plot.AddXY(0,0,'',clRed);
 plot.AddXY(1,1,'',clRed);
 //charger les sries de points
 for j:= 0 to pred(op.WorkData.LstAtts[asInput].Count) do
  begin
   att:= op.WorkData.LstAtts[asInput].Attribute[j];
   createNewPlot(att.Name + ' : ' + Format('%.3f',[op.TabAUC[j]]));
   for i:= 0 to SCORING_NB_STEPS_TARGET_SIZE do
    begin
     x:= op.TabTFP[i,j];
     y:= op.TabTVP[i,j];
     plot.AddXY(x,y,'',clTeeColor);
    end;
  end;
end;

end.
