(*********************************************************************)
(* UCompMetaSpvCSBagging.pas - Copyright (c) 2008 Ricco RAKOTOMALALA *)
(*********************************************************************)

{
@abstract(Baggin - Agrgation d'Apprentissage tenant compte des cots de mauvais classement)
@author(Ricco)
@created(29/12/2008)

La correction est ralise uniquement sur la rgle d'affectation pour chaque classifieur.
Aprs on les combine en les faisant voter.

}

unit UCompMetaSpvCSBagging;

interface

USES
        UCompDefinition,
        UCompSpvLDefinition,
        UOperatorDefinition,
        UCompMetaSpvGenericCostSensitive,
        UCompMetaSpvCSCommitte;

TYPE
        {gnrateur de composant meta}
        TMLGCompCSBagging = class(TMLGenComp)
        protected
        procedure   GenCompInitializations(); override;
        public
        function    GetClassMLComponent: TClassMLComponent; override;
        end;

        {le composant meta, singe un single learning}
        TMLCompCSBagging = class(TMLCompMetaSpvCostSensitive)
        protected
        function    ShortMLCompName(): string; override;
        function    getClassOperator: TClassOperator; override;
        end;

        {oprateur bagging}
        TOpMetaSpvCSBagging = class(TOpMetaSpvCSCommitte)
        protected
        {simple tirage avec remise}
        procedure   prepareSample(); override;
        end;


implementation

uses
        Classes,
        UStringsResources;

{ TMLGCompCSBagging }

procedure TMLGCompCSBagging.GenCompInitializations;
begin
  FMLComp:= mlcMetaSpvLearning;
end;

function TMLGCompCSBagging.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompCSBagging;
end;

{ TMLCompCSBagging }

function TMLCompCSBagging.getClassOperator: TClassOperator;
begin
 result:= TOpMetaSpvCSBagging;
end;

function TMLCompCSBagging.ShortMLCompName: string;
begin
 result:= 'CSBagging';
end;

{ TOpMetaSpvCSBagging }

procedure TOpMetaSpvCSBagging.prepareSample;
begin
 self.WorkData.Examples.SampleReplicate(FInternalExamples,FRnd);
end;

initialization
 RegisterClass(TMLGCompCSBagging);
end.
