unit UDlgOpPrmSpvTreeCSC45;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UDlgBaseOperatorParameter, ComCtrls, StdCtrls, ExtCtrls,
  LMDCustomControl, LMDCustomPanel, LMDCustomBevelPanel, LMDBaseEdit,
  LMDCustomEdit, LMDCustomMaskEdit, LMDMaskEdit, Grids, lmdstdcA;

type
  TdlgOpPrmSpvTreeCSC45 = class(TDlgBaseOperatorParameter)
    tabCost: TTabSheet;
    Label1: TLabel;
    spinSize: TLMDSpinEdit;
    gridCost: TStringGrid;
    Label2: TLabel;
    Label3: TLabel;
    spinMinSize: TLMDSpinEdit;
    edLambda: TLMDMaskEdit;
    Label4: TLabel;
    procedure spinSizeChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  procedure   ApplyModifications(); override;
  procedure   SetParameters(); override;    
  end;

var
  dlgOpPrmSpvTreeCSC45: TdlgOpPrmSpvTreeCSC45;

implementation

uses UCompSpvCSTreeC45;

{$R *.dfm}

{ TdlgOpPrmSpvTreeCSC45 }

procedure TdlgOpPrmSpvTreeCSC45.ApplyModifications;
var prm: TOpPrmSpvCSTreeC45;
begin
 prm:= self.OpPrm as TOpPrmSpvCSTreeC45;
 prm.MinSizeLeaf:= self.spinMinSize.Value;
 prm.CostMatrix.getCostsFromGrid(gridCost);
 TRY
 prm.Lambda:= StrToFloat(self.edLambda.Text);
 EXCEPT
 prm.Lambda:= 3;
 END;
end;

procedure TdlgOpPrmSpvTreeCSC45.SetParameters;
var prm: TOpPrmSpvCSTreeC45;
begin
 prm:= self.OpPrm as TOpPrmSpvCSTreeC45;
 self.spinMinSize.value:= prm.MinSizeLeaf;
 self.edLambda.Text:= FloatToStr(prm.Lambda);
 self.spinSize.Value:= prm.CostMatrix.Size;
 prm.CostMatrix.setCostsToGrid(gridCost);
end;

procedure TdlgOpPrmSpvTreeCSC45.spinSizeChange(Sender: TObject);
var i,j: integer;
begin
 //retailler la grille
 gridCost.RowCount:= spinSize.Value+1;
 gridCost.ColCount:= spinSize.Value+1;
 for i:= 1 to pred(gridCost.RowCount) do
  begin
   gridCost.Cells[i,0]:= IntToStr(i);
   gridCost.Cells[0,i]:= IntToStr(i);
  end;
 //remplir automatiquement les cellules vides
 for i:= 1 to pred(gridCost.RowCount) do
  for j:= 1 to pred(gridCost.ColCount) do
   begin
    if (gridCost.Cells[j,i]='')
     then
      begin
       if (i <> j)
        then gridCost.Cells[j,i]:= '1'
        else gridCost.Cells[j,i]:= '0'
      end;
   end;
end;

end.
