unit UFrmOpViewSpvLogRegResiduals;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, Grids,
  UCompSpvLogisticRegResiduals;

type
  TFrmOpViewSpvLogRegResisuals = class(TFrmBaseOperator)
    tabResiduals: TTabSheet;
    grid: TDrawGrid;
    popMenuDigits: TPopupMenu;
    Increasedigits1: TMenuItem;
    Decreasedigits1: TMenuItem;
    N1: TMenuItem;
    procedure gridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Increasedigits1Click(Sender: TObject);
    procedure Decreasedigits1Click(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Decimals: integer;
    op: TOpSpvLogRegResiduals;
    procedure   PrepareView(); override;    
  end;

var
  FrmOpViewSpvLogRegResisuals: TFrmOpViewSpvLogRegResisuals;

implementation

uses
    Clipbrd,
    UDatasetDefinition, UStringAddBuffered;

{$R *.dfm}

{ TFrmOpViewSpvLogRegResisuals }

procedure TFrmOpViewSpvLogRegResisuals.PrepareView;
begin
 inherited;
 Decimals:= 6;
 op:= self.Operator as TOpSpvLogRegResiduals;
 grid.RowCount:= op.Classifier.CurExamples.Size + 1;
 grid.ColCount:= op.LstRes.Count + 1;
end;

procedure TFrmOpViewSpvLogRegResisuals.gridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var value: string;
    size: TSize;
    width: integer;

    procedure afficher();
    begin
     value:= Format('%.*f',[Decimals,(op.LstRes.Items[ACol-1] as TAttribute).cValue[op.Classifier.CurExamples.Number[ARow]]]);
     size:= grid.Canvas.TextExtent(value);
     grid.Canvas.TextOut(Rect.Left+(width-size.cx)-4,Rect.Top+2,value);
    end;

begin
 width:= Rect.Right - Rect.Left;
 If (ACol = 0) then
  begin
    if (ARow > 0) then grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,IntToStr(op.Classifier.CurExamples.Number[ARow]));
  end
  else
   begin
    if (ARow = 0) then grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,(op.LstRes.Items[ACol-1] as TAttribute).Name)
    else
     begin
      if (ACol in [succ(ord(lrHat))..succ(ord(lrCook))])
       then
        begin
         if op.isOutside(TLogRegResiduals(ACol-1),ACol,op.Classifier.CurExamples.Number[ARow]) then grid.Canvas.Font.Style:= [fsBold];
         afficher();
        end
       else
        begin
         //on doit s'occuper des DFBETA
         if (ACol in [succ(ord(lrCook))+1..succ(ord(lrCook))+op.Classifier.Descriptors.Count+1])
          then afficher()
          else
           begin
            //puis des DFBETAS
            if op.isOutside(lrDfBetas,ACol,op.Classifier.CurExamples.Number[ARow]) then grid.Canvas.Font.Style:= [fsBold];
            afficher();
           end;
        end;
     end;
 end;
 grid.Canvas.Font.Style:= [];
end;

procedure TFrmOpViewSpvLogRegResisuals.Increasedigits1Click(
  Sender: TObject);
begin
 inc(Decimals);
 grid.Refresh();
end;

procedure TFrmOpViewSpvLogRegResisuals.Decreasedigits1Click(
  Sender: TObject);
begin
 if (Decimals > 2)
  then
   begin
    dec(Decimals);
    grid.Refresh();
   end;
end;

const
    COL_SEPARATOR : CHAR = #9;
    LINE_SEPARATOR : STRING = #13#10;

procedure TFrmOpViewSpvLogRegResisuals.actCopyExecute(Sender: TObject);
var buf: TBufString;
    i,j,example: integer;
    s: string;
begin
 if (self.pgctrlFond.ActivePage = tabHTML)
  then inherited
  else
   begin
    screen.Cursor:= crHourGlass;
    TRY
    //copier la grille dans le presse-papier
    buf:= TBufString.Create(1*1024*1024);
    buf.BeginUpdate();
    s:= 'ID' + COL_SEPARATOR;
    for j:= 0 to pred(op.LstRes.Count) do s:= s + (op.LstRes.Items[j] as TAttribute).Name + COL_SEPARATOR;
    s:= copy(s,1,length(s)-1)+LINE_SEPARATOR;
    buf.AddStr(s);
    for i:= 1 to op.Classifier.CurExamples.Size do
     begin
      example:= op.Classifier.CurExamples.Number[i];
      s:= IntToStr(example) + COL_SEPARATOR;
      for j:= 0 to pred(op.LstRes.Count) do
       s:= s + Format('%.15e',[(op.LstRes.Items[j] as TAttribute).cValue[example]]) + COL_SEPARATOR;
      s:= copy(s,1,length(s)-1)+LINE_SEPARATOR;
      buf.AddStr(s);
     end;
    //finaliser
    buf.EndUpdate();
    //envoyer dans le presse papier
    clipboard.AsText:= buf.BufS;
    //and then...
    buf.Free();
    FINALLY
    screen.Cursor:= crDefault;
    END;
   end;
end;

end.
