unit UFrmOpViewSpvLogisticRegression;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, Grids,
  UCompSpvLogisticRegression;

type
  TfrmOpViewLogistiRegression = class(TFrmBaseOperator)
    tabMVCV: TTabSheet;
    grid: TDrawGrid;
    procedure gridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure actCopyExecute(Sender: TObject);
  private
    { Dclarations prives }
    calc: TCalcLogisticReg;
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
  end;

var
  frmOpViewLogistiRegression: TfrmOpViewLogistiRegression;

implementation

{$R *.dfm}

uses
    Math, ClipBrd,
    UCompMetaSpvOneInstance, UStringAddBuffered;

var
    curDigits: integer = 4;

{ TfrmOpViewLogistiRegression }

procedure TfrmOpViewLogistiRegression.PrepareView;
begin
 //rapport HTML
 inherited;
 //rcuprer l'objet contenant les infos
 calc:= (self.Operator as TOpOneInstance).Classifier as TCalcLogisticReg;
 grid.RowCount:= calc.Descriptors.Count + 2;
 grid.ColCount:= grid.RowCount;
end;

procedure TfrmOpViewLogistiRegression.gridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var oldPenColor: TColor;
    id: integer;
begin
 //les bords
 If (ARow=0) OR (ACol=0)
  Then
   Begin
     //dessin du fond des colonnes fixes...
     with grid do
      begin
       Canvas.Brush.Color:= clBtnFace;
       Canvas.FillRect(Rect);
       OldPenColor:= Canvas.Pen.Color;
       Canvas.Pen.Color:= clBtnHighLight;
       Canvas.MoveTo(Rect.Left,Rect.Bottom);
       Canvas.LineTo(Rect.Left,Rect.Top);
       Canvas.LineTo(Rect.Right,Rect.Top);
       Canvas.Pen.Color:= clBtnShadow;
       Canvas.LineTo(Rect.Right,Rect.Bottom);
       Canvas.LineTo(Rect.Left,Rect.Bottom);
       Canvas.Pen.Color:= oldPenColor;
      end;
     //TraceLog.WriteToLogFile('TFrmOpViewData.GridDataDrawCell >> ['+IntToSTr(ARow)+','+IntToStr(ACol)+']');
   end;
 //le coin en haut  gauche
 if (ACol = 0) and (ARow = 0) then grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,'Cov.Matrix');
 //les en-ttes, en ligne ou en colonne
 if (ACol = 0) xor (ARow = 0)
  then
   begin
    id:= Math.Max(ACol,ARow);
    if (id = 1)
     then grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,'intercept')
     else grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,calc.Descriptors.Attribute[id-2].Name);
   end;
 //les valeurs
 if (ACol > 0) and (ARow > 0)
  then
   begin
    grid.Canvas.TextOut(Rect.Left+2,Rect.Top+2,Format('%.8g',[calc.MatVCOV[ACol-1,ARow-1]]));
   end;
end;

const
    TAB = #9;
    CRLF = #13#10;


procedure TfrmOpViewLogistiRegression.actCopyExecute(Sender: TObject);
var i,j,id: integer;
    buf: TBufString;
    s: string;
begin
 if (self.pgctrlFond.ActivePageIndex = 0)
  then inherited
  else
   begin
    buf:= TBufString.Create(2048);
    buf.BeginUpdate();
    for i:= 0 to calc.Descriptors.Count+1 do
     begin
      s:= '';
      for j:= 0 to calc.Descriptors.Count+1 do
       begin
        if (i = 0) and (j = 0) then s:= 'Cov.Matrix' + TAB;
        if (i = 0) xor (j = 0)
         then
          begin
           id:= Math.Max(i,j);
           if (id = 1)
            then s:= s + 'intercept' + TAB
            else s:= s + calc.Descriptors.Attribute[id-2].Name + TAB;
          end;
        if (i > 0) and (j > 0)
         then s:= s + Format('%10.7e',[calc.MatVCOV[i-1,j-1]]) + TAB;
       end;
      s:= copy(s,1,length(s)-1)+ CRLF;
      buf.AddStr(s);
     end;
    buf.EndUpdate();
    clipboard.AsText:= buf.BufS;
    buf.Free();
   end;
end;

end.
