unit UDlgOpPrmSpvRuleInduction;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UDlgBaseOperatorParameter, ComCtrls, StdCtrls, ExtCtrls;

type
  TdlgOpPrmSpvRuleInduction = class(TDlgBaseOperatorParameter)
    Panel1: TPanel;
    Label1: TLabel;
    edSupport: TEdit;
    Label2: TLabel;
    cmbMeasure: TComboBox;
    pagePrm: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label3: TLabel;
    edSignif: TEdit;
    Label4: TLabel;
    edWeight: TEdit;
    procedure cmbMeasureChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  procedure   ApplyModifications(); override;
  procedure   SetParameters(); override;    
  end;

var
  dlgOpPrmSpvRuleInduction: TdlgOpPrmSpvRuleInduction;

implementation

uses UCompSpvRuleInduction, UCalcSpvRuleInduction;

{$R *.dfm}

{ TdlgOpPrmSpvRuleInduction }

procedure TdlgOpPrmSpvRuleInduction.ApplyModifications;
var prm: TOpPrmRuleInduction;
begin
 prm:= OpPrm as TOpPrmRuleInduction;
 //placer les valeurs
 prm.Measurement:= TEnumMeasureRuleInduction(self.cmbMeasure.ItemIndex);
 TRY
 prm.SignifLevel:= StrToFloat(self.edSignif.Text);
 prm.SupportMin:= StrToInt(self.edSupport.Text);
 prm.Weight:= StrToFloat(self.edWeight.Text);
 EXCEPT
 END;
 //remettre les valeurs par dfaut si valeur farfelues
 if (prm.SignifLevel <= 0.0) then prm.SignifLevel:= 0.05;
 if (prm.SupportMin <= 0) then prm.SupportMin:= 10;
 if (prm.Weight <= 0.0) then prm.Weight:= 4.0;
end;

procedure TdlgOpPrmSpvRuleInduction.SetParameters;
var prm: TOpPrmRuleInduction;
begin
 prm:= OpPrm as TOpPrmRuleInduction;
 //placer les valeurs
 self.cmbMeasure.ItemIndex:= ord(prm.Measurement);
 self.edSignif.Text:= Format('%.6f',[prm.SignifLevel]);
 self.edSupport.Text:= IntToStr(prm.SupportMin);
 self.edWeight.Text:= Format('%.1f',[prm.Weight]);
 //synchroniser la page control
 self.cmbMeasureChange(nil);
end;

procedure TdlgOpPrmSpvRuleInduction.cmbMeasureChange(Sender: TObject);
begin
 if (cmbMeasure.ItemIndex = 2)
  then self.pagePrm.ActivePageIndex:= 1
  else self.pagePrm.ActivePageIndex:= 0;
end;

end.
