(************************************************************************)
(* UCompSpvAssesLeaveOneOut.pas - Copyright (c) 2007 Ricco RAKOTOMALALA *)
(************************************************************************)

{
@abstract(Leave One Out)
@author(Ricco)
@created(17/10/2007)

Leave one out. Pas de paramtrage, c'est un cas particulier de la
validation croise.

}

unit UCompSpvAssesLeaveOneOut;

interface

USES
   Forms,Classes,IniFiles,
   UCompDefinition,
   UCompSpvAssesDefinition,
   UOperatorDefinition,
   UCompSpvAssesCrossValidation;

TYPE
        {gnrateur}
        TMLGenCompAssesLVO = class(TMLGenComp)
        protected
        procedure   GenCompInitializations(); override;
        public
        function    GetClassMLComponent: TClassMLComponent; override;
        end;

        {composant}
        TMLCompAssesLVO =  class(TMLCompSpvAsses)
        protected
        function    getClassOperator: TClassOperator; override;
        end;

        {oprateur}
        TOpAssesLVO =  class(TOpSpvAsses)
        protected
        function    getClassParameter: TClassOperatorParameter; override;
        procedure   AssesExecution(); override;
        public
        function    getHTMLResultsSummary(): string; override;
        end;

        {paramtres de l'oprateur}
        TOpPrmAssesLVO = class(TOpPrmSpvAsses)
        protected
        function    CreateDlgParameters(): TForm; override;
        procedure   SetDefaultParameters(); override;
        end;

implementation

uses UDlgOpPrmSpvAssesLVO,
     Sysutils,
     UStringsResources, UDatasetExamples, UCompSpvLDefinition,
     UDatasetImplementation, UDatasetDefinition, UConstConfiguration,
     UDlgOpPrmSpvAssesCV, ULogFile, UCalcRndGenerator;

{ TMLGenCompAssesLVO }

procedure TMLGenCompAssesLVO.GenCompInitializations;
begin
 FMLComp:= mlcSpvAssessment;
end;

function TMLGenCompAssesLVO.GetClassMLComponent: TClassMLComponent;
begin
 result:= TMLCompAssesLVO; 
end;

{ TMLCompAssesLVO }

function TMLCompAssesLVO.getClassOperator: TClassOperator;
begin
 result:= TOpAssesLVO; 
end;

{ TOpPrmAssesLVO }

function TOpPrmAssesLVO.CreateDlgParameters: TForm;
begin
 result:= TdlgOpPrmSpvAssesLVO.CreateFromOpPrm(self);
end;

procedure TOpPrmAssesLVO.SetDefaultParameters;
begin
 //pas de paramtres spcifiques
 inherited;
end;

{ TOpAssesLVO }

procedure TOpAssesLVO.AssesExecution;
var testSample,sample: TExamples;
    f,i: integer;
    nbExamples: integer;
    tmpCM: TConfusionMatrix;
    kClass,kPred: TTypeDiscrete;
    ClassAtt: TAttribute;
    example: integer;
begin
 //attribut  prdire
 ClassAtt:= CompMetaSpv.OutputData.LstAtts[asTarget].Attribute[0];
 //folds
 nbExamples:= AllExamples.Size;
 //matrice de confusion
 tmpCM:= TConfusionMatrix.createStructure(ClassAtt);
 //les individus temporaires
 sample:= TExamples.Create(AllExamples.Size);
 sample.Copy(AllExamples);
 testSample:= TExamples.Create(1);
 //initialiser la matrice de confusion
 tmpCM.CrossTab.ReInitialization();
 //pour chaque fold qui est ici chaque exemple
 for f:= 1 to nbExamples do
  begin
   self.RootExamples.BeginAdd();
   testSample.BeginAdd();
   for i:= 1 to sample.Size do
    begin
     if (i = f)
      then testSample.AddExample(sample.Number[i])
      else self.RootExamples.AddExample(sample.Number[i]);
    end;
   self.RootExamples.EndAdd();
   testSample.EndAdd();
   //lancer l'apprentissage en forant le retour arrire
   CompMetaSpv.Execute(TRUE);
   //calculer la matrice de confusion sur le "test sample" numro >> f <<, c'est toujours le 1er dans le test sample
   example:= testSample.Number[1];
   kClass:= ClassAtt.dValue[example];
   kPred:= CompMetaSpv.PredClass.dValue[example];
   //mj du tableau
   tmpCM.CrossTab.Value[kClass,kPred]:= tmpCM.CrossTab.Value[kClass,kPred]+1;
   //les marges
   tmpCM.CrossTab.Value[kClass,0]:= tmpCM.CrossTab.Value[kClass,0]+1;
   tmpCM.CrossTab.Value[0,kPred]:= tmpCM.CrossTab.Value[0,kPred]+1;
   tmpCM.CrossTab.Value[0,0]:= tmpCM.CrossTab.Value[0,0]+1;
   //envoyer la taille des fichiers et le taux d'erreur
   //TraceLog.WriteToLogFile(format('[LVO] %d train and %d test >>> true = %d, pred = %d',[self.RootExamples.Size,testSample.Size,kClass,kPred]));
  end;
 //ajouter la matrice de confusion
 ConfMatrixAsses.addOtherConfMatrix(tmpCM);
 tmpCM.Free;
 testSample.Free;
 sample.Free;
end;

function TOpAssesLVO.getClassParameter: TClassOperatorParameter;
begin
 result:= TOpPrmAssesLVO;
end;

function TOpAssesLVO.getHTMLResultsSummary: string;
var s: string;
begin
 s:= '<H4>Overall cross-validation error rate</H4>';
 s:= s+ConfMatrixAsses.getHTMLResults();
 result:= s;
end;

initialization
 RegisterClass(TMLGenCompAssesLVO);
end.
