unit UFrmOpViewCatVarClusHAC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, TeEngine,
  Series, TeeProcs, Chart, LMDCustomComponent, LMDCustomHint,
  LMDCustomShapeHint, LMDMessageHint, UCompCatVarClusHAC;

type
  TfrmOpViewCatVarClusHAC = class(TFrmBaseOperator)
    tabDendrogram: TTabSheet;
    ChartDendrogram: TChart;
    dendrogram: TPointSeries;
    messageHint: TLMDMessageHint;
    tabAggregation: TTabSheet;
    ChartAggreg: TChart;
    SeriesAggreg: TLineSeries;
    procedure actCopyExecute(Sender: TObject);
    procedure ChartDendrogramClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
  private
    { Dclarations prives }
    FCalc: TCalcHAC;
    procedure drawDendro(Sender: TObject);
    procedure drawToLeaves(node: TNodeHAC);
  public
    { Dclarations publiques }
    procedure   PrepareView(); override;
    function    getAdditionalInfoForReport(): string; override;
  end;

var
  frmOpViewCatVarClusHAC: TfrmOpViewCatVarClusHAC;

implementation

{$R *.dfm}

procedure TfrmOpViewCatVarClusHAC.actCopyExecute(Sender: TObject);
begin
 if (self.pgctrlFond.ActivePage = self.tabHTML)
  then inherited
  else
   if (self.pgctrlFond.ActivePage = self.tabDendrogram)
    then chartDendrogram.CopyToClipboardMetafile(false)
    else chartAggreg.CopyToClipboardMetafile(false);
end;

procedure TfrmOpViewCatVarClusHAC.ChartDendrogramClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var coord: TPoint;
begin
 if (Series = dendrogram) and (ValueIndex >= 0)
  then
   begin
    coord:= chartDendrogram.ClientToScreen(point(X,Y));
    messageHint.ShowMessage(dendrogram.ValueMarkText[ValueIndex],coord.X,coord.Y);
   end;
end;

procedure TfrmOpViewCatVarClusHAC.drawDendro(Sender: TObject);
begin
 chartDendrogram.Canvas.Pen.Color:= clBlue;
 chartDendrogram.Canvas.Pen.Width:= 2;
 self.drawToLeaves(FCalc.SetNodeHAC.RootNode);
end;

procedure TfrmOpViewCatVarClusHAC.drawToLeaves(node: TNodeHAC);
var sommet,left,right: TPoint;

   function coord(node: TNodeHAC): TPoint;
   begin
    result:= Point(dendrogram.CalcXPosValue(node.XPos),dendrogram.CalcYPosValue(node.YPos));
   end;

begin
 //pas une feuille ?
 if not(node.isLeaf())
  then
   begin
    sommet:= coord(node);
    left:= coord(node.ChildL);
    right:= coord(node.ChildR);
    chartDendrogram.Canvas.Line(sommet.X,sommet.Y,left.X,sommet.Y);
    chartDendrogram.Canvas.Line(left.X,sommet.Y,left.X,left.Y);
    chartDendrogram.Canvas.Line(sommet.X,sommet.Y,right.X,sommet.Y);
    chartDendrogram.Canvas.Line(right.X,sommet.Y,right.X,right.Y);
    //dessiner sur les feuilles
    self.drawToLeaves(node.ChildL);
    self.drawToLeaves(node.ChildR);
   end;
end;

function TfrmOpViewCatVarClusHAC.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Dendrogram</H3>';
 s:= s + self.addChartToReport(chartDendrogram);
 s:= s + '<H3>Aggregation levels</H3>';
 s:= s + self.addChartToReport(chartAggreg);
 result:= s;
end;

procedure TfrmOpViewCatVarClusHAC.PrepareView;
var i: integer;
    node: TNodeHAC;
begin
 inherited;
 //rcuprer l'oprateur de calcul -- bien transtyper pour prvenir les erreurs
 FCalc:= (self.Operator as TOpCatVarClusHCA).Calc as TCalcHAC;
 //modifier la page active
 self.pgctrlFond.ActivePage:= self.tabHTML;
 //remplir le graphique
 dendrogram.Clear();
 for i:= 0 to pred(FCalc.SetNodeHAC.getCountNodes()) do
  begin
   node:= FCalc.SetNodeHAC.getNode(i);
   if node.isCluster
    then dendrogram.AddXY(node.XPos,node.YPos,node.getLabel(),clWhite)
    else dendrogram.AddXY(node.XPos,node.YPos,node.getLabel(),clBlue);
  end;
 //gestionnaire de dessin du dendrogramme
 //dendrogram.AfterDrawValues:= drawDendro;
 //>>new -- 19/07/2006 -- pas mal a, on distingue mieux les noeuds !!!
 dendrogram.BeforeDrawValues:= drawDendro;
 //new - 14/12/2013 - ajouter les niveaux d'agrgation
 SeriesAggreg.Clear();
 for i:= 1 to pred(length(FCalc.TabIndex)) do
  SeriesAggreg.AddXY(i,FCalc.TabIndex[i]);
end;

end.
