(*****************************************************************************)
(* UFrmOpViewMultipleScatterplot.pas - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(*****************************************************************************)

unit UFrmOpViewMultipleScatterplot;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ExtCtrls, OleCtrls,
  ComCtrls, TeEngine, Series, TeeProcs, Chart, UCompViewMultipleScatter;

type
  TFrmOpViewMultipleScatterplot = class(TFrmBaseOperator)
    tabChart: TTabSheet;
    chart: TChart;
    N1: TMenuItem;
    Jitter1: TMenuItem;
    procedure actCopyExecute(Sender: TObject);
    procedure Jitter1Click(Sender: TObject);
  private
    {pointeur sur l'oprateur associ}
    FOpMS: TOpMultipleScatter;
    //new - 07/06/2012 - le min et max en abcisse et ordonne
    x1Min, x1Max, x2Min, x2Max: double;
    {crer un scatterplot  nos spcifications}
    function    CreateScatterplot(): TPointSeries;
    //new - 07/06/2012
    procedure   ShowPoints(jitter: boolean = false);
  public
    procedure   PrepareView(); override;
    function    getAdditionalInfoForReport(): string; override;
  end;

var
  FrmOpViewMultipleScatterplot: TFrmOpViewMultipleScatterplot;

implementation

uses
    Math, UCalcStatDesConditionnalDesc, UCalcStatDes, UDatasetDefinition;

const
    JITTER_FACTOR : double = 0.04;

{$R *.dfm}

{ TFrmOpViewMultipleScatterplot }

function TFrmOpViewMultipleScatterplot.CreateScatterplot: TPointSeries;
var sc: TPointSeries;
begin
 sc:= TPointSeries.Create(self);
 sc.Pointer.HorizSize:= 4;
 sc.Pointer.VertSize:= 4;
 sc.Pointer.Style:= psCircle;
 sc.SeriesColor:= clTeeColor;
 sc.Marks.Visible:= TRUE;
 sc.Marks.Style:= smsLabel;
 //renvoyer le pointeur
 result:= sc;
end;

procedure TFrmOpViewMultipleScatterplot.PrepareView;
begin
 self.x1Min:= Math.MaxDouble;
 self.x1Max:= -1.0 * Math.MaxDouble;
 self.x2Min:= Math.MaxDouble;
 self.x2Max:= -1.0 * Math.MaxDouble;
 self.ShowPoints(false);
end;

procedure TFrmOpViewMultipleScatterplot.actCopyExecute(Sender: TObject);
begin
 chart.CopyToClipboardMetafile(false);
end;

function TFrmOpViewMultipleScatterplot.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Multiple Scatterplot</H3>';
 s:= s + self.addChartToReport(chart);
 result:= s;
end;

procedure TFrmOpViewMultipleScatterplot.ShowPoints(jitter: boolean);
var i,j: integer;
    cX1,cX2: TCalcSDCondDesc;
    scatter: TPointSeries;
    y: TAttribute;
    m1,m2: double;
begin
 //rcuprer le pointeur
 FOpMS:= Operator as TOpMultipleScatter;
 //prparer le graphique
 if assigned(FOpMS.X1) and assigned(FOpMS.X2)
  then
   begin
    chart.Title.Text.Text:= format('%s vs %s',[FOpMS.X1.Name,FOpMS.X2.Name]);
    chart.BottomAxis.Title.Caption:= FOpMS.X1.Name;
    chart.LeftAxis.Title.Caption:= FOpMS.X2.Name;
    for i:= 0 to pred(FOpMS.LstX1.Count) do
     begin
      cX1:= TCalcSDCondDesc(FOpMS.LstX1.Stat(i));
      cX2:= TCalcSDCondDesc(FOpMS.LstX2.Stat(i));
      y:= cX1.AttDescription;//forcment discret donc
      scatter:= self.CreateScatterplot();
      scatter.Title:= y.Name;
      //ajouter les points
      for j:= 0 to pred(y.nbValues) do
       begin
        m1:= cX1.StatCond[j].Average;
        m2:= cX2.StatCond[j].Average;
        //forcment au premier passage, on rentre dans le IF
        if (jitter = false)
         then
          begin
           self.x1Min:= Min(self.x1Min,m1);
           self.x1Max:= Max(self.x1Max,m1);
           self.x2Min:= Min(self.x2Min,m2);
           self.x2Max:= Max(self.x2Max,m2);
          end
         //jittering
         else
          begin
           m1:= m1 + (0.5 - random)*JITTER_FACTOR*(self.x1Max - self.x1Min);
           m2:= m2 + (0.5 - random)*JITTER_FACTOR*(self.x2Max - self.x2Min);
          end;
         scatter.AddXY(m1,m2,format('%s=%s',[y.Name,y.LstValues.getDescription(succ(j))]));
       end;
      chart.AddSeries(scatter);
      scatter.Marks.BackColor:= scatter.SeriesColor;
     end;
   end
  else chart.Title.Text.Text:= 'no information available, use define status for attribute selection';
end;

procedure TFrmOpViewMultipleScatterplot.Jitter1Click(Sender: TObject);
begin
 self.chart.SeriesList.Clear();
 self.ShowPoints(true);
end;

end.
