unit UFrmOpScatterLegend;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBaseOperator, Menus, ActnList, ComCtrls, ExtCtrls, StdCtrls,
  TeEngine, Series, TeeProcs, Chart, UDatasetImplementation;

type
  TFrmOpViewScatterLegend = class(TFrmBaseOperator)
    Panel1: TPanel;
    Panel2: TPanel;
    panelChart: TPanel;
    chart: TChart;
    Series1: TPointSeries;
    cmbX2: TComboBox;
    cmbX1: TComboBox;
    gbLegend: TGroupBox;
    rbExampleId: TRadioButton;
    rbXYValues: TRadioButton;
    rbAttribute: TRadioButton;
    cmbAttribute: TComboBox;
    Label1: TLabel;
    Panel3: TPanel;
    TabSheet1: TTabSheet;
    actFontIn: TAction;
    actFontOut: TAction;
    N1: TMenuItem;
    actFontIn1: TMenuItem;
    actFontOut1: TMenuItem;
    N2: TMenuItem;
    Jitter1: TMenuItem;
    procedure cmbX1Change(Sender: TObject);
    procedure rbExampleIdClick(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
    procedure actFontInExecute(Sender: TObject);
    procedure actFontOutExecute(Sender: TObject);
    procedure Jitter1Click(Sender: TObject);
  private
    { Dclarations prives }
    //donnes  visualiser
    FData: TMLDataset;
    //rafrachissement  la vole ?
    FOkRefresh: boolean;
    //new - 07/06/2012 - le min et max en abcisse et ordonne
    x1Min, x1Max, x2Min, x2Max: double;
    //recalculer le graphique - new - 07/06/2012 - avec Jitter
    procedure   RefreshChart(jitter: boolean = false);
    //raz des min/max
    procedure   resetMinMax();
    //gestionnaire d'affichage des marques
    procedure GetMark(Sender : TChartSeries; ValueIndex : Longint;  Var MarkText : String);
  public
    { Dclarations publiques }
    //prparation de l'affichage
    procedure   PrepareView(); override;
    function getAdditionalInfoForReport: string; override;
  end;

var
  FrmOpViewScatterLegend: TFrmOpViewScatterLegend;

implementation

uses
    UCompViewScatterPlotLegend, UDatasetDefinition,Math;

CONST
    JITTER_FACTOR : double = 0.1;

{$R *.dfm}

{ TFrmOpViewScatterLegend }

procedure TFrmOpViewScatterLegend.PrepareView;
var j: integer;
    att: TAttribute;
begin
 //connecter les donnes
 FData:= (Operator as TOpScatterPlotLegend).Workdata;
 //dimensionner la srie
 self.Series1.FillSampleValues(FData.Examples.Size);
 //lister les variables discrtes
 for j:= 0 to pred(FData.LstAtts[asAll].Count) do
  begin
   att:= FData.LstAtts[asAll].Attribute[j];
   if att.isCategory(caContinue)
    then
     begin
      cmbX1.Items.AddObject(att.Name,att);
      cmbX2.Items.AddObject(att.Name,att);
     end
    else cmbAttribute.Items.AddObject(att.Name,att);
  end;
 //tester si pas de variables discrtes
 if (cmbAttribute.Items.Count = 0)
  then
   begin
    cmbAttribute.Enabled:= false;
    self.rbAttribute.Enabled:= false;
   end
  else cmbAttribute.ItemIndex:= 0;
 FOkRefresh:= FALSE;
 //provoquer la premire slection
 cmbX1.ItemIndex:= 0;
 cmbX2.ItemIndex:= 0;
 //rafrachir l'affichage
 FOkRefresh:= TRUE;
 self.RefreshChart(false);
 //brancher le gestionnaire d'vnement
 self.Series1.OnGetMarkText:= GetMark;
end;

procedure TFrmOpViewScatterLegend.RefreshChart(jitter: boolean = false);
var att1, att2: TAttribute;
    example,i: integer;
    x1, x2: double;
begin
 if (jitter = false) then self.resetMinMax();
 att1:= cmbX1.Items.Objects[cmbX1.ItemIndex] as TAttribute;
 att2:= cmbX2.Items.Objects[cmbX2.ItemIndex] as TAttribute;
 self.chart.Title.Text.Text:= att1.Name + ' vs. ' + att2.Name;
 chart.BottomAxis.Title.Caption:= att1.Name;
 chart.LeftAxis.Title.Caption:= att2.Name;
 for i:= 1 to FData.Examples.Size do
  begin
   example:= FData.Examples.Number[i];
   x1:= att1.cValue[example];
   x2:= att2.cValue[example];
   if (jitter = false)
    then
     begin
      x1Min:= Min(self.x1Min,x1);
      x2Min:= Min(self.x2Min,x2);
      x1Max:= Max(self.x1Max,x1);
      x2Max:= Max(self.x2Max,x2);
     end
    else
     begin
      x1:= x1 + (0.5 - random)*JITTER_FACTOR*(self.x1Max - self.x1Min);
      x2:= x2 + (0.5 - random)*JITTER_FACTOR*(self.x2Max - self.x2Min);
     end;
   series1.XValue[pred(i)]:= x1;
   series1.YValue[pred(i)]:= x2;
  end;
end;

procedure TFrmOpViewScatterLegend.cmbX1Change(Sender: TObject);
begin
 if (FOkRefresh = true)
  then self.RefreshChart();
end;

procedure TFrmOpViewScatterLegend.GetMark(Sender: TChartSeries;
  ValueIndex: Integer; var MarkText: String);
var att: TAttribute;
    id: integer;
begin
 //ID ?
 if (self.rbExampleId.Checked = true)
  then MarkText:= IntToStr(FData.Examples.Number[succ(ValueIndex)])
  else
   begin
    //valeur X, Y ?
    if (self.rbXYValues.Checked = true)
     then MarkText:= Format('%.2f ; %.2f',[series1.XValue[ValueIndex],series1.YValue[ValueIndex]])
     else
      //prendre une variable comme ref.
      begin
       id:= FData.Examples.Number[succ(ValueIndex)];
       att:= cmbAttribute.Items.Objects[cmbAttribute.ItemIndex] as TAttribute;
       MarkText:= att.sValue[id];
      end;
   end;
end;

procedure TFrmOpViewScatterLegend.rbExampleIdClick(Sender: TObject);
begin
 //demander le rafrachissement de l'affichage
 chart.Refresh();
end;

procedure TFrmOpViewScatterLegend.actCopyExecute(Sender: TObject);
begin
 chart.CopyToClipboardMetafile(false);
end;

procedure TFrmOpViewScatterLegend.actFontInExecute(Sender: TObject);
begin
 self.Series1.Marks.Font.Size:= self.Series1.Marks.Font.Size + 1;
end;

procedure TFrmOpViewScatterLegend.actFontOutExecute(Sender: TObject);
begin
 self.Series1.Marks.Font.Size:= self.Series1.Marks.Font.Size - 1;
end;

function TFrmOpViewScatterLegend.getAdditionalInfoForReport: string;
var s: string;
begin
 //titre
 s:= '<H3>Scatter plot with labels</H3>';
 s:= s + self.addChartToReport(chart);
 result:= s;
end;

procedure TFrmOpViewScatterLegend.resetMinMax;
begin
 self.x1Min:= Math.MaxDouble;
 self.x1Max:= -1.0 * Math.MaxDouble;
 self.x2Min:= Math.MaxDouble;
 self.x2Max:= -1.0 * Math.MaxDouble;
end;

procedure TFrmOpViewScatterLegend.Jitter1Click(Sender: TObject);
begin
 self.RefreshChart(true);
end;

end.
