(*******************************************************)
(* TANAGRA.DPR - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(*******************************************************)

{
@abstract(Gestionnaire de projet TANAGRA)
@author(Ricco)
@created(12/01/2004)
Fichier principal du projet TANAGRA.
}
program Tanagra;

uses
  FastMM4 in '..\CommonStructures\FastMM\FastMM4.pas',
  FastMM4Messages in '..\CommonStructures\FastMM\FastMM4Messages.pas',
  Forms,
  Controls,
  UConstConfiguration in 'Constants\UConstConfiguration.pas',
  UExperiments in '..\CommonStructures\Experiments\UExperiments.pas',
  UFrmBase in '..\CommonStructures\Forms\UFrmBase.pas' {FrmBase},
  UFrmMainForm in 'UFrmMainForm.pas' {FrmMain},
  UCompDefinition in '..\Diagram\MLComponents\UCompDefinition.pas',
  UFrmPaletteGenComponents in 'PaletteDefinition\UFrmPaletteGenComponents.pas' {FrmPaletteComp},
  UPaletteGenCompDefinition in 'PaletteDefinition\UPaletteGenCompDefinition.pas',
  UCompTest in '..\Diagram\MLComponents\UCompTest.pas',
  UFrmDiagramManager in '..\Diagram\Manager\UFrmDiagramManager.pas' {FrmDiagramManager},
  UDatasetDefinition in '..\CommonStructures\Dataset\UDatasetDefinition.pas',
  UDatasetImplementation in '..\CommonStructures\Dataset\UDatasetImplementation.pas',
  UOperatorDefinition in '..\Diagram\MLComponents\UOperatorDefinition.pas',
  UDlgBase in '..\CommonStructures\Forms\UDlgBase.pas' {DlgBase},
  UDlgBaseOperatorParameter in '..\Diagram\MLComponents\UDlgBaseOperatorParameter.pas' {DlgBaseOperatorParameter},
  UDlgDatasetDownload in '..\Diagram\Manager\UDlgDatasetDownload.pas' {DlgDatasetDownload},
  UDataAccessDefinition in '..\CommonStructures\Dataset\UDataAccessDefinition.pas',
  UDataAccessTextFile in '..\CommonStructures\Dataset\UDataAccessTextFile.pas',
  ULogFile in '..\CommonStructures\LogFile\ULogFile.pas',
  UCompDataset in '..\Diagram\MLComponents\Dataset\UCompDataset.pas',
  UDlgOpPrmDataset in '..\Diagram\MLComponents\Dataset\UDlgOpPrmDataset.pas' {DlgOpPrmDataset},
  UFrmBaseOperator in '..\Diagram\MLComponents\UFrmBaseOperator.pas' {FrmBaseOperator},
  UCompManageDataset in '..\Diagram\MLComponents\UCompManageDataset.pas',
  UCompViewDataset in '..\Diagram\MLComponents\ViewDataset\UCompViewDataset.pas',
  UDlgOpPrmViewData in '..\Diagram\MLComponents\ViewDataset\UDlgOpPrmViewData.pas' {DlgOpPrmViewData},
  UFrmOpViewData in '..\Diagram\MLComponents\ViewDataset\UFrmOpViewData.pas' {FrmOpViewData},
  UDatasetExamples in '..\CommonStructures\Dataset\UDatasetExamples.pas',
  UCompISSampling in '..\Diagram\MLComponents\InstanceSelection\UCompISSampling.pas',
  UDlgOpPrmSampling in '..\Diagram\MLComponents\InstanceSelection\UDlgOpPrmSampling.pas' {DlgOpPrmSampling},
  UCompISDefinition in '..\Diagram\MLComponents\InstanceSelection\UCompISDefinition.pas',
  UIOFastTextFileAccess in '..\CommonStructures\Buffering\UIOFastTextFileAccess.pas',
  UIOFastBufferedWriter in '..\CommonStructures\Buffering\UIOFastBufferedWriter.pas',
  UCompSDUnivariateContinuousAtt in '..\Diagram\MLComponents\DescriptiveStat\UCompSDUnivariateContinuousAtt.pas',
  UDlgOpPrmUnivStatDesCont in '..\Diagram\MLComponents\DescriptiveStat\UDlgOpPrmUnivStatDesCont.pas' {DlgOpPrmUnivStatDesCont},
  UCalcStatDes in '..\CommonStructures\StatDes\UCalcStatDes.pas',
  UCalcDistribution in '..\CommonStructures\VecTab\UCalcDistribution.pas',
  UCompSDUnivariateDiscreteAtt in '..\Diagram\MLComponents\DescriptiveStat\UCompSDUnivariateDiscreteAtt.pas',
  UDlgOpPrmUnivStatDesDisc in '..\Diagram\MLComponents\DescriptiveStat\UDlgOpPrmUnivStatDesDisc.pas' {DlgOpPrmUnivStatDesDisc},
  UMLDiagramDrawing in '..\Diagram\Manager\UMLDiagramDrawing.pas',
  GIFImage in '..\CommonStructures\Gif\GIFImage.pas',
  UMLDiagramReport in '..\Diagram\Manager\UMLDiagramReport.pas',
  UCompFCDefinition in '..\Diagram\MLComponents\FeatureConstruction\UCompFCDefinition.pas',
  UCalcP10Build in '..\CommonStructures\ParserFormula\UCalcP10Build.pas',
  UCalcParser10 in '..\CommonStructures\ParserFormula\UCalcParser10.pas',
  UCompFCFormula in '..\Diagram\MLComponents\FeatureConstruction\ContinuousFormula\UCompFCFormula.pas',
  UDlgOpPrmFormulaContinuous in '..\Diagram\MLComponents\FeatureConstruction\ContinuousFormula\UDlgOpPrmFormulaContinuous.pas' {DlgOpPrmFormulaContinuous},
  UCompFSDefinition in '..\Diagram\MLComponents\FeatureSelection\UCompFSDefinition.pas',
  UCompFSDefineStatus in '..\Diagram\MLComponents\FeatureSelection\DefineAttStatus\UCompFSDefineStatus.pas',
  UDlgOpFSDefStatus in '..\Diagram\MLComponents\FeatureSelection\DefineAttStatus\UDlgOpFSDefStatus.pas' {DlgOpPrmFSDefStatus},
  FMath in '..\CommonStructures\AthanorBiblio\fmath.pas',
  Fourier in '..\CommonStructures\AthanorBiblio\fourier.pas',
  MatComp in '..\CommonStructures\AthanorBiblio\matcomp.pas',
  Matrices in '..\CommonStructures\AthanorBiblio\matrices.pas',
  MCMC in '..\CommonStructures\AthanorBiblio\mcmc.pas',
  Optim in '..\CommonStructures\AthanorBiblio\optim.pas',
  PaString in '..\CommonStructures\AthanorBiblio\pastring.pas',
  Polynom in '..\CommonStructures\AthanorBiblio\polynom.pas',
  Random in '..\CommonStructures\AthanorBiblio\random.pas',
  Stat in '..\CommonStructures\AthanorBiblio\stat.pas',
  Eigen in '..\CommonStructures\AthanorBiblio\eigen.pas',
  UCompRegDefinition in '..\Diagram\MLComponents\Regression\UCompRegDefinition.pas',
  UCompRegMultiple in '..\Diagram\MLComponents\Regression\MultipleRegression\UCompRegMultiple.pas',
  Models in '..\CommonStructures\AthanorBiblio\reg\models.pas',
  FitPower in '..\CommonStructures\AthanorBiblio\reg\fitpower.pas',
  FitExLin in '..\CommonStructures\AthanorBiblio\reg\fitexlin.pas',
  FitExpo in '..\CommonStructures\AthanorBiblio\reg\fitexpo.pas',
  FitFrac in '..\CommonStructures\AthanorBiblio\reg\fitfrac.pas',
  FitHill in '..\CommonStructures\AthanorBiblio\reg\fithill.pas',
  FitIExpo in '..\CommonStructures\AthanorBiblio\reg\fitiexpo.pas',
  FitLin in '..\CommonStructures\AthanorBiblio\reg\fitlin.pas',
  FitLogis in '..\CommonStructures\AthanorBiblio\reg\fitlogis.pas',
  FitMich in '..\CommonStructures\AthanorBiblio\reg\fitmich.pas',
  FitMult in '..\CommonStructures\AthanorBiblio\reg\fitmult.pas',
  FitPKa in '..\CommonStructures\AthanorBiblio\reg\fitpka.pas',
  FitPoly in '..\CommonStructures\AthanorBiblio\reg\fitpoly.pas',
  UStringAddBuffered in '..\CommonStructures\Buffering\UStringAddBuffered.pas',
  UCalcStatDesConditionnalDesc in '..\CommonStructures\StatDes\UCalcStatDesConditionnalDesc.pas',
  UCompSDOneWayAnova in '..\Diagram\MLComponents\DescriptiveStat\OneWayAnova\UCompSDOneWayAnova.pas',
  UCompSDDefinition in '..\Diagram\MLComponents\DescriptiveStat\UCompSDDefinition.pas',
  UDlgOpPrmSDOneWayAnova in '..\Diagram\MLComponents\DescriptiveStat\OneWayAnova\UDlgOpPrmSDOneWayAnova.pas' {DlgOpPrmOneWayAnova},
  UCalcCrossTab in '..\CommonStructures\VecTab\UCalcCrossTab.pas',
  UCalcStatDesCrossTab in '..\CommonStructures\StatDes\UCalcStatDesCrossTab.pas',
  UCompSDCrossTabutation in '..\Diagram\MLComponents\DescriptiveStat\CrossTabAnalysis\UCompSDCrossTabutation.pas',
  UCalcMatrixAdditionalFunctions in '..\CommonStructures\VecMatrix\UCalcMatrixAdditionalFunctions.pas',
  UCalcMatrixToAttributes in '..\CommonStructures\VecMatrix\UCalcMatrixToAttributes.pas',
  UCompFADefinition in '..\Diagram\MLComponents\FactorialAnalysis\UCompFADefinition.pas',
  UCompFactAnalysisPCA in '..\Diagram\MLComponents\FactorialAnalysis\ACP\UCompFactAnalysisPCA.pas',
  UCompFactAnalysisMCA in '..\Diagram\MLComponents\FactorialAnalysis\AFCM\UCompFactAnalysisMCA.pas',
  UCompViewScatterPlot in '..\Diagram\MLComponents\ViewDataset\ScatterPlot\UCompViewScatterPlot.pas',
  UFrmOpScatterplot in '..\Diagram\MLComponents\ViewDataset\ScatterPlot\UFrmOpScatterplot.pas' {FrmOpViewDataScatterplot},
  UCompSDKruskalWallis in '..\Diagram\MLComponents\DescriptiveStat\KruskalWallisTest\UCompSDKruskalWallis.pas',
  UCompViewMultipleScatter in '..\Diagram\MLComponents\ViewDataset\MultipleScatterPlot\UCompViewMultipleScatter.pas',
  UFrmOpViewMultipleScatterplot in '..\Diagram\MLComponents\ViewDataset\MultipleScatterPlot\UFrmOpViewMultipleScatterplot.pas' {FrmOpViewMultipleScatterplot},
  UCompSpvLDefinition in '..\Diagram\MLComponents\SpvLearning\UCompSpvLDefinition.pas',
  UCompSpvLTest in '..\Diagram\MLComponents\SpvLearning\UCompSpvLTest.pas',
  UDlgMetaSpvTest in '..\Diagram\MLComponents\SpvLearning\UDlgMetaSpvTest.pas' {DlgOpPrmMetaSpvTest},
  UDlgSpvTest in '..\Diagram\MLComponents\SpvLearning\UDlgSpvTest.pas' {DlgOpPrmSpv},
  UCompMetaSpvOneInstance in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvOneInstance.pas',
  UCompSpvNaiveBayes in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\NaiveBayes\UCompSpvNaiveBayes.pas',
  UCompSpvDiscriminantAnalysis in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DiscriminantAnalysis\UCompSpvDiscriminantAnalysis.pas',
  UCompSpvAssesDefinition in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\UCompSpvAssesDefinition.pas',
  UCompSpvAssesTrainTest in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\TrainTest\UCompSpvAssesTrainTest.pas',
  UCompSpvLogisticRegression in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LogisticRegression\UCompSpvLogisticRegression.pas',
  Regress in '..\CommonStructures\AthanorBiblio\regress.pas',
  OptimObject in '..\CommonStructures\AthanorBiblio\OptimObject.pas',
  UDlgAboutBox in 'UDlgAboutBox.pas' {DlgAboutBox},
  UDlgOpPrmSDCrossTabulation in '..\Diagram\MLComponents\DescriptiveStat\CrossTabAnalysis\UDlgOpPrmSDCrossTabulation.pas' {DlgOpPrmSDCrossTab},
  UCalcStatDesCorrelation in '..\CommonStructures\StatDes\UCalcStatDesCorrelation.pas',
  UCompSDLinearCorrelation in '..\Diagram\MLComponents\DescriptiveStat\LinearCorrelation\UCompSDLinearCorrelation.pas',
  UDlgOpPrmSDLinearCorrelation in '..\Diagram\MLComponents\DescriptiveStat\LinearCorrelation\UDlgOpPrmSDLinearCorrelation.pas' {DlgOpPrmLinearCorrelation},
  UCompViewCorrelationScatter in '..\Diagram\MLComponents\ViewDataset\CorrelationScatterplot\UCompViewCorrelationScatter.pas',
  UFrmOpViewCorrelationScatterplot in '..\Diagram\MLComponents\ViewDataset\CorrelationScatterplot\UFrmOpViewCorrelationScatterplot.pas' {FrmOpViewCorrelationScatterplot},
  UDlgOpPrmPCA in '..\Diagram\MLComponents\FactorialAnalysis\ACP\UDlgOpPrmPCA.pas' {DlgOpPrmPCA},
  UDlgOpPrmMCA in '..\Diagram\MLComponents\FactorialAnalysis\AFCM\UDlgOpPrmMCA.pas' {DlgOpPrmMCA},
  UDlgOpPrmTrainTest in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\TrainTest\UDlgOpPrmTrainTest.pas' {DlgOpPrmAssesTrainTest},
  UCalcRulesDefinition in '..\CommonStructures\RulesAndTrees\UCalcRulesDefinition.pas',
  UCalcTreeStructureDefinition in '..\CommonStructures\RulesAndTrees\UCalcTreeStructureDefinition.pas',
  UCalcSpvTreeDefinition in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCalcSpvTreeDefinition.pas',
  UCompSpvTreeID3 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCompSpvTreeID3.pas',
  UDlgOpPrmSpvTreeID3 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UDlgOpPrmSpvTreeID3.pas' {DlgOpPrmSpvTreeID3},
  UCalcStatDesGroupCaracterization in '..\CommonStructures\StatDes\UCalcStatDesGroupCaracterization.pas',
  UCompSDGroupCaracterization in '..\Diagram\MLComponents\DescriptiveStat\GroupCaracterization\UCompSDGroupCaracterization.pas',
  UCompClusteringDefinition in '..\Diagram\MLComponents\Clustering\UCompClusteringDefinition.pas',
  UCompClusteringKMeans in '..\Diagram\MLComponents\Clustering\KMeans\UCompClusteringKMeans.pas',
  UDlgOpClusKMeans in '..\Diagram\MLComponents\Clustering\KMeans\UDlgOpClusKMeans.pas' {DlgOpPrmClusKMeans},
  UCompClusteringSOM in '..\Diagram\MLComponents\Clustering\KohonenSOM\UCompClusteringSOM.pas',
  UDlgOpPrmClusteringSOM in '..\Diagram\MLComponents\Clustering\KohonenSOM\UDlgOpPrmClusteringSOM.pas' {DlgOpPrmClusKohonenSOM},
  UStringsResources in '..\CommonStructures\Strings\UStringsResources.pas',
  UCompExportDataset in '..\Diagram\MLComponents\ViewDataset\ExportDataset\UCompExportDataset.pas',
  UDlgOpPrmExportData in '..\Diagram\MLComponents\ViewDataset\ExportDataset\UDlgOpPrmExportData.pas' {DlgOpPrmExportDataset},
  UCompISStratifiedSampling in '..\Diagram\MLComponents\InstanceSelection\StratifiedSampling\UCompISStratifiedSampling.pas',
  UDlgOpPrmStratSampling in '..\Diagram\MLComponents\InstanceSelection\StratifiedSampling\UDlgOpPrmStratSampling.pas' {DlgOpPrmStratSampling},
  UCompISRecoverExamples in '..\Diagram\MLComponents\InstanceSelection\RecoverExamples\UCompISRecoverExamples.pas',
  UDlgOpPrmISRecoverExamples in '..\Diagram\MLComponents\InstanceSelection\RecoverExamples\UDlgOpPrmISRecoverExamples.pas' {DlgOpPrmISRecoverExamples},
  UCompSpvMLPerceptron in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\MLP\UCompSpvMLPerceptron.pas',
  UCalcSpvMLPStructure in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\MLP\UCalcSpvMLPStructure.pas',
  UCompSpvRBF in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\RBF\UCompSpvRBF.pas',
  UDlgOpPrmSpvMLP in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\MLP\UDlgOpPrmSpvMLP.pas' {DlgOpPrmSpvMLP},
  UDlgOpPrmSpvRBF in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\RBF\UDlgOpPrmSpvRBF.pas' {DlgOpPrmSpvRBF},
  UCompSpvAssesCrossValidation in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\CrossValidation\UCompSpvAssesCrossValidation.pas',
  UDlgOpPrmSpvAssesCV in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\CrossValidation\UDlgOpPrmSpvAssesCV.pas' {DlgOpPrmSpvAssesCV},
  UCompMetaSpvCommitte in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvCommitte.pas',
  UCompMetaSpvBagging in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvBagging.pas',
  UCompMetaSpvArcing in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvArcing.pas',
  UCompMetaSpvBoosting in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvBoosting.pas',
  UDlgOprmMetaSpvCommittee in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UDlgOprmMetaSpvCommittee.pas' {DlgOpPrmSpvMetaCommittee},
  UCompSpvKNN in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\KNN\UCompSpvKNN.pas',
  UCompSpvPrototypeNN in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\PrototypeNN\UCompSpvPrototypeNN.pas',
  UDlgOpPrmSpvKNN in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\KNN\UDlgOpPrmSpvKNN.pas' {DlgOpPrmSpvKNN},
  UDlgOpPrmSpvPrototypeNN in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\PrototypeNN\UDlgOpPrmSpvPrototypeNN.pas' {DlgOpPrmSpvPrototypeNN},
  UCompClusteringLVQ in '..\Diagram\MLComponents\Clustering\LVQ\UCompClusteringLVQ.pas',
  UDlgOpPrmClusteringLVQ in '..\Diagram\MLComponents\Clustering\LVQ\UDlgOpPrmClusteringLVQ.pas' {DlgOpPrmClusteringLVQ},
  LiteUn2 in '..\CommonStructures\HtmlLite\package\LiteUn2.pas',
  LiteDith in '..\CommonStructures\HtmlLite\package\LiteDith.pas',
  litegif1 in '..\CommonStructures\HtmlLite\package\litegif1.pas',
  litegif2 in '..\CommonStructures\HtmlLite\package\litegif2.pas',
  LitePars in '..\CommonStructures\HtmlLite\package\LitePars.pas',
  LiteSbs1 in '..\CommonStructures\HtmlLite\package\LiteSbs1.pas',
  LiteSubs in '..\CommonStructures\HtmlLite\package\LiteSubs.pas',
  HTMLLite in '..\CommonStructures\HtmlLite\package\HTMLLite.pas',
  UCompAssociationRuleDefinition in '..\Diagram\MLComponents\AssociationRule\UCompAssociationRuleDefinition.pas',
  UCompAssocRuleAPriori in '..\Diagram\MLComponents\AssociationRule\UCompAssocRuleAPriori.pas',
  EzdslBAr in '..\CommonStructures\EZDSL\EZDSLBAR.PAS',
  EZDSLBse in '..\CommonStructures\EZDSL\EZDSLBSE.PAS',
  EZDSLBtr in '..\CommonStructures\EZDSL\EZDSLBTR.PAS',
  EZDSLCol in '..\CommonStructures\EZDSL\EZDSLCOL.PAS',
  EZDSLCts in '..\CommonStructures\EZDSL\EZDSLCTS.PAS',
  EZDSLDbl in '..\CommonStructures\EZDSL\EZDSLDBL.PAS',
  EZDSLHsh in '..\CommonStructures\EZDSL\EZDSLHSH.PAS',
  EZDSLLst in '..\CommonStructures\EZDSL\EZDSLLST.PAS',
  EZDSLPQu in '..\CommonStructures\EZDSL\EZDSLPQU.PAS',
  EZDSLQue in '..\CommonStructures\EZDSL\EZDSLQUE.PAS',
  EZDSLRnd in '..\CommonStructures\EZDSL\EZDSLRND.PAS',
  EZDSLSkp in '..\CommonStructures\EZDSL\EZDSLSKP.PAS',
  EZDSLStk in '..\CommonStructures\EZDSL\EZDSLSTK.PAS',
  EZDSLSup in '..\CommonStructures\EZDSL\EZDSLSUP.PAS',
  EZDSLThd in '..\CommonStructures\EZDSL\EZDSLTHD.PAS',
  EZIntQue in '..\CommonStructures\EZDSL\EZINTQUE.PAS',
  EZLngStk in '..\CommonStructures\EZDSL\EZLNGSTK.PAS',
  EZStrStk in '..\CommonStructures\EZDSL\EZSTRSTK.PAS',
  UCalcAssocStructure in '..\Diagram\MLComponents\AssociationRule\UCalcAssocStructure.pas',
  UDlgOpPrmAssociationRule in '..\Diagram\MLComponents\AssociationRule\UDlgOpPrmAssociationRule.pas' {DlgOpPrmAssociationRule},
  LibXmlParser in '..\CommonStructures\XmlParser\LibXmlParser.pas',
  UCalcRndGenerator in '..\CommonStructures\Random\UCalcRndGenerator.pas',
  UDlgLicense in 'UDlgLicense.pas' {DlgLicense},
  UCompClusteringHAC in '..\Diagram\MLComponents\Clustering\HAC\UCompClusteringHAC.pas',
  UDlgOpClusHAC in '..\Diagram\MLComponents\Clustering\HAC\UDlgOpClusHAC.pas' {DlgOpPrmClusHAC},
  UCompFCDiscDefinition in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UCompFCDiscDefinition.pas',
  UCompFCDiscEqWidth in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UCompFCDiscEqWidth.pas',
  UCompFCDiscEqFreq in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UCompFCDiscEqFreq.pas',
  UDlgOpPrmDiscEqWidth in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UDlgOpPrmDiscEqWidth.pas' {DlgOpPrmDiscEqWidth},
  UDlgOpPrmDiscEqFreq in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UDlgOpPrmDiscEqFreq.pas' {DlgOpPrmDiscEqFreq},
  UCompFCStandardize in '..\Diagram\MLComponents\FeatureConstruction\Standardize\UCompFCStandardize.pas',
  UDlgOpPrmFCStandardize in '..\Diagram\MLComponents\FeatureConstruction\Standardize\UDlgOpPrmFCStandardize.pas' {DlgOpPrmFCStandardize},
  UCompFCDiscMDLPC in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UCompFCDiscMDLPC.pas',
  UCompFCBinarizeDiscreteToContinuous in '..\Diagram\MLComponents\FeatureConstruction\Binarization\UCompFCBinarizeDiscreteToContinuous.pas',
  UCompFSRemoveConstant in '..\Diagram\MLComponents\FeatureSelection\RemoveConstant\UCompFSRemoveConstant.pas',
  UCompFSInputSelection in '..\Diagram\MLComponents\FeatureSelection\UCompFSInputSelection.pas',
  UCompFSUnivariateChi2 in '..\Diagram\MLComponents\FeatureSelection\UnivariateChi2\UCompFSUnivariateChi2.pas',
  UDlgOpFSUnivariateChi2 in '..\Diagram\MLComponents\FeatureSelection\UnivariateChi2\UDlgOpFSUnivariateChi2.pas' {DlgOpPrmUnivChi2},
  UCompFSMifs in '..\Diagram\MLComponents\FeatureSelection\CorrelationBased\UCompFSMifs.pas',
  UDlgOpPrmFSMifs in '..\Diagram\MLComponents\FeatureSelection\CorrelationBased\UDlgOpPrmFSMifs.pas' {DlgOpPrmFSMifs},
  UCalcFSCorrelation in '..\Diagram\MLComponents\FeatureSelection\CorrelationBased\UCalcFSCorrelation.pas',
  UCompFSMerit in '..\Diagram\MLComponents\FeatureSelection\CorrelationBased\UCompFSMerit.pas',
  UCompFSMODTree in '..\Diagram\MLComponents\FeatureSelection\CorrelationBased\UCompFSMODTree.pas',
  UCompFSFcbf in '..\Diagram\MLComponents\FeatureSelection\CorrelationBased\UCompFSFcbf.pas',
  UDlgOpPrmFSFcbf in '..\Diagram\MLComponents\FeatureSelection\CorrelationBased\UDlgOpPrmFSFcbf.pas' {DlgOpPrmFSFcbf},
  UCompAssocRuleAPrioriMR in '..\Diagram\MLComponents\AssociationRule\UCompAssocRuleAPrioriMR.pas',
  UDlgOpPrmAssociationRuleMR in '..\Diagram\MLComponents\AssociationRule\UDlgOpPrmAssociationRuleMR.pas' {DlgOpPrmAssociationRuleMR},
  UCalcStatDesContinuousPlus in '..\CommonStructures\StatDes\UCalcStatDesContinuousPlus.pas',
  UCompSDUnivariateContinuousAttPlus in '..\CommonStructures\StatDes\UCompSDUnivariateContinuousAttPlus.pas',
  MATRIXMM in '..\Diagram\MLComponents\Regression\MultipleRegression\PortageRegress\Matrixmm.pas',
  UDlgOpPrmRegMultiple in '..\Diagram\MLComponents\Regression\MultipleRegression\UDlgOpPrmRegMultiple.pas' {DlgOpPrmRegressionMultiple},
  UFrmOpViewAssocRuleMR in '..\Diagram\MLComponents\AssociationRule\UFrmOpViewAssocRuleMR.pas' {frmOpViewMRAssocRuleViewer},
  UCompAssocRuleSupervised in '..\Diagram\MLComponents\AssociationRule\UCompAssocRuleSupervised.pas',
  UCompFCTrend in '..\Diagram\MLComponents\FeatureConstruction\Trend\UCompFCTrend.pas',
  UDlgOpPrmFCTrend in '..\Diagram\MLComponents\FeatureConstruction\Trend\UDlgOpPrmFCTrend.pas' {DlgOpPrmFCTrend},
  UFrmOpSingleSpvLearning in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UFrmOpSingleSpvLearning.pas' {FrmOpViewSingleSpvLearning},
  UDlgOpPrmAssocRuleSupervised in '..\Diagram\MLComponents\AssociationRule\UDlgOpPrmAssocRuleSupervised.pas' {DlgOpPrmAssociationRuleSpv},
  UCompFSUnivFisher in '..\Diagram\MLComponents\FeatureSelection\UnivariateFisher\UCompFSUnivFisher.pas',
  UDlgOpPrmFSUnivFisher in '..\Diagram\MLComponents\FeatureSelection\UnivariateFisher\UDlgOpPrmFSUnivFisher.pas' {DlgOpPrmFSUnivFisher},
  UBatchExecution in 'UBatchExecution.pas',
  UCalcSpvTreeCART in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCalcSpvTreeCART.pas',
  UCompSpvTreeCART in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCompSpvTreeCART.pas',
  UDlgOpPrmSpvTreeCART in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UDlgOpPrmSpvTreeCART.pas' {dlgOpprmSpvTreeCART},
  UCompFSUnivRuns in '..\Diagram\MLComponents\FeatureSelection\UnivariateRuns\UCompFSUnivRuns.pas',
  UCalcStatDesCondDescRuns in '..\CommonStructures\StatDes\UCalcStatDesCondDescRuns.pas',
  UCompAssocTreeSpv in '..\Diagram\MLComponents\AssociationRule\TreeAssocRule\UCompAssocTreeSpv.pas',
  UCalcAssocTreeSpv in '..\Diagram\MLComponents\AssociationRule\TreeAssocRule\UCalcAssocTreeSpv.pas',
  UDlgOpPrmAssocTreeSpv in '..\Diagram\MLComponents\AssociationRule\TreeAssocRule\UDlgOpPrmAssocTreeSpv.pas' {DlgOpPrmAssocTreeSpv},
  UCompISAttributeValue in '..\Diagram\MLComponents\InstanceSelection\AttValueSelection\UCompISAttributeValue.pas',
  UDlgOpPrmISAttributeValue in '..\Diagram\MLComponents\InstanceSelection\AttValueSelection\UDlgOpPrmISAttributeValue.pas' {DlgOpPrmISAttributeValue},
  UDataAccessWEKAFile in '..\CommonStructures\Dataset\UDataAccessWEKAFile.pas',
  UDataAccessExcelFile in '..\CommonStructures\Dataset\UDataAccessExcelFile.pas',
  UFlexCelImport in '..\CommonStructures\FlexCelImport\UFlexCelImport.pas',
  XLSAdapter in '..\CommonStructures\FlexCelImport\XLSAdapter.pas',
  UDlgOpPrmSpvNaiveBayes in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\NaiveBayes\UDlgOpPrmSpvNaiveBayes.pas' {DlgOpPrmSpvNaiveBayes},
  UStringFastHash in '..\CommonStructures\FastHashString\UStringFastHash.pas',
  UDataAccessInfoDownload in '..\CommonStructures\Dataset\UDataAccessInfoDownload.pas',
  UCompSpvAssesBVDecomposition in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\BVDecomposition\UCompSpvAssesBVDecomposition.pas',
  UCompSpvAssesBootstrap in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\Bootstrap\UCompSpvAssesBootstrap.pas',
  UDlgOpPrmSpvAssesBootstrap in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\Bootstrap\UDlgOpPrmSpvAssesBootstrap.pas' {dlgOpPrmSpvAssesBootstrap},
  UDlgOpPrmSpvAssesBVDecomposition in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\BVDecomposition\UDlgOpPrmSpvAssesBVDecomposition.pas' {dlgOpPrmSpvAssesBVDecomposition},
  UFileResources in '..\CommonStructures\File\UFileResources.pas',
  UCompClusteringNG in '..\Diagram\MLComponents\Clustering\RNG\UCompClusteringNG.pas',
  UCompFactNIPALS in '..\Diagram\MLComponents\FactorialAnalysis\NIPALS\UCompFactNIPALS.pas',
  UCalcFactNIPALS in '..\Diagram\MLComponents\FactorialAnalysis\NIPALS\UCalcFactNIPALS.pas',
  UDlgOpPrmFactNIPALS in '..\Diagram\MLComponents\FactorialAnalysis\NIPALS\UDlgOpPrmFactNIPALS.pas' {DlgOpPrmFactNIPALS},
  UCompSpvSVM in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\SVM\UCompSpvSVM.pas',
  UCalcSpvSMOSet in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\SVM\UCalcSpvSMOSet.pas',
  UCalcSpvSMOPolyKernel in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\SVM\UCalcSpvSMOPolyKernel.pas',
  UCalcSpvSMOAttTransformation in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\SVM\UCalcSpvSMOAttTransformation.pas',
  UDlgOpPrmSVM in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\SVM\UDlgOpPrmSVM.pas' {dlgOpPrmSpvSVM},
  UCalcSpvSMORbfKernel in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\SVM\UCalcSpvSMORbfKernel.pas',
  d6_optim in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LogisticRegression\d6_optim.pas',
  d6_fmath in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LogisticRegression\d6_fmath.pas',
  d6_matrices in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LogisticRegression\d6_matrices.pas',
  UCompSpvMultinomialLogReg in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\MultinomialLogisticRegression\UCompSpvMultinomialLogReg.pas',
  UDlgOpPrmSpvMLogReg in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\MultinomialLogisticRegression\UDlgOpPrmSpvMLogReg.pas' {dlgOpPrmSpvMLogReg},
  UCompSpvCN2 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\CN2\UCompSpvCN2.pas',
  UCalcSpvCN2 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\CN2\UCalcSpvCN2.pas',
  UCalcDistributionEvaluation in '..\CommonStructures\VecTab\UCalcDistributionEvaluation.pas',
  UCalcRulesImplementation in '..\CommonStructures\RulesAndTrees\UCalcRulesImplementation.pas',
  UDlgOpPrmSpvDLCN2 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\CN2\UDlgOpPrmSpvDLCN2.pas' {dlgOprPrmSpvDLCN2},
  UCalcSpvStructScore in '..\Diagram\MLComponents\SpvLearning\UCalcSpvStructScore.pas',
  UCompSpvScoring in '..\Diagram\MLComponents\Scoring\UCompSpvScoring.pas',
  UDlgOpPrmSpvScoring in '..\Diagram\MLComponents\Scoring\UDlgOpPrmSpvScoring.pas' {dlgOpPrmSpvScoring},
  UCompSpvScoringLift in '..\Diagram\MLComponents\Scoring\UCompSpvScoringLift.pas',
  UCompSpvScoringRoc in '..\Diagram\MLComponents\Scoring\UCompSpvScoringRoc.pas',
  UDlgOpPrmSpvScoringLift in '..\Diagram\MLComponents\Scoring\UDlgOpPrmSpvScoringLift.pas' {dlgOpPrmSpvScoringCurve},
  UCompFCDiscBinaryBinning in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UCompFCDiscBinaryBinning.pas',
  UDlgOpPrmDiscBinBinning in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UDlgOpPrmDiscBinBinning.pas' {dlgOpPrmDiscBinBinning},
  UCalcSpvMutlinomialLogReg in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\MultinomialLogisticRegression\UCalcSpvMutlinomialLogReg.pas',
  UDlgOpPrmClusteringRNG in '..\Diagram\MLComponents\Clustering\RNG\UDlgOpPrmClusteringRNG.pas' {dlgOpPrmClusteringNG},
  UCompPlsBase in '..\Diagram\MLComponents\Pls\PlsBase\UCompPlsBase.pas',
  UDlgOpPrmPlsBase in '..\Diagram\MLComponents\Pls\PlsBase\UDlgOpPrmPlsBase.pas' {dlgOpPrmPlsBase},
  UCompFCRadialBasisFunction in '..\Diagram\MLComponents\FeatureConstruction\RBF\UCompFCRadialBasisFunction.pas',
  UDlgOpPrmFCRadialBasisFunction in '..\Diagram\MLComponents\FeatureConstruction\RBF\UDlgOpPrmFCRadialBasisFunction.pas' {dlgOpPrmFCRadialBasisFunction},
  UCompSDMannWhitney in '..\Diagram\MLComponents\DescriptiveStat\KruskalWallisTest\UCompSDMannWhitney.pas',
  UCalcStatDesRankForNonParametricStat in '..\CommonStructures\StatDes\UCalcStatDesRankForNonParametricStat.pas',
  UCompSDSpearmanCorrelation in '..\Diagram\MLComponents\DescriptiveStat\NonParametricCorrelation\UCompSDSpearmanCorrelation.pas',
  UCompSDKendallCorrelation in '..\Diagram\MLComponents\DescriptiveStat\NonParametricCorrelation\UCompSDKendallCorrelation.pas',
  UCompSDMoodRunsTest in '..\Diagram\MLComponents\DescriptiveStat\KruskalWallisTest\UCompSDMoodRunsTest.pas',
  UCompSDCondDescDefinition in '..\Diagram\MLComponents\DescriptiveStat\UCompSDCondDescDefinition.pas',
  UCompSDPairedTestDefinition in '..\Diagram\MLComponents\DescriptiveStat\PairedTest\UCompSDPairedTestDefinition.pas',
  UCalcStatDesPairedTest in '..\CommonStructures\StatDes\UCalcStatDesPairedTest.pas',
  UCompSDPairedTestSignTest in '..\Diagram\MLComponents\DescriptiveStat\PairedTest\UCompSDPairedTestSignTest.pas',
  UCompSDPairedTestStudent in '..\Diagram\MLComponents\DescriptiveStat\PairedTest\UCompSDPairedTestStudent.pas',
  UCompSDPairedTestWilcoxonSignedRanks in '..\Diagram\MLComponents\DescriptiveStat\PairedTest\UCompSDPairedTestWilcoxonSignedRanks.pas',
  UCompSDWaldWolfowitzRunsTest in '..\Diagram\MLComponents\DescriptiveStat\KruskalWallisTest\UCompSDWaldWolfowitzRunsTest.pas',
  UCompSpvAssesTestSet in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\UCompSpvAssesTestSet.pas',
  UDlgOpPrmSpvAssesTestSet in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\UDlgOpPrmSpvAssesTestSet.pas' {dlgOpPrmSpvAssesTestSet},
  UCalcStatDesVarianceHomogeneity in '..\CommonStructures\StatDes\UCalcStatDesVarianceHomogeneity.pas',
  UCompSDVarTestFisher in '..\Diagram\MLComponents\DescriptiveStat\VarianceHomogeneity\UCompSDVarTestFisher.pas',
  UCompSDVarTestBartlett in '..\Diagram\MLComponents\DescriptiveStat\VarianceHomogeneity\UCompSDVarTestBartlett.pas',
  UCompSDVarTestLevene in '..\Diagram\MLComponents\DescriptiveStat\VarianceHomogeneity\UCompSDVarTestLevene.pas',
  UCompSDVarTestBrownForsythe in '..\Diagram\MLComponents\DescriptiveStat\VarianceHomogeneity\UCompSDVarTestBrownForsythe.pas',
  UCompSDTTestEqualVariance in '..\Diagram\MLComponents\DescriptiveStat\TTest\UCompSDTTestEqualVariance.pas',
  UCompSDTTestUnequalVariance in '..\Diagram\MLComponents\DescriptiveStat\TTest\UCompSDTTestUnequalVariance.pas',
  UCalcStatDesNormalityTestFromFORTRAN in '..\CommonStructures\StatDes\UCalcStatDesNormalityTestFromFORTRAN.pas',
  UCalcStatDesNormalityTest in '..\CommonStructures\StatDes\UCalcStatDesNormalityTest.pas',
  UCompSDUnivContNormalityTest in '..\Diagram\MLComponents\DescriptiveStat\NormalityTest\UCompSDUnivContNormalityTest.pas',
  UCalcRegLinMultiple in '..\CommonStructures\Regression\UCalcRegLinMultiple.pas',
  UCompRegForwardSel in '..\Diagram\MLComponents\Regression\MultipleRegression\UCompRegForwardSel.pas',
  UDlgOpPrmRegForward in '..\Diagram\MLComponents\Regression\MultipleRegression\UDlgOpPrmRegForward.pas' {DlgOpPrmRegForward},
  UCalcStatDesKRelatedSamples in '..\Diagram\MLComponents\DescriptiveStat\KRelatedSamples\UCalcStatDesKRelatedSamples.pas',
  UCompSDKRelatedDefinition in '..\Diagram\MLComponents\DescriptiveStat\KRelatedSamples\UCompSDKRelatedDefinition.pas',
  UCompSDKRelatedFriedman in '..\Diagram\MLComponents\DescriptiveStat\KRelatedSamples\UCompSDKRelatedFriedman.pas',
  UCompSDKRelatedWKendall in '..\Diagram\MLComponents\DescriptiveStat\KRelatedSamples\UCompSDKRelatedWKendall.pas',
  UCalcStatDesManova in '..\CommonStructures\StatDes\UCalcStatDesManova.pas',
  UCompSDManovaDefinition in '..\Diagram\MLComponents\DescriptiveStat\Manova\UCompSDManovaDefinition.pas',
  UCompFactDiscriminantAnalysis in '..\Diagram\MLComponents\FactorialAnalysis\DiscriminantAnalysis\UCompFactDiscriminantAnalysis.pas',
  UCalcFactDiscriminantAnalysis in '..\Diagram\MLComponents\FactorialAnalysis\DiscriminantAnalysis\UCalcFactDiscriminantAnalysis.pas',
  UCompClusteringTree in '..\Diagram\MLComponents\Clustering\Tree\UCompClusteringTree.pas',
  UCalcClusteringTree in '..\Diagram\MLComponents\Clustering\Tree\UCalcClusteringTree.pas',
  UDlgOpPrmClusteringTree in '..\Diagram\MLComponents\Clustering\Tree\UDlgOpPrmClusteringTree.pas' {dlgOpPrmClusteringTree},
  UCompClusteringTreeCART in '..\Diagram\MLComponents\Clustering\Tree\UCompClusteringTreeCART.pas',
  UCalcClusteringTreeCART in '..\Diagram\MLComponents\Clustering\Tree\UCalcClusteringTreeCART.pas',
  UDlgOpPrmClusteringTreeCART in '..\Diagram\MLComponents\Clustering\Tree\UDlgOpPrmClusteringTreeCART.pas' {dlgOpPrmClusteringTreeCART},
  JFGDlgOpPrmPLS in '..\Diagram\MLComponents\Pls\PlsBase\JFGDlgOpPrmPLS.pas' {DlgOpPrmPLS},
  JFGCalcPLS in '..\Diagram\MLComponents\Pls\PlsBase\JFGCalcPLS.pas',
  JFGCompPLS in '..\Diagram\MLComponents\Pls\PlsBase\JFGCompPLS.pas',
  UCalcSpvTreeC45 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCalcSpvTreeC45.pas',
  UCompSpvTreeC45 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCompSpvTreeC45.pas',
  UDlgOpPrmSpvTreeC45 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UDlgOpPrmSpvTreeC45.pas' {dlgOpPrmSpvTreeC45},
  ULibSVMImport in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibSVM\ULibSVMImport.pas',
  UCompSpvLibsvmCsvc in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibSVM\UCompSpvLibsvmCsvc.pas',
  UCalcSpvLibsvmCsvc in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibSVM\UCalcSpvLibsvmCsvc.pas',
  UDlgOpPrmSpvLibSvmCSVC in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibSVM\UDlgOpPrmSpvLibSvmCSVC.pas' {dlgOpPrmSpvLibsvmCsvc},
  UCompAssocRulePrefixTreeCB in '..\Diagram\MLComponents\AssociationRule\UCompAssocRulePrefixTreeCB.pas',
  DosCommand in '..\CommonStructures\DosCommand\DosCommand.pas',
  UFrmOpViewAssocRulePrefixTree in '..\Diagram\MLComponents\AssociationRule\UFrmOpViewAssocRulePrefixTree.pas' {frmOpViewAssocPrefixTree},
  UDlgOpPrmAssocRulePrefixTree in '..\Diagram\MLComponents\AssociationRule\UDlgOpPrmAssocRulePrefixTree.pas' {DlgOpPrmAssociationRulePrefixTree},
  VTHeaderPopup in '..\CommonStructures\VirtualTreeView\VTHeaderPopup.pas',
  VirtualTrees in '..\CommonStructures\VirtualTreeView\VirtualTrees.pas',
  UCompSDGroupExploration in '..\Diagram\MLComponents\DescriptiveStat\GroupExploration\UCompSDGroupExploration.pas',
  UFrmOpViewSDGroupExploration in '..\Diagram\MLComponents\DescriptiveStat\GroupExploration\UFrmOpViewSDGroupExploration.pas' {frmOpViewSDGroupExploration},
  UCalcSDGroupExploration in '..\Diagram\MLComponents\DescriptiveStat\GroupExploration\UCalcSDGroupExploration.pas',
  UImportTRIRLS in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LR_TRIRLS\UImportTRIRLS.pas',
  UCalcSpvTrirls in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LR_TRIRLS\UCalcSpvTrirls.pas',
  UCompSpvTrirls in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LR_TRIRLS\UCompSpvTrirls.pas',
  UCompMetaSpvGenericAggregating in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvGenericAggregating.pas',
  UCompSpvCPLS in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\PLS\UCompSpvCPLS.pas',
  UDlgOpPrmSpvCPLS in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\PLS\UDlgOpPrmSpvCPLS.pas' {dlgOpPrmSpvCPLS},
  XLSfile in '..\CommonStructures\XlsFile\XLSfile.pas',
  UCalcRegTree in '..\Diagram\MLComponents\Regression\RegressionTree\UCalcRegTree.pas',
  UCompRegTree in '..\Diagram\MLComponents\Regression\RegressionTree\UCompRegTree.pas',
  UDlgOpPrmRegressionTree in '..\Diagram\MLComponents\Regression\RegressionTree\UDlgOpPrmRegressionTree.pas' {DlgOpPrmRegressionTree},
  UFrmOpClusHAC in '..\Diagram\MLComponents\Clustering\HAC\UFrmOpClusHAC.pas' {FrmOpViewClusHAC},
  UCalcFactRotateFactors in '..\Diagram\MLComponents\FactorialAnalysis\ACP\UCalcFactRotateFactors.pas',
  UCompFactRotateFactors in '..\Diagram\MLComponents\FactorialAnalysis\ACP\UCompFactRotateFactors.pas',
  UDlgOpPrmRotateFactors in '..\Diagram\MLComponents\FactorialAnalysis\ACP\UDlgOpPrmRotateFactors.pas' {dlgOpPrmFactRotateFactors},
  UDlgOpPrmSpvDiscAnalysis in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DiscriminantAnalysis\UDlgOpPrmSpvDiscAnalysis.pas' {dlgOpPrmSpvDiscAnalysis},
  UCompSpvTreeRandomTree in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCompSpvTreeRandomTree.pas',
  UCalcSpvTreeRandomTree in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCalcSpvTreeRandomTree.pas',
  UCompPLSFactorial in '..\Diagram\MLComponents\Pls\UCompPLSFactorial.pas',
  UDlgOpPrmSpvTreeRandomTree in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UDlgOpPrmSpvTreeRandomTree.pas' {DlgOpPrmSpvTreeRandomTree},
  UCompISContinuousAttributeValue in '..\Diagram\MLComponents\InstanceSelection\AttValueSelection\UCompISContinuousAttributeValue.pas',
  UDlgOpPrmISCAttributeValue in '..\Diagram\MLComponents\InstanceSelection\AttValueSelection\UDlgOpPrmISCAttributeValue.pas' {dlgOpPrmISCAttValue},
  UCompISRuleBased in '..\Diagram\MLComponents\InstanceSelection\RuleBasedSelection\UCompISRuleBased.pas',
  UDlgOpPrmISRuleBased in '..\Diagram\MLComponents\InstanceSelection\RuleBasedSelection\UDlgOpPrmISRuleBased.pas' {DlgOpPrmISRuleBased},
  UDlgOpPrmFCBinarization in '..\Diagram\MLComponents\FeatureConstruction\Binarization\UDlgOpPrmFCBinarization.pas' {DlgOpPrmFCBinarization},
  UCompClusteringEM in '..\Diagram\MLComponents\Clustering\EM\UCompClusteringEM.pas',
  UDlgOpPrmClusEM in '..\Diagram\MLComponents\Clustering\EM\UDlgOpPrmClusEM.pas' {DlgOpPrmClusEM},
  UCompClusteringEMSelection in '..\Diagram\MLComponents\Clustering\EM\UCompClusteringEMSelection.pas',
  UDlgOpPrmClusEMSelection in '..\Diagram\MLComponents\Clustering\EM\UDlgOpPrmClusEMSelection.pas' {DlgOpPrmClusEMSelection},
  UDlgOpPrmPlsFactorial in '..\Diagram\MLComponents\Pls\UDlgOpPrmPlsFactorial.pas' {DlgOpPrmPLSFactorial},
  UCompPLSSelection in '..\Diagram\MLComponents\Pls\UCompPLSSelection.pas',
  UCalcPLSSelectionStructure in '..\Diagram\MLComponents\Pls\UCalcPLSSelectionStructure.pas',
  UDlgOpPrmPlsSelection in '..\Diagram\MLComponents\Pls\UDlgOpPrmPlsSelection.pas' {DlgOpPrmPLSSelection},
  UConstConfigHint in 'Constants\UConstConfigHint.pas',
  UCompPLSConfidenceInterval in '..\Diagram\MLComponents\Pls\UCompPLSConfidenceInterval.pas',
  UDlgOpPrmPlsConfidenceInterval in '..\Diagram\MLComponents\Pls\UDlgOpPrmPlsConfidenceInterval.pas' {DlgOpPrmPlsConfInterval},
  UCompFCRandomProjection in '..\Diagram\MLComponents\FeatureConstruction\RandomProjection\UCompFCRandomProjection.pas',
  UCompFSStepDisc in '..\Diagram\MLComponents\FeatureSelection\StepDisc\UCompFSStepDisc.pas',
  UCalcFSStepDisc in '..\Diagram\MLComponents\FeatureSelection\StepDisc\UCalcFSStepDisc.pas',
  UDlgOpPrmFSStepdisc in '..\Diagram\MLComponents\FeatureSelection\StepDisc\UDlgOpPrmFSStepdisc.pas' {DlgOpPrmFSStepdisc},
  UCompViewScatterPlotLegend in '..\Diagram\MLComponents\ViewDataset\ScatterPlot\UCompViewScatterPlotLegend.pas',
  UFrmOpScatterLegend in '..\Diagram\MLComponents\ViewDataset\ScatterPlot\UFrmOpScatterLegend.pas' {FrmOpViewScatterLegend},
  UCompFactAnalysisAFC in '..\Diagram\MLComponents\FactorialAnalysis\AFC\UCompFactAnalysisAFC.pas',
  UFrmOpViewFactAnalysisAFC in '..\Diagram\MLComponents\FactorialAnalysis\AFC\UFrmOpViewFactAnalysisAFC.pas' {FrmOpViewFactAnalysisAFC},
  UDlgOpPrmFactAnalysisAFC in '..\Diagram\MLComponents\FactorialAnalysis\AFC\UDlgOpPrmFactAnalysisAFC.pas' {DlgOpPrmFactAnalysisAFC},
  UCompVarClusBase in '..\Diagram\MLComponents\VarClustering\UCompVarClusBase.pas',
  UCalcVarClusBase in '..\Diagram\MLComponents\VarClustering\UCalcVarClusBase.pas',
  UCompVarClusKMeans in '..\Diagram\MLComponents\VarClustering\UCompVarClusKMeans.pas',
  UCompVarClusHCA in '..\Diagram\MLComponents\VarClustering\UCompVarClusHCA.pas',
  UFrmOpVarClusHCA in '..\Diagram\MLComponents\VarClustering\UFrmOpVarClusHCA.pas' {FrmOpViewVarClusHCA},
  UCompVarClusTopDown in '..\Diagram\MLComponents\VarClustering\UCompVarClusTopDown.pas',
  UFrmOpViewVarClusTopDown in '..\Diagram\MLComponents\VarClustering\UFrmOpViewVarClusTopDown.pas' {FrmOpViewVarClusTopDown},
  UDlgOpPrmVarClusBase in '..\Diagram\MLComponents\VarClustering\UDlgOpPrmVarClusBase.pas' {DlgOpPrmVarClusBase},
  UDlgOpPrmVarClusKMeans in '..\Diagram\MLComponents\VarClustering\UDlgOpPrmVarClusKMeans.pas' {DlgOpPrmVarClusKMeans},
  UDlgOpPrmVarClusTopDown in '..\Diagram\MLComponents\VarClustering\UDlgOpPrmVarClusTopDown.pas' {DlgOpPrmVarClusTopDown},
  UDlgOpPrmVarClusHCA in '..\Diagram\MLComponents\VarClustering\UDlgOpPrmVarClusHCA.pas' {DlgOpPrmVarClusHCA},
  UCompFCResidualScores in '..\Diagram\MLComponents\FeatureConstruction\ResidualScores\UCompFCResidualScores.pas',
  UCompRegBackwardElimination in '..\Diagram\MLComponents\Regression\MultipleRegression\UCompRegBackwardElimination.pas',
  UCompSDCategoricalCorrelation in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UCompSDCategoricalCorrelation.pas',
  UCompSDCategoricalAssociation in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UCompSDCategoricalAssociation.pas',
  UDlgOpPrmSDCategoricalAssociation in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UDlgOpPrmSDCategoricalAssociation.pas' {dlgOpPrmSDCategoricalAssociation},
  UCompRegOutlierDetection in '..\Diagram\MLComponents\Regression\MultipleRegression\UCompRegOutlierDetection.pas',
  xinbta_u in '..\CommonStructures\InvLoiStat\XINBTA_U.PAS',
  acrcy in '..\CommonStructures\InvLoiStat\ACRCY.PAS',
  anorpr_u in '..\CommonStructures\InvLoiStat\Anorpr_u.pas',
  betain_u in '..\CommonStructures\InvLoiStat\Betain_u.pas',
  dlgama_u in '..\CommonStructures\InvLoiStat\DLGAMA_U.PAS',
  gamain_u in '..\CommonStructures\InvLoiStat\GAMAIN_U.PAS',
  LOISTAT in '..\CommonStructures\InvLoiStat\LOISTAT.PAS',
  pax_u in '..\CommonStructures\InvLoiStat\PAX_U.PAS',
  ppchi2_u in '..\CommonStructures\InvLoiStat\PPCHI2_U.PAS',
  ppnd_u in '..\CommonStructures\InvLoiStat\PPND_U.PAS',
  probst_u in '..\CommonStructures\InvLoiStat\PROBST_U.PAS',
  xap_u in '..\CommonStructures\InvLoiStat\XAP_U.PAS',
  UFrmOpViewRegOutlier in '..\Diagram\MLComponents\Regression\MultipleRegression\UFrmOpViewRegOutlier.pas' {frmOpViewRegOutlier},
  UDlgOpPrmRegOutlier in '..\Diagram\MLComponents\Regression\MultipleRegression\UDlgOpPrmRegOutlier.pas' {DlgOpPrmRegOutlier},
  UCompRegOutlierDfBetas in '..\Diagram\MLComponents\Regression\MultipleRegression\UCompRegOutlierDfBetas.pas',
  UFrmOpViewRegDfBetas in '..\Diagram\MLComponents\Regression\MultipleRegression\UFrmOpViewRegDfBetas.pas' {frmOpViewRegDfBetas},
  UCompSDCatAssocTheilU in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UCompSDCatAssocTheilU.pas',
  UDlgOpPrmSDCatAssocTheil in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UDlgOpPrmSDCatAssocTheil.pas' {dlgOpPrmSDCatAssocTheil},
  UCompSDCatAssocLambda in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UCompSDCatAssocLambda.pas',
  UDlgOpPrmSDCatAssocLambda in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UDlgOpPrmSDCatAssocLambda.pas' {dlgOpPrmSDCatAssocLambda},
  UCalcStatDesCrossTab3D in '..\CommonStructures\StatDes\UCalcStatDesCrossTab3D.pas',
  UCompSDCatAssocPartialTheilU in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UCompSDCatAssocPartialTheilU.pas',
  UDlgOpPrmSDCatAssocPartialTheil in '..\Diagram\MLComponents\DescriptiveStat\CategoricalCorrelation\UDlgOpPrmSDCatAssocPartialTheil.pas' {dlgOpPrmSDCatAssocPartialTheil},
  UCompAssocRuleOutlierDetection in '..\Diagram\MLComponents\AssociationRule\UCompAssocRuleOutlierDetection.pas',
  UCalcAssocStrucOutlier in '..\Diagram\MLComponents\AssociationRule\UCalcAssocStrucOutlier.pas',
  UDlgOpPrmAssocRuleOutlier in '..\Diagram\MLComponents\AssociationRule\UDlgOpPrmAssocRuleOutlier.pas' {DlgOpPrmAssocOutlier},
  UCompOutlierDetectUnivariate in '..\Diagram\MLComponents\DescriptiveStat\OutlierDetection\UCompOutlierDetectUnivariate.pas',
  UDlgOpPrmODUnivariate in '..\Diagram\MLComponents\DescriptiveStat\OutlierDetection\UDlgOpPrmODUnivariate.pas' {dlgOpPrmODUnivariate},
  UCalcStructOrdinalAssociation in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UCalcStructOrdinalAssociation.pas',
  UCalcStatDesOrdinalAssociation in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UCalcStatDesOrdinalAssociation.pas',
  UCompSDOrdinalAssociation in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UCompSDOrdinalAssociation.pas',
  UCompSDOrdinalAssocGamma in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UCompSDOrdinalAssocGamma.pas',
  UDlgOpPrmOrdinalAssociation in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UDlgOpPrmOrdinalAssociation.pas' {dlgOpPrmSDOrdinalAssociation},
  UCompSDOrdinalAssocTau_b in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UCompSDOrdinalAssocTau_b.pas',
  UCompSDOrdinalAssocTau_c in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UCompSDOrdinalAssocTau_c.pas',
  UCompSDOrdinalAssocSommers in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UCompSDOrdinalAssocSommers.pas',
  UDlgOpPrmOrdinalAssociationSommers in '..\Diagram\MLComponents\DescriptiveStat\OrdinalAssociation\UDlgOpPrmOrdinalAssociationSommers.pas' {dlgOpPrmSDOrdinalAssociationSommers},
  UCompFCDiscValues in '..\Diagram\MLComponents\FeatureConstruction\Discretization\UCompFCDiscValues.pas',
  UCompSpvAssesLeaveOneOut in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\LeaveOneOut\UCompSpvAssesLeaveOneOut.pas',
  UDlgOpPrmSpvAssesLVO in '..\Diagram\MLComponents\SpvLearning\SpvAssesment\LeaveOneOut\UDlgOpPrmSpvAssesLVO.pas' {dlgOpPrmSpvAssesLVO},
  UFrmSpvScoringLift in '..\Diagram\MLComponents\Scoring\UFrmSpvScoringLift.pas' {FrmOpViewSpvScoringLift},
  UFrmSpvScoringRoc in '..\Diagram\MLComponents\Scoring\UFrmSpvScoringRoc.pas' {frmOpViewSpvScoringRoc},
  UCompSpvMultiCategoryLogReg in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\MultinomialLogisticRegression\UCompSpvMultiCategoryLogReg.pas',
  UCalcFSStepLogisticReg in '..\Diagram\MLComponents\FeatureSelection\StepLogisticReg\UCalcFSStepLogisticReg.pas',
  UCompFSLogisticRegBackward in '..\Diagram\MLComponents\FeatureSelection\StepLogisticReg\UCompFSLogisticRegBackward.pas',
  UCompFSLogisticRegForward in '..\Diagram\MLComponents\FeatureSelection\StepLogisticReg\UCompFSLogisticRegForward.pas',
  UDlgOpPrmFSLogRegBase in '..\Diagram\MLComponents\FeatureSelection\StepLogisticReg\UDlgOpPrmFSLogRegBase.pas' {DlgOpPrmFSLogRegBase},
  UDlgOpPrmFSLogRegForward in '..\Diagram\MLComponents\FeatureSelection\StepLogisticReg\UDlgOpPrmFSLogRegForward.pas' {DlgOpPrmFSLogRegForward},
  UDlgOpPrmSDGroupCharacterization in '..\Diagram\MLComponents\DescriptiveStat\GroupCaracterization\UDlgOpPrmSDGroupCharacterization.pas' {dlgOpPrmSDGroupCharacterization},
  UDlgOpPrmSDGroupExploration in '..\Diagram\MLComponents\DescriptiveStat\GroupExploration\UDlgOpPrmSDGroupExploration.pas' {dlgOpPrmSDGroupExploration},
  UFrmSpvTreeCart in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UFrmSpvTreeCart.pas' {frmOpViewSpvTreeCart},
  UFrmOpClusTree in '..\Diagram\MLComponents\Clustering\Tree\UFrmOpClusTree.pas' {frmOpViewClusteringTree},
  UCalcPLSSupervised in '..\Diagram\MLComponents\Pls\UCalcPLSSupervised.pas',
  UCompSpvPLSDA in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\PLS\UCompSpvPLSDA.pas',
  UCompSpvPLSLDA in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\PLS\UCompSpvPLSLDA.pas',
  UDlgOpPrmSpvPLSDA in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\PLS\UDlgOpPrmSpvPLSDA.pas' {dlgOpPrmSpvPlsDa},
  UCompPLSRegressionPlus in '..\Diagram\MLComponents\Pls\UCompPLSRegressionPlus.pas',
  UCalcPLSRegressionPlus in '..\Diagram\MLComponents\Pls\UCalcPLSRegressionPlus.pas',
  UDlgOpPrmPlsRegPlus in '..\Diagram\MLComponents\Pls\UDlgOpPrmPlsRegPlus.pas' {dlgOpPrmPlsRegPlus},
  UFrmOpViewPLSRegressionChart in '..\Diagram\MLComponents\Pls\UFrmOpViewPLSRegressionChart.pas' {frmOpViewPlsRegressionChart},
  UCompSDSemiPartialCorrelation in '..\Diagram\MLComponents\DescriptiveStat\LinearCorrelation\UCompSDSemiPartialCorrelation.pas',
  UDlgOpPrmSDSemiPartialCorrelation in '..\Diagram\MLComponents\DescriptiveStat\LinearCorrelation\UDlgOpPrmSDSemiPartialCorrelation.pas' {dlgOpPrmSDSemiPartialCorrelation},
  UCompSDPartialCorrelation in '..\Diagram\MLComponents\DescriptiveStat\LinearCorrelation\UCompSDPartialCorrelation.pas',
  UCompSDPairedTestVariance in '..\Diagram\MLComponents\DescriptiveStat\PairedTest\UCompSDPairedTestVariance.pas',
  UCompSDKRelatedAnovaRndBlock in '..\Diagram\MLComponents\DescriptiveStat\KRelatedSamples\UCompSDKRelatedAnovaRndBlock.pas',
  UCompSDWelchAnova in '..\Diagram\MLComponents\DescriptiveStat\OneWayAnova\UCompSDWelchAnova.pas',
  UCompSDT2Hotelling in '..\Diagram\MLComponents\DescriptiveStat\Manova\UCompSDT2Hotelling.pas',
  UCompSDT2HotellingHeteroscedastic in '..\Diagram\MLComponents\DescriptiveStat\Manova\UCompSDT2HotellingHeteroscedastic.pas',
  UCompSDBoxMTest in '..\Diagram\MLComponents\DescriptiveStat\Manova\UCompSDBoxMTest.pas',
  UCompSDVanDerWaerden in '..\Diagram\MLComponents\DescriptiveStat\NonParametricOneWay\UCompSDVanDerWaerden.pas',
  UCompSDMedianTest in '..\Diagram\MLComponents\DescriptiveStat\NonParametricOneWay\UCompSDMedianTest.pas',
  UCompSDFYTH in '..\Diagram\MLComponents\DescriptiveStat\NonParametricOneWay\UCompSDFYTH.pas',
  UCompSDMoodScaleDifferences in '..\Diagram\MLComponents\DescriptiveStat\NonParametricOneWay\UCompSDMoodScaleDifferences.pas',
  UCompSDKlotzScaleDifferences in '..\Diagram\MLComponents\DescriptiveStat\NonParametricOneWay\UCompSDKlotzScaleDifferences.pas',
  UCompSDAnsariBradleyScaleDifference in '..\Diagram\MLComponents\DescriptiveStat\NonParametricOneWay\UCompSDAnsariBradleyScaleDifference.pas',
  UCalcSDCondDescKolmogorov2S in '..\Diagram\MLComponents\DescriptiveStat\NonParametricOneWay\UCalcSDCondDescKolmogorov2S.pas',
  UCompSDKS2SampleTest in '..\Diagram\MLComponents\DescriptiveStat\NonParametricOneWay\UCompSDKS2SampleTest.pas',
  UCompSDKRelatedQCochran in '..\Diagram\MLComponents\DescriptiveStat\KRelatedSamples\UCompSDKRelatedQCochran.pas',
  UCalcSpvSVMBinarySMO in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\SVM\UCalcSpvSVMBinarySMO.pas',
  UCalcSpvSMOCachedKernel in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\SVM\UCalcSpvSMOCachedKernel.pas',
  UCompSpvPosteriorProba in '..\Diagram\MLComponents\Scoring\UCompSpvPosteriorProba.pas',
  UCompMetaSpvGenericCostSensitive in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvGenericCostSensitive.pas',
  UDlgOpPrmBaseCostSensitive in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UDlgOpPrmBaseCostSensitive.pas' {dlgOpPrmMetaSpvCostSensitiveBase},
  UCompMetaSpvCSOneInstance in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvCSOneInstance.pas',
  UCompMetaSpvCSBagging in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvCSBagging.pas',
  UCompMetaSpvCSCommitte in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvCSCommitte.pas',
  UDlgOpPrmCommitteeCostSensitive in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UDlgOpPrmCommitteeCostSensitive.pas' {dlgOpPrmMetaSpvCSCommittee},
  UCompSpvCSTreeCART in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCompSpvCSTreeCART.pas',
  UDlgOpPrmSpvTreeCSCART in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UDlgOpPrmSpvTreeCSCART.pas' {dlgOpPrmSpvTreeCSCART},
  UCompSpvCSTreeC45 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UCompSpvCSTreeC45.pas',
  UDlgOpPrmSpvTreeCSC45 in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\DecisionTree\UDlgOpPrmSpvTreeCSC45.pas' {dlgOpPrmSpvTreeCSC45},
  UCompMetaSpvCSMultiCost in '..\Diagram\MLComponents\SpvLearning\MetaSpvLearning\UCompMetaSpvCSMultiCost.pas',
  UCalcRegSvm in '..\Diagram\MLComponents\Regression\RegSvm\UCalcRegSvm.pas',
  UCompRegSvm in '..\Diagram\MLComponents\Regression\RegSvm\UCompRegSvm.pas',
  UCompRegSvmEpsilon in '..\Diagram\MLComponents\Regression\RegSvm\UCompRegSvmEpsilon.pas',
  UCompRegSvmNu in '..\Diagram\MLComponents\Regression\RegSvm\UCompRegSvmNu.pas',
  UCompRegAssessment in '..\Diagram\MLComponents\Regression\UCompRegAssessment.pas',
  UDlgOpPrmRegAssessment in '..\Diagram\MLComponents\Regression\UDlgOpPrmRegAssessment.pas' {dlgOpPrmRegAssessment},
  UDlgOpPrmRegSvmEpsilon in '..\Diagram\MLComponents\Regression\RegSvm\UDlgOpPrmRegSvmEpsilon.pas' {dlgOpPrmRegSvmEpsilon},
  UDlgOpPrmRegSvmNu in '..\Diagram\MLComponents\Regression\RegSvm\UDlgOpPrmRegSvmNu.pas' {dlgOpPrmRegSvmNu},
  UCompSpvScoringPrecRecallCurve in '..\Diagram\MLComponents\Scoring\UCompSpvScoringPrecRecallCurve.pas',
  UFrmSpvScoringPrecRecall in '..\Diagram\MLComponents\Scoring\UFrmSpvScoringPrecRecall.pas' {frmOpViewSpvScoringPrecRecall},
  UFrmOpViewSpvLogisticRegression in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LogisticRegression\UFrmOpViewSpvLogisticRegression.pas' {frmOpViewLogistiRegression},
  UCompSpvLogisticRegHLTest in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LogisticRegression\UCompSpvLogisticRegHLTest.pas',
  UCompSpvScoringReliabilityDiagram in '..\Diagram\MLComponents\Scoring\UCompSpvScoringReliabilityDiagram.pas',
  UFrmSpvScoringRelDiagram in '..\Diagram\MLComponents\Scoring\UFrmSpvScoringRelDiagram.pas' {frmSpvScoringRelDiagram},
  UCompSpvLogisticRegResiduals in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LogisticRegression\UCompSpvLogisticRegResiduals.pas',
  UFrmOpViewSpvLogRegResiduals in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LogisticRegression\UFrmOpViewSpvLogRegResiduals.pas' {FrmOpViewSpvLogRegResisuals},
  UCompSpvRuleInduction in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\RuleInduction\UCompSpvRuleInduction.pas',
  UCalcSpvRuleInduction in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\RuleInduction\UCalcSpvRuleInduction.pas',
  UDlgOpPrmSpvRuleInduction in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\RuleInduction\UDlgOpPrmSpvRuleInduction.pas' {dlgOpPrmSpvRuleInduction},
  UCalcRegTreeCART in '..\Diagram\MLComponents\Regression\RegressionTree\UCalcRegTreeCART.pas',
  UCompRegTreePredictive in '..\Diagram\MLComponents\Regression\RegressionTree\UCompRegTreePredictive.pas',
  UDlgOpPrmRegTreeCART in '..\Diagram\MLComponents\Regression\RegressionTree\UDlgOpPrmRegTreeCART.pas' {dlgOpPrmRegTreeCART},
  UFrmOpViewRegTreeCART in '..\Diagram\MLComponents\Regression\RegressionTree\UFrmOpViewRegTreeCART.pas' {frmOpViewRegTreeCART},
  UCalcFSReliefF in '..\Diagram\MLComponents\FeatureSelection\ReliefF\UCalcFSReliefF.pas',
  UCompFSRelieff in '..\Diagram\MLComponents\FeatureSelection\ReliefF\UCompFSRelieff.pas',
  UDlgOpPrmFSRelieff in '..\Diagram\MLComponents\FeatureSelection\ReliefF\UDlgOpPrmFSRelieff.pas' {dlgOpPrmFSRelieff},
  minlbfgs in '..\CommonStructures\Alglib\minlbfgs.pas',
  Ap in '..\CommonStructures\Alglib\ap.pas',
  linmin in '..\CommonStructures\Alglib\linmin.pas',
  UCompSpvNaiveBayesContinuous in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\NaiveBayes\UCompSpvNaiveBayesContinuous.pas',
  UDlgOpPrmSpvNaiveBayesContinuous in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\NaiveBayes\UDlgOpPrmSpvNaiveBayesContinuous.pas' {dlgOpPrmSpvNaiveBayesCont},
  UFrmOpViewRegMultiple in '..\Diagram\MLComponents\Regression\MultipleRegression\UFrmOpViewRegMultiple.pas' {frmOpViewRegression},
  UCompFCContValues in '..\Diagram\MLComponents\FeatureConstruction\DiscToCont\UCompFCContValues.pas',
  UCompRegSimultaneous in '..\Diagram\MLComponents\Regression\Simultaneous\UCompRegSimultaneous.pas',
  UCompAssocFreqItemsets in '..\Diagram\MLComponents\AssociationRule\UCompAssocFreqItemsets.pas',
  UFrmOpViewAssocFreqItemsets in '..\Diagram\MLComponents\AssociationRule\UFrmOpViewAssocFreqItemsets.pas' {frmOpViewAssocFreqItemsets},
  UDlgOpPrmAssocFreqItemsets in '..\Diagram\MLComponents\AssociationRule\UDlgOpPrmAssocFreqItemsets.pas' {dlgOpPrmAssocFreqItemsets},
  ULibCVMImport in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibCVM\ULibCVMImport.pas',
  UCompSpvLibcvmCVM in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibCVM\UCompSpvLibcvmCVM.pas',
  UCalcLibcvmCVM in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibCVM\UCalcLibcvmCVM.pas',
  UDlgOpPrmSpvCVM in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibCVM\UDlgOpPrmSpvCVM.pas' {dlgOpPrmSpvCvm},
  UCompSpvLibcmBVM in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibCVM\UCompSpvLibcmBVM.pas',
  UDlgOpPrmSpvBVM in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LibCVM\UDlgOpPrmSpvBVM.pas' {dlgOpPrmSpvBvm},
  UDlgOpPrmSpvTRIRLS in '..\Diagram\MLComponents\SpvLearning\SpvAlgorithm\LR_TRIRLS\UDlgOpPrmSpvTRIRLS.pas' {dlgOpPrmSpvTRIRLS},
  UDatatAccessSparse in '..\CommonStructures\Dataset\UDatatAccessSparse.pas',
  UCompISFirst in '..\Diagram\MLComponents\InstanceSelection\FirstInstances\UCompISFirst.pas',
  UDlgOpPrmISFirst in '..\Diagram\MLComponents\InstanceSelection\FirstInstances\UDlgOpPrmISFirst.pas' {dlgOpPrmISFirst},
  UFrmOpViewFactPCA in '..\Diagram\MLComponents\FactorialAnalysis\ACP\UFrmOpViewFactPCA.pas' {FrmOpViewFactPCA},
  UCompFactParallelAnalysis in '..\Diagram\MLComponents\FactorialAnalysis\UCompFactParallelAnalysis.pas',
  StStat in '..\CommonStructures\TPower\StStat.pas',
  StBase in '..\CommonStructures\TPower\StBase.pas',
  StConst in '..\CommonStructures\TPower\StConst.pas',
  StMath in '..\CommonStructures\TPower\StMath.pas',
  StDate in '..\CommonStructures\TPower\StDate.pas',
  UFrmOpViewFactParallelAnalysis in '..\Diagram\MLComponents\FactorialAnalysis\UFrmOpViewFactParallelAnalysis.pas' {FrmOpViewFactParallelAnalysis},
  UCompFactBootstrap in '..\Diagram\MLComponents\FactorialAnalysis\UCompFactBootstrap.pas',
  UFrmOpViewFactBootstrap in '..\Diagram\MLComponents\FactorialAnalysis\UFrmOpViewFactBootstrap.pas' {FrmOpViewFactBootstrap},
  UDlgOpPrmFactParallelAnalysis in '..\Diagram\MLComponents\FactorialAnalysis\UDlgOpPrmFactParallelAnalysis.pas' {DlgOpPrmFactParallelAnalysis},
  UFrmOpViewFSStepdisc in '..\Diagram\MLComponents\FeatureSelection\StepDisc\UFrmOpViewFSStepdisc.pas' {FrmOpViewFSStepdisc},
  UCompFactAnalysisAFDM in '..\Diagram\MLComponents\FactorialAnalysis\AFDM\UCompFactAnalysisAFDM.pas',
  UDlgOpPrmFactAFDM in '..\Diagram\MLComponents\FactorialAnalysis\AFDM\UDlgOpPrmFactAFDM.pas' {DlgOpPrmFactAFDM},
  UCompFactAnalysisPFA in '..\Diagram\MLComponents\FactorialAnalysis\PFA\UCompFactAnalysisPFA.pas',
  UCompFactAnalysisHarrisCA in '..\Diagram\MLComponents\FactorialAnalysis\PFA\UCompFactAnalysisHarrisCA.pas',
  UDlgOpPrmFactFA in '..\Diagram\MLComponents\FactorialAnalysis\PFA\UDlgOpPrmFactFA.pas' {DlgOpPrmFactFA},
  UCompClusteringKMeansStrengthen in '..\Diagram\MLComponents\Clustering\KMeans\UCompClusteringKMeansStrengthen.pas',
  UDlgOpClusKMeansStrengthen in '..\Diagram\MLComponents\Clustering\KMeans\UDlgOpClusKMeansStrengthen.pas' {DlgOpPrmClusKMeansStrengthen},
  UCompFactDiscCorrespAnalysis in '..\Diagram\MLComponents\FactorialAnalysis\DiscriminantAnalysis\UCompFactDiscCorrespAnalysis.pas',
  UFrmOpViewFactDiscCorresp in '..\Diagram\MLComponents\FactorialAnalysis\DiscriminantAnalysis\UFrmOpViewFactDiscCorresp.pas' {FrmOpViewFactDiscCorresp},
  UDlgOpPrmFactDCA in '..\Diagram\MLComponents\FactorialAnalysis\DiscriminantAnalysis\UDlgOpPrmFactDCA.pas' {dlgOpPrmFactDCA},
  UFrmOpViewFactACM in '..\Diagram\MLComponents\FactorialAnalysis\AFCM\UFrmOpViewFactACM.pas' {frmOpViewFactACM},
  StColl in '..\CommonStructures\TPower\StColl.pas',
  StList in '..\CommonStructures\TPower\StList.pas',
  DTstGen in '..\CommonStructures\EZDSL\DTSTGEN.PAS',
  UCompCatVarClusHAC in '..\Diagram\MLComponents\VarClustering\UCompCatVarClusHAC.pas',
  UDlgOpPrmCatVarClusHAC in '..\Diagram\MLComponents\VarClustering\UDlgOpPrmCatVarClusHAC.pas' {dlgOpPrCatVarClusHAC},
  UFrmOpViewCatVarClusHAC in '..\Diagram\MLComponents\VarClustering\UFrmOpViewCatVarClusHAC.pas' {frmOpViewCatVarClusHAC};

{$R *.res}

//pour la gestion de 3 GB sous Win32 et 4 GB sous Win64 - FastMM

{$SetPEFlags $20}

begin
  Application.Initialize;
  Application.Title := 'Tanagra';
  Application.CreateForm(TFrmMain, FrmMain);
  Application.CreateForm(TFrmPaletteComp, FrmPaletteComp);
  setInfoConfigurationOnApplication();
  //dtecter si mode batch ou graphique
  //if (ParamCount() = 1)
  if (detectBatchExecution() <> bmeNone)
   //mode "batch"
   then
    begin
     case detectBatchExecution() of
        //mode batch  partir d'excel
        bmeExcel: executeExcelBatchMode(); 
        //mode batch standard
        else executeStandardBatchMode();
     end;
    end
   //mode "graphique"
   else
    begin
     //lancer l'appli en mode graphique
     Application.Run;
    end;
end.
