(************************************************************)
(* UFrmMainForm.pas - Copyright (c) 2004 Ricco RAKOTOMALALA *)
(************************************************************)

{
@abstract(Fiche principale de l'application)
@author(Ricco)
@created(12/01/2004)
Cette fiche reprsente la fiche principale de l'application.
Elle dfinit le comportement global du logiciel.
}
unit UFrmMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UFrmBase, ActnList, Menus, ImgList, ComCtrls, ExtCtrls, ToolWin,
  LMDCustomControl, LMDCustomPanel, LMDCustomBevelPanel, LMDFormDisplay,
  UCompDefinition, StdActns;

type
  {Fiche principale de pilotage de l'application.}
  TFrmMain = class(TFrmBase)
    MainMenuMainForm: TMainMenu;
    ActListMainForm: TActionList;
    ImageListMainFormMenu: TImageList;
    ActNew: TAction;
    ActOpen: TAction;
    ActSave: TAction;
    menuFile: TMenuItem;
    menuFileNew: TMenuItem;
    N1: TMenuItem;
    menuFileOpen: TMenuItem;
    menuFileSave: TMenuItem;
    menuFileSaveAs: TMenuItem;
    N2: TMenuItem;
    menuFileExit: TMenuItem;
    ActExit: TAction;
    ActSaveAs: TAction;
    MainStatusBar: TStatusBar;
    MainToolBar: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ActClose: TAction;
    N3: TMenuItem;
    menuFileClose: TMenuItem;
    menuWindow: TMenuItem;
    menuWindowCascade: TMenuItem;
    SaveDlgDiagram: TSaveDialog;
    OpenDlgDiagram: TOpenDialog;
    menuFullExecute: TMenuItem;
    menuFileReport: TMenuItem;
    ActExecute: TAction;
    actWindowTileVertical: TWindowTileVertical;
    menuTile: TMenuItem;
    actWindowCascade: TWindowCascade;
    actWindowTileHorizontal: TWindowTileHorizontal;
    menuWindowTileHorizontal: TMenuItem;
    menuDiagram: TMenuItem;
    N4: TMenuItem;
    menuCopy: TMenuItem;
    ActCopy: TAction;
    SaveDlgHTMLReport: TSaveDialog;
    ActReport: TAction;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    actInsertDefStatus: TAction;
    ActDeleteComponent: TAction;
    menuDeleteComponent: TMenuItem;
    ActHelpIndex: TAction;
    MenuHelp: TMenuItem;
    menuHelpIndex: TMenuItem;
    N6: TMenuItem;
    menuHelpAbout: TMenuItem;
    ActHelpAbout: TAction;
    N7: TMenuItem;
    panelBottom: TPanel;
    pnlComponents: TPanel;
    pnlCompDisplay: TLMDFormDisplay;
    pnlTools: TPanel;
    pnlDiagram: TPanel;
    panelTitleBarDiagram: TPanel;
    pnlMLDiagramDisplay: TLMDFormDisplay;
    panelAll: TPanel;
    Splitter1: TSplitter;
    panelComponentsTitle: TPanel;
    Splitter2: TSplitter;
    N5: TMenuItem;
    Loadsubdiagram1: TMenuItem;
    SaveSubdiagram1: TMenuItem;
    actLoadSubdiagram: TAction;
    actSaveSubdiagram: TAction;
    openDlgSubdiagram: TOpenDialog;
    saveSubdiagram: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure ActNewExecute(Sender: TObject);
    procedure ActCloseExecute(Sender: TObject);
    procedure ActExitExecute(Sender: TObject);
    procedure ActSaveAsExecute(Sender: TObject);
    procedure ActOpenExecute(Sender: TObject);
    procedure ActSaveExecute(Sender: TObject);
    procedure ActExecuteExecute(Sender: TObject);
    procedure ActCopyExecute(Sender: TObject);
    procedure ActReportExecute(Sender: TObject);
    procedure actInsertDefStatusExecute(Sender: TObject);
    procedure ActDeleteComponentExecute(Sender: TObject);
    procedure ActHelpAboutExecute(Sender: TObject);
    procedure ActHelpIndexExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actSaveSubdiagramExecute(Sender: TObject);
    procedure actLoadSubdiagramExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
   {insertion de la palette de composants}
   procedure InsertMLCompPalette();
   {dsactiver les menus de manipulation de diagram
   c'est le cas lorsque le diagramme courant est NIL}
   procedure DeactivateMenusActionDiagram();
   {invserse, activer les menus actions diagram}
   procedure ActivateMenusActionDiagram();
  protected
   procedure InsertComponents(); override;
   procedure InsertTexts(); override;
   procedure openDiagram(fileName: TFileName);
  public
  end;

var
  FrmMain: TFrmMain;

  {un objet fondamental - le diagramme courant}
  curMLDiagram: TMLDiagram;

implementation

uses
        Clipbrd, ShellApi, Math,
        UFrmPaletteGenComponents, UMLDiagramDrawing, UMLDiagramReport,
        UCompFSDefineStatus, UDlgAboutBox, UStringsResources,
        UConstConfiguration, UCalcStatDesCondDescRuns, UBatchExecution,
  ULogFile;

const
        MARGE_FENETRE = 2;
        TAILLE_FENETRE_LARGEUR = 1152;//1280
        TAILLE_FENETRE_HAUTEUR = 960;//1024

{$R *.dfm}

{ TFrmMain }

procedure TFrmMain.InsertComponents;
begin
 inherited InsertComponents();
end;

procedure TFrmMain.FormShow(Sender: TObject);
begin
 //new -- 11/11/2007 -- spcifier la taille de la fentre ? -- c'est mieux si c'est configurable...
 if (Screen.WorkAreaWidth < TAILLE_FENETRE_LARGEUR) or (Screen.WorkAreaHeight < TAILLE_FENETRE_HAUTEUR) 
  then self.WindowState:= wsMaximized
  else
   begin
    self.WindowState:= wsNormal;
    self.Height:= Math.Min(TAILLE_FENETRE_HAUTEUR,Screen.WorkAreaHeight) - MARGE_FENETRE;
    self.Width:= Math.Min(TAILLE_FENETRE_LARGEUR,Screen.WorkAreaWidth) - MARGE_FENETRE;
    self.Top:= (Screen.WorkAreaHeight - Self.Height) div 2;
    self.Left:= (Screen.WorkAreaWidth - Self.Width) div 2;
   end;
 //insrer la palette de composants
 self.InsertMLCompPalette();
 self.DeactivateMenusActionDiagram();
 //est-on dans le schma d'excution batch sous EXCEL ?
 if (detectBatchExecution() = bmeExcel)
  then
   begin
    //new -- 20/02/2012 -- dans ce cas de figure, la vrification des donnes manquantes est systmatique
    IMPORT_CHECKING_MISSING_VALUES:= 1;
    //suite normale
    self.openDiagram(FILE_DIAGRAM_FROM_EXCEL);
   end;
 //infos dans le fichier log.
 TraceLog.WriteToLogFile(format('[IMPORTATION] Checking Missing Values = %d',[IMPORT_CHECKING_MISSING_VALUES]));
end;

procedure TFrmMain.InsertMLCompPalette;
begin
 //insertion de la palette de composants
 //FrmPaletteComp.Show();
 pnlCompDisplay.AddForm(FrmPaletteComp,TRUE);
end;

procedure TFrmMain.ActNewExecute(Sender: TObject);
var ok: Boolean;
begin
 //vrification
 if assigned(curMLDiagram) then curMLDiagram.Free;
 //branchement sur la fiche principale
 ok:= true;
 curMLDiagram:= TMLDiagram.Create(self,FrmPaletteComp.imglstMLComponents,FrmPaletteComp.imglstMLComponents,ok);
 //si pas de chargement de donnes et prparations idoines effectues correctement
 if not(ok)
  then self.ActCloseExecute(sender)
  //sauvegarde automatique
  else
   begin
    curMLDiagram.SaveToFile();
    self.panelTitleBarDiagram.Caption:= curMLDiagram.Title;
    //self.pnlDiagram.Show;
    self.ActivateMenusActionDiagram();
    curMLDiagram.Modified:= false;
   end;
end;

procedure TFrmMain.ActCloseExecute(Sender: TObject);
var saveBefore: integer;
begin
 //suggested by GongYu - 09/10/2007
 if assigned(curMLDiagram) and (curMLDiagram.Modified)
  then
   begin
    saveBefore:= MessageDlg('Save changes',mtConfirmation,[mbyes,mbNo,mbCancel],0);
    if (saveBefore = idCancel) then EXIT;
    if (saveBefore = idYes) then curMLDiagram.SaveToFile();
   end;
 //suite normale...
 if assigned(curMLDiagram)
  then
   begin
    TRY
    curMLDiagram.Free;//un peu brutal pour l'instant
    FINALLY
    curMLDiagram:= NIL;
    END;
   end;
 //menus appropris
 self.DeactivateMenusActionDiagram();
 //info
 self.panelTitleBarDiagram.Caption:= str_dgm_data_mining_diagram_empty;
 //self.pnlDiagram.Hide;
end;

procedure TFrmMain.ActExitExecute(Sender: TObject);
begin
 self.Close();
end;

procedure TFrmMain.ActSaveAsExecute(Sender: TObject);
begin
 if assigned(curMLDiagram)
  then
   begin
    if SaveDlgDiagram.Execute
     then curMLDiagram.SaveToFile(SaveDlgDiagram.FileName);
   end;
end;

procedure TFrmMain.ActOpenExecute(Sender: TObject);
begin
 if OpenDlgDiagram.Execute
  then
   begin
    self.ActCloseExecute(sender);
    self.openDiagram(OpenDlgDiagram.FileName);
   end;
end;

procedure TFrmMain.ActSaveExecute(Sender: TObject);
begin
 if assigned(curMLDiagram)
  then curMLDiagram.SaveToFile();
end;

procedure TFrmMain.ActExecuteExecute(Sender: TObject);
begin
 if assigned(curMLDiagram)
  then curMLDiagram.FullExecute();
end;

procedure TFrmMain.DeactivateMenusActionDiagram;
begin
 self.ActSave.Enabled:= FALSE;
 self.ActSaveAs.Enabled:= FALSE;
 menuDiagram.Enabled:= FALSE;
 self.actInsertDefStatus.Enabled:= FALSE;
 self.ActDeleteComponent.Enabled:= FALSE;
 self.ActClose.Enabled:= FALSE; 
 //a contrario les autres menus sont actifs
 self.ActNew.Enabled:= TRUE;
 self.ActOpen.Enabled:= TRUE;
end;

procedure TFrmMain.ActivateMenusActionDiagram;
begin
 self.ActSave.Enabled:= TRUE;
 self.ActSaveAs.Enabled:= TRUE;
 menuDiagram.Enabled:= TRUE;
 self.actInsertDefStatus.Enabled:= TRUE;
 self.ActDeleteComponent.Enabled:= TRUE;
 self.ActClose.Enabled:= TRUE;
 //a contrario les autres menus sont inactifs
 self.ActNew.Enabled:= FALSE;
 self.ActOpen.Enabled:= FALSE;
 //le premier composant doit tre slectionn
 curMLDiagram.TreeView.Select(curMLDiagram.TreeView.Items.GetFirstNode());
end;

procedure TFrmMain.ActCopyExecute(Sender: TObject);
var mld: TMLDgmDrawing;
begin
 if assigned(curMLDiagram)
  then
   begin
    mld:= TMLDgmDrawing.Create(curMLDiagram);
    mld.Drawing(Clipboard);
    mld.Free;
   end;
end;

procedure TFrmMain.ActReportExecute(Sender: TObject);
var report: TMLDgmReport;
begin
 if assigned(curMLDiagram)
  then
   begin
    //initialisation
    SaveDlgHTMLReport.FileName:= curMLDiagram.HTMLFileName;
    //rcupration et excution
    if SaveDlgHTMLReport.Execute
     then
      begin
       curMLDiagram.HTMLFileName:= SaveDlgHTMLReport.FileName;//!!! trs important !!!
       report:= TMLDgmReport.create(curMlDiagram);
       report.WriteReport();
       report.Free;
       //lancer le navigateur html - c'est plus simple que createprocess
       ShellExecute(0,'open',PANSICHAR(SaveDlgHTMLReport.FileName),nil,nil,SW_SHOWMAXIMIZED);
      end;
   end;
end;

procedure TFrmMain.actInsertDefStatusExecute(Sender: TObject);
var curComp: TMLComponent;
    newComp: TMLComponent;
begin
 if assigned(curMLDiagram)
  then
   begin
    //rcuprer le composant courant
    if assigned(curMLDiagram.TreeView.Selected)
     then
      begin
       curComp:= TMLComponent(curMLDiagram.TreeView.Selected.Data);
       //ajouter  la suite une dfinition des attributs
       newComp:= TMLCompFSDefStatus.CreateMLComponent(curMLDiagram,FrmPaletteComp.GenCompDefStatus,curComp);
       curMLDiagram.TreeView.Selected.Expand(true);
       //montrer automatiquement la bote de paramtrage
       newComp.ShowDlgParameters();
      end;
   end;
end;

procedure TFrmMain.ActDeleteComponentExecute(Sender: TObject);
begin
 curMLDiagram.DelCurMLComponent();
end;

procedure TFrmMain.ActHelpAboutExecute(Sender: TObject);
begin
 with TDlgAboutBox.Create(self) do
  ShowModal();
end;

procedure TFrmMain.ActHelpIndexExecute(Sender: TObject);
begin
 ShellExecute(0,'open',PANSICHAR('http://eric.univ-lyon2.fr/~ricco/tanagra/index.html'),nil,nil,SW_SHOWMAXIMIZED);
end;

procedure TFrmMain.InsertTexts;
begin
 inherited InsertTexts();

 //dnomination du logiciel
 self.Caption:= TANAGRA_NAME_CURRENT_VERSION;
 Application.Title:= TANAGRA_NAME_CURRENT_VERSION;

 //nom initial du diagramme
 self.panelTitleBarDiagram.Caption:= str_dgm_data_mining_diagram_empty;

 {les actions et menus}

 //fichier
 self.menuFile.Caption:= str_frm_menu_file;
 self.ActNew.Caption:= str_frm_menu_new+'...';
 self.ActOpen.Caption:= str_frm_menu_open+'...';
 self.ActSave.Caption:= str_frm_menu_save;
 self.ActSaveAs.Caption:= str_frm_menu_save_as+'...';
 self.ActClose.Caption:= str_frm_menu_close;
 self.ActExit.Caption:= str_frm_menu_exit;

 //diagramme
 self.menuDiagram.Caption:= str_frm_menu_diagram;
 self.menuFullExecute.Caption:= str_frm_menu_execute;
 self.ActExecute.Caption:= str_frm_menu_execute;
 self.ActCopy.Caption:= str_frm_menu_copy;
 self.ActReport.Caption:= str_frm_menu_report;
 self.ActDeleteComponent.Caption:= str_frm_menu_delete_component;

 //fentre
 self.menuWindow.Caption:= str_frm_menu_window;
 self.actWindowCascade.Caption:= str_frm_menu_window_cascade;
 self.actWindowTileVertical.Caption:= str_frm_menu_window_tile_vertical;
 self.actWindowTileHorizontal.Caption:= str_frm_menu_window_tile_horizontal;

 //aide
 self.MenuHelp.Caption:= str_frm_menu_help;
 self.ActHelpIndex.Caption:= str_frm_menu_help_index;
 self.ActHelpAbout.Caption:= str_frm_menu_help_about+'...';

end;

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if assigned(curMLDiagram)
  then
   begin
    //fermeture irrmdiable  ce stade, plus besoin de poser la question de la sauvegarde ou pas
    curMLDiagram.Modified:= false;
    //lancer la fermeture
    self.ActCloseExecute(sender);
   end;
end;

procedure TFrmMain.actSaveSubdiagramExecute(Sender: TObject);
begin
 //s'il y a un diagramme et qu'on n'essaie pas de sauver  partir de la racine du diagramme
 if assigned(curMLDiagram) and (curMLDiagram.RootMLComp <> curMLDiagram.getCurComponent())
  then
   begin
    if (curMLDiagram.getCurComponent() <> nil)
     then
      begin
       if (self.saveSubdiagram.Execute() = true)
        then curMLDiagram.saveSubDiagram(curMLDiagram.getCurComponent(),self.saveSubdiagram.FileName);
      end
     else MessageDlg('Select a node of the diagram before saving',mtError,[mbOk],0);
   end
  else MessageDlg('Cannot save subdiagram from the root node'+#13#10+'Use File/Save instead',mtError,[mbOk],0);
end;

procedure TFrmMain.actLoadSubdiagramExecute(Sender: TObject);
begin
 if assigned(curMLDiagram)
  then
   begin
    if assigned(curMLDiagram.getCurComponent())
     then
      begin
       if (self.openDlgSubdiagram.Execute() = true)
        then
         begin
          curMLDiagram.loadSubDiagram(curMLDiagram.getCurComponent(),self.openDlgSubdiagram.FileName);
          curMLDiagram.TreeView.FullExpand();
         end;
      end
     else MessageDlg('Select a node of the diagram before loading',mtError,[mbOk],0);
   end;
end;

procedure TFrmMain.openDiagram(fileName: TFileName);
begin
 TRY
 screen.Cursor:= crHourGlass;
 curMLDiagram:= TMLDiagram.CreateFromFile(self,frmPaletteComp.imglstMLComponents,fileName);
 //info
 self.panelTitleBarDiagram.Caption:= curMLDiagram.Title;
 //self.pnlDiagram.Show;
 self.ActivateMenusActionDiagram();
 FINALLY
 screen.Cursor:= crDefault;
 END;
end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var saveBefore: integer;
begin
 CanClose:= true;
 //suggested by GongYu - 09/10/2007
 if assigned(curMLDiagram)
  then
   begin
    //modif en cours ?
    if (curMLDiagram.Modified = true)
     then
      begin
       saveBefore:= MessageDlg('Save changes',mtConfirmation,[mbyes,mbNo,mbCancel],0);
       if (saveBefore = idYes) then curMLDiagram.SaveToFile();
       CanClose:= (saveBefore = idYes) or (saveBefore = idNo);
      end;
   end;
end;

initialization
 curMLDiagram:= NIL;
end.
